/* page-view.c generated by valac 0.40.8, the Vala compiler
 * generated from page-view.vala, do not modify */

/*
 * Copyright (C) 2009-2015 Canonical Ltd.
 * Author: Robert Ancell <robert.ancell@canonical.com>
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */


#include <glib.h>
#include <glib-object.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <string.h>
#include <stdlib.h>
#include <cairo.h>
#include <gobject/gvaluecollector.h>


#define TYPE_CROP_LOCATION (crop_location_get_type ())

#define TYPE_PAGE_VIEW (page_view_get_type ())
#define PAGE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE_VIEW, PageView))
#define PAGE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE_VIEW, PageViewClass))
#define IS_PAGE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE_VIEW))
#define IS_PAGE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE_VIEW))
#define PAGE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE_VIEW, PageViewClass))

typedef struct _PageView PageView;
typedef struct _PageViewClass PageViewClass;
typedef struct _PageViewPrivate PageViewPrivate;

#define TYPE_PAGE (page_get_type ())
#define PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE, Page))
#define PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE, PageClass))
#define IS_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE))
#define IS_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE))
#define PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE, PageClass))

typedef struct _Page Page;
typedef struct _PageClass PageClass;

#define TYPE_SCAN_DIRECTION (scan_direction_get_type ())
#define _page_unref0(var) ((var == NULL) ? NULL : (var = (page_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecPageView ParamSpecPageView;
enum  {
	PAGE_VIEW_SIZE_CHANGED_SIGNAL,
	PAGE_VIEW_CHANGED_SIGNAL,
	PAGE_VIEW_NUM_SIGNALS
};
static guint page_view_signals[PAGE_VIEW_NUM_SIGNALS] = {0};

typedef enum  {
	CROP_LOCATION_NONE = 0,
	CROP_LOCATION_MIDDLE,
	CROP_LOCATION_TOP,
	CROP_LOCATION_BOTTOM,
	CROP_LOCATION_LEFT,
	CROP_LOCATION_RIGHT,
	CROP_LOCATION_TOP_LEFT,
	CROP_LOCATION_TOP_RIGHT,
	CROP_LOCATION_BOTTOM_LEFT,
	CROP_LOCATION_BOTTOM_RIGHT
} CropLocation;

struct _PageView {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PageViewPrivate * priv;
};

struct _PageViewClass {
	GTypeClass parent_class;
	void (*finalize) (PageView *self);
};

typedef enum  {
	SCAN_DIRECTION_TOP_TO_BOTTOM,
	SCAN_DIRECTION_LEFT_TO_RIGHT,
	SCAN_DIRECTION_BOTTOM_TO_TOP,
	SCAN_DIRECTION_RIGHT_TO_LEFT
} ScanDirection;

struct _PageViewPrivate {
	Page* _page;
	GdkPixbuf* image;
	gboolean selected_;
	gint border_width;
	gboolean update_image;
	ScanDirection scan_direction;
	gint scan_line;
	gint width_;
	gint height_;
	gint _x_offset;
	gint _y_offset;
	CropLocation crop_location;
	gdouble selected_crop_px;
	gdouble selected_crop_py;
	gint selected_crop_x;
	gint selected_crop_y;
	gint selected_crop_w;
	gint selected_crop_h;
	GdkCursorType _cursor;
	gint animate_n_segments;
	gint animate_segment;
	guint animate_timeout;
};

struct _ParamSpecPageView {
	GParamSpec parent_instance;
};


static gpointer page_view_parent_class = NULL;

GType crop_location_get_type (void) G_GNUC_CONST;
gpointer page_view_ref (gpointer instance);
void page_view_unref (gpointer instance);
GParamSpec* param_spec_page_view (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
void value_set_page_view (GValue* value,
                          gpointer v_object);
void value_take_page_view (GValue* value,
                           gpointer v_object);
gpointer value_get_page_view (const GValue* value);
GType page_view_get_type (void) G_GNUC_CONST;
gpointer page_ref (gpointer instance);
void page_unref (gpointer instance);
GParamSpec* param_spec_page (const gchar* name,
                             const gchar* nick,
                             const gchar* blurb,
                             GType object_type,
                             GParamFlags flags);
void value_set_page (GValue* value,
                     gpointer v_object);
void value_take_page (GValue* value,
                      gpointer v_object);
gpointer value_get_page (const GValue* value);
GType page_get_type (void) G_GNUC_CONST;
GType scan_direction_get_type (void) G_GNUC_CONST;
#define PAGE_VIEW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PAGE_VIEW, PageViewPrivate))
Page* page_view_get_page (PageView* self);
static void page_view_page_pixels_changed_cb (PageView* self,
                                       Page* p);
static void _page_view_page_pixels_changed_cb_page_pixels_changed (Page* _sender,
                                                            gpointer self);
static void page_view_page_size_changed_cb (PageView* self,
                                     Page* p);
static void _page_view_page_size_changed_cb_page_size_changed (Page* _sender,
                                                        gpointer self);
static void page_view_page_overlay_changed_cb (PageView* self,
                                        Page* p);
static void _page_view_page_overlay_changed_cb_page_crop_changed (Page* _sender,
                                                           gpointer self);
static void _page_view_page_overlay_changed_cb_page_scan_line_changed (Page* _sender,
                                                                gpointer self);
static void page_view_scan_direction_changed_cb (PageView* self,
                                          Page* p);
static void _page_view_scan_direction_changed_cb_page_scan_direction_changed (Page* _sender,
                                                                       gpointer self);
PageView* page_view_new (Page* page);
PageView* page_view_construct (GType object_type,
                               Page* page);
static void page_view_set_page (PageView* self,
                         Page* value);
static guchar page_view_get_sample (PageView* self,
                             guchar* pixels,
                             int pixels_length1,
                             gint offset,
                             gint x,
                             gint depth,
                             gint sample);
static void page_view_get_pixel (PageView* self,
                          Page* page,
                          gint x,
                          gint y,
                          guchar* pixel,
                          int pixel_length1);
ScanDirection page_get_scan_direction (Page* self);
gint page_get_scan_width (Page* self);
gint page_get_scan_height (Page* self);
gint page_get_depth (Page* self);
gint page_get_n_channels (Page* self);
guchar* page_get_pixels (Page* self,
                         int* result_length1);
gint page_get_rowstride (Page* self);
static void page_view_set_pixel (PageView* self,
                          Page* page,
                          gdouble l,
                          gdouble r,
                          gdouble t,
                          gdouble b,
                          guchar* output,
                          int output_length1,
                          gint offset);
static void page_view_update_preview (PageView* self,
                               Page* page,
                               GdkPixbuf* * output_image,
                               gint output_width,
                               gint output_height,
                               ScanDirection scan_direction,
                               gint old_scan_line,
                               gint scan_line);
gint page_get_width (Page* self);
gint page_get_height (Page* self);
gboolean page_get_has_data (Page* self);
static gint page_view_get_preview_width (PageView* self);
static gint page_view_get_preview_height (PageView* self);
static void page_view_update_page_view (PageView* self);
gint page_get_scan_line (Page* self);
static gint page_view_page_to_screen_x (PageView* self,
                                 gint x);
static gint page_view_page_to_screen_y (PageView* self,
                                 gint y);
static gint page_view_screen_to_page_x (PageView* self,
                                 gint x);
static gint page_view_screen_to_page_y (PageView* self,
                                 gint y);
static CropLocation page_view_get_crop_location (PageView* self,
                                          gint x,
                                          gint y);
gboolean page_get_has_crop (Page* self);
gint page_get_crop_x (Page* self);
gint page_get_crop_y (Page* self);
gint page_get_crop_width (Page* self);
gint page_get_crop_height (Page* self);
const gchar* page_get_crop_name (Page* self);
void page_view_button_press (PageView* self,
                             gint x,
                             gint y);
void page_view_motion (PageView* self,
                       gint x,
                       gint y);
static void page_view_set_cursor (PageView* self,
                           GdkCursorType value);
void page_move_crop (Page* self,
                     gint x,
                     gint y);
void page_set_custom_crop (Page* self,
                           gint width,
                           gint height);
void page_view_button_release (PageView* self,
                               gint x,
                               gint y);
static gboolean page_view_animation_cb (PageView* self);
static void page_view_update_animation (PageView* self);
gboolean page_get_is_scanning (Page* self);
static gboolean _page_view_animation_cb_gsource_func (gpointer self);
void page_view_render (PageView* self,
                       cairo_t* context);
gint page_view_get_x_offset (PageView* self);
gint page_view_get_y_offset (PageView* self);
gboolean page_view_get_selected (PageView* self);
void page_view_set_selected (PageView* self,
                             gboolean value);
void page_view_set_x_offset (PageView* self,
                             gint value);
void page_view_set_y_offset (PageView* self,
                             gint value);
GdkCursorType page_view_get_cursor (PageView* self);
gint page_view_get_width (PageView* self);
void page_view_set_width (PageView* self,
                          gint value);
gint page_view_get_height (PageView* self);
void page_view_set_height (PageView* self,
                           gint value);
static void page_view_finalize (PageView * obj);


GType
crop_location_get_type (void)
{
	static volatile gsize crop_location_type_id__volatile = 0;
	if (g_once_init_enter (&crop_location_type_id__volatile)) {
		static const GEnumValue values[] = {{CROP_LOCATION_NONE, "CROP_LOCATION_NONE", "none"}, {CROP_LOCATION_MIDDLE, "CROP_LOCATION_MIDDLE", "middle"}, {CROP_LOCATION_TOP, "CROP_LOCATION_TOP", "top"}, {CROP_LOCATION_BOTTOM, "CROP_LOCATION_BOTTOM", "bottom"}, {CROP_LOCATION_LEFT, "CROP_LOCATION_LEFT", "left"}, {CROP_LOCATION_RIGHT, "CROP_LOCATION_RIGHT", "right"}, {CROP_LOCATION_TOP_LEFT, "CROP_LOCATION_TOP_LEFT", "top-left"}, {CROP_LOCATION_TOP_RIGHT, "CROP_LOCATION_TOP_RIGHT", "top-right"}, {CROP_LOCATION_BOTTOM_LEFT, "CROP_LOCATION_BOTTOM_LEFT", "bottom-left"}, {CROP_LOCATION_BOTTOM_RIGHT, "CROP_LOCATION_BOTTOM_RIGHT", "bottom-right"}, {0, NULL, NULL}};
		GType crop_location_type_id;
		crop_location_type_id = g_enum_register_static ("CropLocation", values);
		g_once_init_leave (&crop_location_type_id__volatile, crop_location_type_id);
	}
	return crop_location_type_id__volatile;
}


static void
_page_view_page_pixels_changed_cb_page_pixels_changed (Page* _sender,
                                                       gpointer self)
{
	page_view_page_pixels_changed_cb ((PageView*) self, _sender);
}


static void
_page_view_page_size_changed_cb_page_size_changed (Page* _sender,
                                                   gpointer self)
{
	page_view_page_size_changed_cb ((PageView*) self, _sender);
}


static void
_page_view_page_overlay_changed_cb_page_crop_changed (Page* _sender,
                                                      gpointer self)
{
	page_view_page_overlay_changed_cb ((PageView*) self, _sender);
}


static void
_page_view_page_overlay_changed_cb_page_scan_line_changed (Page* _sender,
                                                           gpointer self)
{
	page_view_page_overlay_changed_cb ((PageView*) self, _sender);
}


static void
_page_view_scan_direction_changed_cb_page_scan_direction_changed (Page* _sender,
                                                                  gpointer self)
{
	page_view_scan_direction_changed_cb ((PageView*) self, _sender);
}


PageView*
page_view_construct (GType object_type,
                     Page* page)
{
	PageView* self = NULL;
	g_return_val_if_fail (page != NULL, NULL);
	self = (PageView*) g_type_create_instance (object_type);
	page_view_set_page (self, page);
	g_signal_connect (page, "pixels-changed", (GCallback) _page_view_page_pixels_changed_cb_page_pixels_changed, self);
	g_signal_connect (page, "size-changed", (GCallback) _page_view_page_size_changed_cb_page_size_changed, self);
	g_signal_connect (page, "crop-changed", (GCallback) _page_view_page_overlay_changed_cb_page_crop_changed, self);
	g_signal_connect (page, "scan-line-changed", (GCallback) _page_view_page_overlay_changed_cb_page_scan_line_changed, self);
	g_signal_connect (page, "scan-direction-changed", (GCallback) _page_view_scan_direction_changed_cb_page_scan_direction_changed, self);
	return self;
}


PageView*
page_view_new (Page* page)
{
	return page_view_construct (TYPE_PAGE_VIEW, page);
}


static guchar
page_view_get_sample (PageView* self,
                      guchar* pixels,
                      int pixels_length1,
                      gint offset,
                      gint x,
                      gint depth,
                      gint sample)
{
	guchar result = '\0';
	g_return_val_if_fail (self != NULL, '\0');
	result = (guchar) 0xFF;
	return result;
}


static void
page_view_get_pixel (PageView* self,
                     Page* page,
                     gint x,
                     gint y,
                     guchar* pixel,
                     int pixel_length1)
{
	ScanDirection _tmp0_;
	ScanDirection _tmp1_;
	gint depth = 0;
	gint _tmp12_;
	gint _tmp13_;
	gint n_channels = 0;
	gint _tmp14_;
	gint _tmp15_;
	guchar* pixels = NULL;
	gint _tmp16_;
	guchar* _tmp17_;
	gint pixels_length1;
	gint _pixels_size_;
	gint offset = 0;
	gint _tmp18_;
	gint _tmp19_;
	gboolean _tmp20_ = FALSE;
	gint _tmp21_;
	guchar* _tmp71_;
	gint _tmp71__length1;
	gint _tmp72_;
	gint _tmp73_;
	gint _tmp74_;
	guchar _tmp75_;
	guchar* _tmp76_;
	gint _tmp76__length1;
	gint _tmp77_;
	gint _tmp78_;
	gint _tmp79_;
	guchar _tmp80_;
	guchar* _tmp81_;
	gint _tmp81__length1;
	gint _tmp82_;
	gint _tmp83_;
	gint _tmp84_;
	guchar _tmp85_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (page != NULL);
	_tmp0_ = page_get_scan_direction (page);
	_tmp1_ = _tmp0_;
	switch (_tmp1_) {
		case SCAN_DIRECTION_TOP_TO_BOTTOM:
		{
			break;
		}
		case SCAN_DIRECTION_BOTTOM_TO_TOP:
		{
			gint _tmp2_;
			gint _tmp3_;
			gint _tmp4_;
			gint _tmp5_;
			_tmp2_ = page_get_scan_width (page);
			_tmp3_ = _tmp2_;
			x = (_tmp3_ - x) - 1;
			_tmp4_ = page_get_scan_height (page);
			_tmp5_ = _tmp4_;
			y = (_tmp5_ - y) - 1;
			break;
		}
		case SCAN_DIRECTION_LEFT_TO_RIGHT:
		{
			gint t = 0;
			gint _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			t = x;
			_tmp6_ = page_get_scan_width (page);
			_tmp7_ = _tmp6_;
			x = (_tmp7_ - y) - 1;
			_tmp8_ = t;
			y = _tmp8_;
			break;
		}
		case SCAN_DIRECTION_RIGHT_TO_LEFT:
		{
			gint t = 0;
			gint _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
			t = x;
			x = y;
			_tmp9_ = page_get_scan_height (page);
			_tmp10_ = _tmp9_;
			_tmp11_ = t;
			y = (_tmp10_ - _tmp11_) - 1;
			break;
		}
		default:
		break;
	}
	_tmp12_ = page_get_depth (page);
	_tmp13_ = _tmp12_;
	depth = _tmp13_;
	_tmp14_ = page_get_n_channels (page);
	_tmp15_ = _tmp14_;
	n_channels = _tmp15_;
	_tmp17_ = page_get_pixels (page, &_tmp16_);
	pixels = _tmp17_;
	pixels_length1 = _tmp16_;
	_pixels_size_ = pixels_length1;
	_tmp18_ = page_get_rowstride (page);
	_tmp19_ = _tmp18_;
	offset = _tmp19_ * y;
	_tmp21_ = depth;
	if (_tmp21_ == 8) {
		gint _tmp22_;
		_tmp22_ = n_channels;
		_tmp20_ = _tmp22_ == 3;
	} else {
		_tmp20_ = FALSE;
	}
	if (_tmp20_) {
		gint o = 0;
		gint _tmp23_;
		gint _tmp24_;
		guchar* _tmp25_;
		gint _tmp25__length1;
		gint _tmp26_;
		guchar _tmp27_;
		guchar _tmp28_;
		guchar* _tmp29_;
		gint _tmp29__length1;
		gint _tmp30_;
		guchar _tmp31_;
		guchar _tmp32_;
		guchar* _tmp33_;
		gint _tmp33__length1;
		gint _tmp34_;
		guchar _tmp35_;
		guchar _tmp36_;
		_tmp23_ = offset;
		_tmp24_ = n_channels;
		o = _tmp23_ + (x * _tmp24_);
		_tmp25_ = pixels;
		_tmp25__length1 = pixels_length1;
		_tmp26_ = o;
		_tmp27_ = _tmp25_[_tmp26_];
		pixel[0] = _tmp27_;
		_tmp28_ = pixel[0];
		_tmp29_ = pixels;
		_tmp29__length1 = pixels_length1;
		_tmp30_ = o;
		_tmp31_ = _tmp29_[_tmp30_ + 1];
		pixel[1] = _tmp31_;
		_tmp32_ = pixel[1];
		_tmp33_ = pixels;
		_tmp33__length1 = pixels_length1;
		_tmp34_ = o;
		_tmp35_ = _tmp33_[_tmp34_ + 2];
		pixel[2] = _tmp35_;
		_tmp36_ = pixel[2];
		return;
	} else {
		gboolean _tmp37_ = FALSE;
		gint _tmp38_;
		_tmp38_ = depth;
		if (_tmp38_ == 8) {
			gint _tmp39_;
			_tmp39_ = n_channels;
			_tmp37_ = _tmp39_ == 1;
		} else {
			_tmp37_ = FALSE;
		}
		if (_tmp37_) {
			guchar* _tmp40_;
			gint _tmp40__length1;
			gint _tmp41_;
			guchar _tmp42_;
			guchar _tmp43_;
			guchar _tmp44_;
			guchar _tmp45_;
			_tmp40_ = pixels;
			_tmp40__length1 = pixels_length1;
			_tmp41_ = offset;
			_tmp42_ = _tmp40_[_tmp41_ + x];
			pixel[2] = _tmp42_;
			_tmp43_ = pixel[2];
			pixel[1] = _tmp43_;
			_tmp44_ = pixel[1];
			pixel[0] = _tmp44_;
			_tmp45_ = pixel[0];
			return;
		} else {
			gboolean _tmp46_ = FALSE;
			gint _tmp47_;
			_tmp47_ = depth;
			if (_tmp47_ == 1) {
				gint _tmp48_;
				_tmp48_ = n_channels;
				_tmp46_ = _tmp48_ == 1;
			} else {
				_tmp46_ = FALSE;
			}
			if (_tmp46_) {
				gint o = 0;
				gint _tmp49_;
				gint _tmp50_ = 0;
				guchar* _tmp51_;
				gint _tmp51__length1;
				gint _tmp52_;
				guchar _tmp53_;
				guchar _tmp54_;
				guchar _tmp55_;
				guchar _tmp56_;
				_tmp49_ = offset;
				o = _tmp49_ + (x / 8);
				_tmp51_ = pixels;
				_tmp51__length1 = pixels_length1;
				_tmp52_ = o;
				_tmp53_ = _tmp51_[_tmp52_];
				if (((gint) (_tmp53_ & (0x80 >> (x % 8)))) != 0) {
					_tmp50_ = 0x00;
				} else {
					_tmp50_ = 0xFF;
				}
				pixel[2] = (guchar) _tmp50_;
				_tmp54_ = pixel[2];
				pixel[1] = _tmp54_;
				_tmp55_ = pixel[1];
				pixel[0] = _tmp55_;
				_tmp56_ = pixel[0];
				return;
			} else {
				gboolean _tmp57_ = FALSE;
				gint _tmp58_;
				_tmp58_ = depth;
				if (_tmp58_ == 2) {
					gint _tmp59_;
					_tmp59_ = n_channels;
					_tmp57_ = _tmp59_ == 1;
				} else {
					_tmp57_ = FALSE;
				}
				if (_tmp57_) {
					gint block_shift[4] = {0};
					gint _tmp60_[4] = {0};
					gint o = 0;
					gint _tmp61_;
					gint sample = 0;
					guchar* _tmp62_;
					gint _tmp62__length1;
					gint _tmp63_;
					guchar _tmp64_;
					gint _tmp65_;
					gint _tmp66_;
					gint _tmp67_;
					guchar _tmp68_;
					guchar _tmp69_;
					guchar _tmp70_;
					_tmp60_[0] = 6;
					_tmp60_[1] = 4;
					_tmp60_[2] = 2;
					_tmp60_[3] = 0;
					memcpy (block_shift, _tmp60_, 4 * sizeof (gint));
					_tmp61_ = offset;
					o = _tmp61_ + (x / 4);
					_tmp62_ = pixels;
					_tmp62__length1 = pixels_length1;
					_tmp63_ = o;
					_tmp64_ = _tmp62_[_tmp63_];
					_tmp65_ = block_shift[x % 4];
					sample = (_tmp64_ >> _tmp65_) & 0x3;
					_tmp66_ = sample;
					sample = (_tmp66_ * 255) / 3;
					_tmp67_ = sample;
					pixel[2] = (guchar) _tmp67_;
					_tmp68_ = pixel[2];
					pixel[1] = _tmp68_;
					_tmp69_ = pixel[1];
					pixel[0] = _tmp69_;
					_tmp70_ = pixel[0];
					return;
				}
			}
		}
	}
	_tmp71_ = pixels;
	_tmp71__length1 = pixels_length1;
	_tmp72_ = offset;
	_tmp73_ = depth;
	_tmp74_ = n_channels;
	pixel[0] = page_view_get_sample (self, _tmp71_, _tmp71__length1, _tmp72_, x, _tmp73_, x * _tmp74_);
	_tmp75_ = pixel[0];
	_tmp76_ = pixels;
	_tmp76__length1 = pixels_length1;
	_tmp77_ = offset;
	_tmp78_ = depth;
	_tmp79_ = n_channels;
	pixel[1] = page_view_get_sample (self, _tmp76_, _tmp76__length1, _tmp77_, x, _tmp78_, (x * _tmp79_) + 1);
	_tmp80_ = pixel[1];
	_tmp81_ = pixels;
	_tmp81__length1 = pixels_length1;
	_tmp82_ = offset;
	_tmp83_ = depth;
	_tmp84_ = n_channels;
	pixel[2] = page_view_get_sample (self, _tmp81_, _tmp81__length1, _tmp82_, x, _tmp83_, (x * _tmp84_) + 2);
	_tmp85_ = pixel[2];
}


static void
page_view_set_pixel (PageView* self,
                     Page* page,
                     gdouble l,
                     gdouble r,
                     gdouble t,
                     gdouble b,
                     guchar* output,
                     int output_length1,
                     gint offset)
{
	gint L = 0;
	gint _tmp0_;
	gint R = 0;
	gint T = 0;
	gint _tmp2_;
	gint B = 0;
	gdouble red = 0.0;
	gdouble green = 0.0;
	gdouble blue = 0.0;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp171_ = FALSE;
	gint _tmp172_;
	gboolean _tmp188_ = FALSE;
	gint _tmp189_;
	gboolean _tmp205_ = FALSE;
	gint _tmp206_;
	gboolean _tmp222_ = FALSE;
	gint _tmp223_;
	gdouble scale = 0.0;
	gdouble _tmp239_;
	gdouble _tmp240_;
	guchar _tmp241_;
	gdouble _tmp242_;
	gdouble _tmp243_;
	guchar _tmp244_;
	gdouble _tmp245_;
	gdouble _tmp246_;
	guchar _tmp247_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (page != NULL);
	L = (gint) l;
	_tmp0_ = L;
	if (((gdouble) _tmp0_) != l) {
		gint _tmp1_;
		_tmp1_ = L;
		L = _tmp1_ + 1;
	}
	R = (gint) r;
	T = (gint) t;
	_tmp2_ = T;
	if (((gdouble) _tmp2_) != t) {
		gint _tmp3_;
		_tmp3_ = T;
		T = _tmp3_ + 1;
	}
	B = (gint) b;
	red = 0.0;
	green = 0.0;
	blue = 0.0;
	if ((r - l) <= 1.0) {
		_tmp5_ = ((gint) r) == ((gint) l);
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		_tmp4_ = TRUE;
	} else {
		gboolean _tmp6_ = FALSE;
		if ((b - t) <= 1.0) {
			_tmp6_ = ((gint) b) == ((gint) t);
		} else {
			_tmp6_ = FALSE;
		}
		_tmp4_ = _tmp6_;
	}
	if (_tmp4_) {
		gboolean _tmp7_ = FALSE;
		gint _tmp14_;
		gint _tmp15_;
		gdouble scale = 0.0;
		gdouble _tmp86_;
		gdouble _tmp87_;
		guchar _tmp88_;
		gdouble _tmp89_;
		gdouble _tmp90_;
		guchar _tmp91_;
		gdouble _tmp92_;
		gdouble _tmp93_;
		guchar _tmp94_;
		if (((gint) l) == ((gint) r)) {
			_tmp7_ = TRUE;
		} else {
			_tmp7_ = ((gint) t) == ((gint) b);
		}
		if (_tmp7_) {
			guchar p[3] = {0};
			guchar _tmp8_;
			guchar _tmp9_;
			guchar _tmp10_;
			guchar _tmp11_;
			guchar _tmp12_;
			guchar _tmp13_;
			page_view_get_pixel (self, page, (gint) l, (gint) t, p, 3);
			_tmp8_ = p[0];
			output[offset] = _tmp8_;
			_tmp9_ = output[offset];
			_tmp10_ = p[1];
			output[offset + 1] = _tmp10_;
			_tmp11_ = output[offset + 1];
			_tmp12_ = p[2];
			output[offset + 2] = _tmp12_;
			_tmp13_ = output[offset + 2];
			return;
		}
		_tmp14_ = L;
		_tmp15_ = R;
		if (_tmp14_ > _tmp15_) {
			guchar p[3] = {0};
			gint _tmp16_;
			gint _tmp17_;
			gdouble _tmp18_;
			guchar _tmp19_;
			gint _tmp20_;
			gdouble _tmp21_;
			guchar _tmp22_;
			gint _tmp23_;
			gdouble _tmp24_;
			guchar _tmp25_;
			gint _tmp26_;
			gint _tmp40_;
			gint _tmp41_;
			gdouble _tmp42_;
			guchar _tmp43_;
			gint _tmp44_;
			gdouble _tmp45_;
			guchar _tmp46_;
			gint _tmp47_;
			gdouble _tmp48_;
			guchar _tmp49_;
			gint _tmp50_;
			_tmp16_ = R;
			_tmp17_ = T;
			page_view_get_pixel (self, page, _tmp16_, _tmp17_ - 1, p, 3);
			_tmp18_ = red;
			_tmp19_ = p[0];
			_tmp20_ = T;
			red = _tmp18_ + ((_tmp19_ * (r - l)) * (_tmp20_ - t));
			_tmp21_ = green;
			_tmp22_ = p[1];
			_tmp23_ = T;
			green = _tmp21_ + ((_tmp22_ * (r - l)) * (_tmp23_ - t));
			_tmp24_ = blue;
			_tmp25_ = p[2];
			_tmp26_ = T;
			blue = _tmp24_ + ((_tmp25_ * (r - l)) * (_tmp26_ - t));
			{
				gint y = 0;
				gint _tmp27_;
				_tmp27_ = T;
				y = _tmp27_;
				{
					gboolean _tmp28_ = FALSE;
					_tmp28_ = TRUE;
					while (TRUE) {
						gint _tmp30_;
						gint _tmp31_;
						gint _tmp32_;
						gint _tmp33_;
						gdouble _tmp34_;
						guchar _tmp35_;
						gdouble _tmp36_;
						guchar _tmp37_;
						gdouble _tmp38_;
						guchar _tmp39_;
						if (!_tmp28_) {
							gint _tmp29_;
							_tmp29_ = y;
							y = _tmp29_ + 1;
						}
						_tmp28_ = FALSE;
						_tmp30_ = y;
						_tmp31_ = B;
						if (!(_tmp30_ < _tmp31_)) {
							break;
						}
						_tmp32_ = R;
						_tmp33_ = y;
						page_view_get_pixel (self, page, _tmp32_, _tmp33_, p, 3);
						_tmp34_ = red;
						_tmp35_ = p[0];
						red = _tmp34_ + (_tmp35_ * (r - l));
						_tmp36_ = green;
						_tmp37_ = p[1];
						green = _tmp36_ + (_tmp37_ * (r - l));
						_tmp38_ = blue;
						_tmp39_ = p[2];
						blue = _tmp38_ + (_tmp39_ * (r - l));
					}
				}
			}
			_tmp40_ = R;
			_tmp41_ = B;
			page_view_get_pixel (self, page, _tmp40_, _tmp41_, p, 3);
			_tmp42_ = red;
			_tmp43_ = p[0];
			_tmp44_ = B;
			red = _tmp42_ + ((_tmp43_ * (r - l)) * (b - _tmp44_));
			_tmp45_ = green;
			_tmp46_ = p[1];
			_tmp47_ = B;
			green = _tmp45_ + ((_tmp46_ * (r - l)) * (b - _tmp47_));
			_tmp48_ = blue;
			_tmp49_ = p[2];
			_tmp50_ = B;
			blue = _tmp48_ + ((_tmp49_ * (r - l)) * (b - _tmp50_));
		} else {
			guchar p[3] = {0};
			gint _tmp51_;
			gint _tmp52_;
			gdouble _tmp53_;
			guchar _tmp54_;
			gint _tmp55_;
			gdouble _tmp56_;
			guchar _tmp57_;
			gint _tmp58_;
			gdouble _tmp59_;
			guchar _tmp60_;
			gint _tmp61_;
			gint _tmp75_;
			gint _tmp76_;
			gdouble _tmp77_;
			guchar _tmp78_;
			gint _tmp79_;
			gdouble _tmp80_;
			guchar _tmp81_;
			gint _tmp82_;
			gdouble _tmp83_;
			guchar _tmp84_;
			gint _tmp85_;
			_tmp51_ = L;
			_tmp52_ = B;
			page_view_get_pixel (self, page, _tmp51_ - 1, _tmp52_, p, 3);
			_tmp53_ = red;
			_tmp54_ = p[0];
			_tmp55_ = L;
			red = _tmp53_ + ((_tmp54_ * (b - t)) * (_tmp55_ - l));
			_tmp56_ = green;
			_tmp57_ = p[1];
			_tmp58_ = L;
			green = _tmp56_ + ((_tmp57_ * (b - t)) * (_tmp58_ - l));
			_tmp59_ = blue;
			_tmp60_ = p[2];
			_tmp61_ = L;
			blue = _tmp59_ + ((_tmp60_ * (b - t)) * (_tmp61_ - l));
			{
				gint x = 0;
				gint _tmp62_;
				_tmp62_ = L;
				x = _tmp62_;
				{
					gboolean _tmp63_ = FALSE;
					_tmp63_ = TRUE;
					while (TRUE) {
						gint _tmp65_;
						gint _tmp66_;
						gint _tmp67_;
						gint _tmp68_;
						gdouble _tmp69_;
						guchar _tmp70_;
						gdouble _tmp71_;
						guchar _tmp72_;
						gdouble _tmp73_;
						guchar _tmp74_;
						if (!_tmp63_) {
							gint _tmp64_;
							_tmp64_ = x;
							x = _tmp64_ + 1;
						}
						_tmp63_ = FALSE;
						_tmp65_ = x;
						_tmp66_ = R;
						if (!(_tmp65_ < _tmp66_)) {
							break;
						}
						_tmp67_ = x;
						_tmp68_ = B;
						page_view_get_pixel (self, page, _tmp67_, _tmp68_, p, 3);
						_tmp69_ = red;
						_tmp70_ = p[0];
						red = _tmp69_ + (_tmp70_ * (b - t));
						_tmp71_ = green;
						_tmp72_ = p[1];
						green = _tmp71_ + (_tmp72_ * (b - t));
						_tmp73_ = blue;
						_tmp74_ = p[2];
						blue = _tmp73_ + (_tmp74_ * (b - t));
					}
				}
			}
			_tmp75_ = R;
			_tmp76_ = B;
			page_view_get_pixel (self, page, _tmp75_, _tmp76_, p, 3);
			_tmp77_ = red;
			_tmp78_ = p[0];
			_tmp79_ = R;
			red = _tmp77_ + ((_tmp78_ * (b - t)) * (r - _tmp79_));
			_tmp80_ = green;
			_tmp81_ = p[1];
			_tmp82_ = R;
			green = _tmp80_ + ((_tmp81_ * (b - t)) * (r - _tmp82_));
			_tmp83_ = blue;
			_tmp84_ = p[2];
			_tmp85_ = R;
			blue = _tmp83_ + ((_tmp84_ * (b - t)) * (r - _tmp85_));
		}
		scale = 1.0 / ((r - l) * (b - t));
		_tmp86_ = red;
		_tmp87_ = scale;
		output[offset] = (guchar) ((_tmp86_ * _tmp87_) + 0.5);
		_tmp88_ = output[offset];
		_tmp89_ = green;
		_tmp90_ = scale;
		output[offset + 1] = (guchar) ((_tmp89_ * _tmp90_) + 0.5);
		_tmp91_ = output[offset + 1];
		_tmp92_ = blue;
		_tmp93_ = scale;
		output[offset + 2] = (guchar) ((_tmp92_ * _tmp93_) + 0.5);
		_tmp94_ = output[offset + 2];
		return;
	}
	{
		gint x = 0;
		gint _tmp95_;
		_tmp95_ = L;
		x = _tmp95_;
		{
			gboolean _tmp96_ = FALSE;
			_tmp96_ = TRUE;
			while (TRUE) {
				gint _tmp98_;
				gint _tmp99_;
				if (!_tmp96_) {
					gint _tmp97_;
					_tmp97_ = x;
					x = _tmp97_ + 1;
				}
				_tmp96_ = FALSE;
				_tmp98_ = x;
				_tmp99_ = R;
				if (!(_tmp98_ < _tmp99_)) {
					break;
				}
				{
					gint y = 0;
					gint _tmp100_;
					_tmp100_ = T;
					y = _tmp100_;
					{
						gboolean _tmp101_ = FALSE;
						_tmp101_ = TRUE;
						while (TRUE) {
							gint _tmp103_;
							gint _tmp104_;
							guchar p[3] = {0};
							gint _tmp105_;
							gint _tmp106_;
							gdouble _tmp107_;
							guchar _tmp108_;
							gdouble _tmp109_;
							guchar _tmp110_;
							gdouble _tmp111_;
							guchar _tmp112_;
							if (!_tmp101_) {
								gint _tmp102_;
								_tmp102_ = y;
								y = _tmp102_ + 1;
							}
							_tmp101_ = FALSE;
							_tmp103_ = y;
							_tmp104_ = B;
							if (!(_tmp103_ < _tmp104_)) {
								break;
							}
							_tmp105_ = x;
							_tmp106_ = y;
							page_view_get_pixel (self, page, _tmp105_, _tmp106_, p, 3);
							_tmp107_ = red;
							_tmp108_ = p[0];
							red = _tmp107_ + _tmp108_;
							_tmp109_ = green;
							_tmp110_ = p[1];
							green = _tmp109_ + _tmp110_;
							_tmp111_ = blue;
							_tmp112_ = p[2];
							blue = _tmp111_ + _tmp112_;
						}
					}
				}
			}
		}
	}
	{
		gint x = 0;
		gint _tmp113_;
		_tmp113_ = L;
		x = _tmp113_;
		{
			gboolean _tmp114_ = FALSE;
			_tmp114_ = TRUE;
			while (TRUE) {
				gint _tmp116_;
				gint _tmp117_;
				gint _tmp118_;
				gint _tmp130_;
				if (!_tmp114_) {
					gint _tmp115_;
					_tmp115_ = x;
					x = _tmp115_ + 1;
				}
				_tmp114_ = FALSE;
				_tmp116_ = x;
				_tmp117_ = R;
				if (!(_tmp116_ < _tmp117_)) {
					break;
				}
				_tmp118_ = T;
				if (t != ((gdouble) _tmp118_)) {
					guchar p[3] = {0};
					gint _tmp119_;
					gint _tmp120_;
					gdouble _tmp121_;
					guchar _tmp122_;
					gint _tmp123_;
					gdouble _tmp124_;
					guchar _tmp125_;
					gint _tmp126_;
					gdouble _tmp127_;
					guchar _tmp128_;
					gint _tmp129_;
					_tmp119_ = x;
					_tmp120_ = T;
					page_view_get_pixel (self, page, _tmp119_, _tmp120_ - 1, p, 3);
					_tmp121_ = red;
					_tmp122_ = p[0];
					_tmp123_ = T;
					red = _tmp121_ + (_tmp122_ * (_tmp123_ - t));
					_tmp124_ = green;
					_tmp125_ = p[1];
					_tmp126_ = T;
					green = _tmp124_ + (_tmp125_ * (_tmp126_ - t));
					_tmp127_ = blue;
					_tmp128_ = p[2];
					_tmp129_ = T;
					blue = _tmp127_ + (_tmp128_ * (_tmp129_ - t));
				}
				_tmp130_ = B;
				if (b != ((gdouble) _tmp130_)) {
					guchar p[3] = {0};
					gint _tmp131_;
					gint _tmp132_;
					gdouble _tmp133_;
					guchar _tmp134_;
					gint _tmp135_;
					gdouble _tmp136_;
					guchar _tmp137_;
					gint _tmp138_;
					gdouble _tmp139_;
					guchar _tmp140_;
					gint _tmp141_;
					_tmp131_ = x;
					_tmp132_ = B;
					page_view_get_pixel (self, page, _tmp131_, _tmp132_, p, 3);
					_tmp133_ = red;
					_tmp134_ = p[0];
					_tmp135_ = B;
					red = _tmp133_ + (_tmp134_ * (b - _tmp135_));
					_tmp136_ = green;
					_tmp137_ = p[1];
					_tmp138_ = B;
					green = _tmp136_ + (_tmp137_ * (b - _tmp138_));
					_tmp139_ = blue;
					_tmp140_ = p[2];
					_tmp141_ = B;
					blue = _tmp139_ + (_tmp140_ * (b - _tmp141_));
				}
			}
		}
	}
	{
		gint y = 0;
		gint _tmp142_;
		_tmp142_ = T;
		y = _tmp142_;
		{
			gboolean _tmp143_ = FALSE;
			_tmp143_ = TRUE;
			while (TRUE) {
				gint _tmp145_;
				gint _tmp146_;
				gint _tmp147_;
				gint _tmp159_;
				if (!_tmp143_) {
					gint _tmp144_;
					_tmp144_ = y;
					y = _tmp144_ + 1;
				}
				_tmp143_ = FALSE;
				_tmp145_ = y;
				_tmp146_ = B;
				if (!(_tmp145_ < _tmp146_)) {
					break;
				}
				_tmp147_ = L;
				if (l != ((gdouble) _tmp147_)) {
					guchar p[3] = {0};
					gint _tmp148_;
					gint _tmp149_;
					gdouble _tmp150_;
					guchar _tmp151_;
					gint _tmp152_;
					gdouble _tmp153_;
					guchar _tmp154_;
					gint _tmp155_;
					gdouble _tmp156_;
					guchar _tmp157_;
					gint _tmp158_;
					_tmp148_ = L;
					_tmp149_ = y;
					page_view_get_pixel (self, page, _tmp148_ - 1, _tmp149_, p, 3);
					_tmp150_ = red;
					_tmp151_ = p[0];
					_tmp152_ = L;
					red = _tmp150_ + (_tmp151_ * (_tmp152_ - l));
					_tmp153_ = green;
					_tmp154_ = p[1];
					_tmp155_ = L;
					green = _tmp153_ + (_tmp154_ * (_tmp155_ - l));
					_tmp156_ = blue;
					_tmp157_ = p[2];
					_tmp158_ = L;
					blue = _tmp156_ + (_tmp157_ * (_tmp158_ - l));
				}
				_tmp159_ = R;
				if (r != ((gdouble) _tmp159_)) {
					guchar p[3] = {0};
					gint _tmp160_;
					gint _tmp161_;
					gdouble _tmp162_;
					guchar _tmp163_;
					gint _tmp164_;
					gdouble _tmp165_;
					guchar _tmp166_;
					gint _tmp167_;
					gdouble _tmp168_;
					guchar _tmp169_;
					gint _tmp170_;
					_tmp160_ = R;
					_tmp161_ = y;
					page_view_get_pixel (self, page, _tmp160_, _tmp161_, p, 3);
					_tmp162_ = red;
					_tmp163_ = p[0];
					_tmp164_ = R;
					red = _tmp162_ + (_tmp163_ * (r - _tmp164_));
					_tmp165_ = green;
					_tmp166_ = p[1];
					_tmp167_ = R;
					green = _tmp165_ + (_tmp166_ * (r - _tmp167_));
					_tmp168_ = blue;
					_tmp169_ = p[2];
					_tmp170_ = R;
					blue = _tmp168_ + (_tmp169_ * (r - _tmp170_));
				}
			}
		}
	}
	_tmp172_ = L;
	if (l != ((gdouble) _tmp172_)) {
		gint _tmp173_;
		_tmp173_ = T;
		_tmp171_ = t != ((gdouble) _tmp173_);
	} else {
		_tmp171_ = FALSE;
	}
	if (_tmp171_) {
		guchar p[3] = {0};
		gint _tmp174_;
		gint _tmp175_;
		gdouble _tmp176_;
		guchar _tmp177_;
		gint _tmp178_;
		gint _tmp179_;
		gdouble _tmp180_;
		guchar _tmp181_;
		gint _tmp182_;
		gint _tmp183_;
		gdouble _tmp184_;
		guchar _tmp185_;
		gint _tmp186_;
		gint _tmp187_;
		_tmp174_ = L;
		_tmp175_ = T;
		page_view_get_pixel (self, page, _tmp174_ - 1, _tmp175_ - 1, p, 3);
		_tmp176_ = red;
		_tmp177_ = p[0];
		_tmp178_ = L;
		_tmp179_ = T;
		red = _tmp176_ + ((_tmp177_ * (_tmp178_ - l)) * (_tmp179_ - t));
		_tmp180_ = green;
		_tmp181_ = p[1];
		_tmp182_ = L;
		_tmp183_ = T;
		green = _tmp180_ + ((_tmp181_ * (_tmp182_ - l)) * (_tmp183_ - t));
		_tmp184_ = blue;
		_tmp185_ = p[2];
		_tmp186_ = L;
		_tmp187_ = T;
		blue = _tmp184_ + ((_tmp185_ * (_tmp186_ - l)) * (_tmp187_ - t));
	}
	_tmp189_ = R;
	if (r != ((gdouble) _tmp189_)) {
		gint _tmp190_;
		_tmp190_ = T;
		_tmp188_ = t != ((gdouble) _tmp190_);
	} else {
		_tmp188_ = FALSE;
	}
	if (_tmp188_) {
		guchar p[3] = {0};
		gint _tmp191_;
		gint _tmp192_;
		gdouble _tmp193_;
		guchar _tmp194_;
		gint _tmp195_;
		gint _tmp196_;
		gdouble _tmp197_;
		guchar _tmp198_;
		gint _tmp199_;
		gint _tmp200_;
		gdouble _tmp201_;
		guchar _tmp202_;
		gint _tmp203_;
		gint _tmp204_;
		_tmp191_ = R;
		_tmp192_ = T;
		page_view_get_pixel (self, page, _tmp191_, _tmp192_ - 1, p, 3);
		_tmp193_ = red;
		_tmp194_ = p[0];
		_tmp195_ = R;
		_tmp196_ = T;
		red = _tmp193_ + ((_tmp194_ * (r - _tmp195_)) * (_tmp196_ - t));
		_tmp197_ = green;
		_tmp198_ = p[1];
		_tmp199_ = R;
		_tmp200_ = T;
		green = _tmp197_ + ((_tmp198_ * (r - _tmp199_)) * (_tmp200_ - t));
		_tmp201_ = blue;
		_tmp202_ = p[2];
		_tmp203_ = R;
		_tmp204_ = T;
		blue = _tmp201_ + ((_tmp202_ * (r - _tmp203_)) * (_tmp204_ - t));
	}
	_tmp206_ = R;
	if (r != ((gdouble) _tmp206_)) {
		gint _tmp207_;
		_tmp207_ = B;
		_tmp205_ = b != ((gdouble) _tmp207_);
	} else {
		_tmp205_ = FALSE;
	}
	if (_tmp205_) {
		guchar p[3] = {0};
		gint _tmp208_;
		gint _tmp209_;
		gdouble _tmp210_;
		guchar _tmp211_;
		gint _tmp212_;
		gint _tmp213_;
		gdouble _tmp214_;
		guchar _tmp215_;
		gint _tmp216_;
		gint _tmp217_;
		gdouble _tmp218_;
		guchar _tmp219_;
		gint _tmp220_;
		gint _tmp221_;
		_tmp208_ = R;
		_tmp209_ = B;
		page_view_get_pixel (self, page, _tmp208_, _tmp209_, p, 3);
		_tmp210_ = red;
		_tmp211_ = p[0];
		_tmp212_ = R;
		_tmp213_ = B;
		red = _tmp210_ + ((_tmp211_ * (r - _tmp212_)) * (b - _tmp213_));
		_tmp214_ = green;
		_tmp215_ = p[1];
		_tmp216_ = R;
		_tmp217_ = B;
		green = _tmp214_ + ((_tmp215_ * (r - _tmp216_)) * (b - _tmp217_));
		_tmp218_ = blue;
		_tmp219_ = p[2];
		_tmp220_ = R;
		_tmp221_ = B;
		blue = _tmp218_ + ((_tmp219_ * (r - _tmp220_)) * (b - _tmp221_));
	}
	_tmp223_ = L;
	if (l != ((gdouble) _tmp223_)) {
		gint _tmp224_;
		_tmp224_ = B;
		_tmp222_ = b != ((gdouble) _tmp224_);
	} else {
		_tmp222_ = FALSE;
	}
	if (_tmp222_) {
		guchar p[3] = {0};
		gint _tmp225_;
		gint _tmp226_;
		gdouble _tmp227_;
		guchar _tmp228_;
		gint _tmp229_;
		gint _tmp230_;
		gdouble _tmp231_;
		guchar _tmp232_;
		gint _tmp233_;
		gint _tmp234_;
		gdouble _tmp235_;
		guchar _tmp236_;
		gint _tmp237_;
		gint _tmp238_;
		_tmp225_ = L;
		_tmp226_ = B;
		page_view_get_pixel (self, page, _tmp225_ - 1, _tmp226_, p, 3);
		_tmp227_ = red;
		_tmp228_ = p[0];
		_tmp229_ = L;
		_tmp230_ = B;
		red = _tmp227_ + ((_tmp228_ * (_tmp229_ - l)) * (b - _tmp230_));
		_tmp231_ = green;
		_tmp232_ = p[1];
		_tmp233_ = L;
		_tmp234_ = B;
		green = _tmp231_ + ((_tmp232_ * (_tmp233_ - l)) * (b - _tmp234_));
		_tmp235_ = blue;
		_tmp236_ = p[2];
		_tmp237_ = L;
		_tmp238_ = B;
		blue = _tmp235_ + ((_tmp236_ * (_tmp237_ - l)) * (b - _tmp238_));
	}
	scale = 1.0 / ((r - l) * (b - t));
	_tmp239_ = red;
	_tmp240_ = scale;
	output[offset] = (guchar) ((_tmp239_ * _tmp240_) + 0.5);
	_tmp241_ = output[offset];
	_tmp242_ = green;
	_tmp243_ = scale;
	output[offset + 1] = (guchar) ((_tmp242_ * _tmp243_) + 0.5);
	_tmp244_ = output[offset + 1];
	_tmp245_ = blue;
	_tmp246_ = scale;
	output[offset + 2] = (guchar) ((_tmp245_ * _tmp246_) + 0.5);
	_tmp247_ = output[offset + 2];
}


static void
page_view_update_preview (PageView* self,
                          Page* page,
                          GdkPixbuf* * output_image,
                          gint output_width,
                          gint output_height,
                          ScanDirection scan_direction,
                          gint old_scan_line,
                          gint scan_line)
{
	gint input_width = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint input_height = 0;
	gint _tmp2_;
	gint _tmp3_;
	gint L = 0;
	gint R = 0;
	gint T = 0;
	gint B = 0;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gint _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	gint _tmp30_;
	gint _tmp31_;
	guchar* output = NULL;
	guint8* _tmp32_;
	gint output_length1;
	gint _output_size_;
	gint output_rowstride = 0;
	gint _tmp33_;
	gint _tmp34_;
	gint output_n_channels = 0;
	gint _tmp35_;
	gint _tmp36_;
	gboolean _tmp37_;
	gboolean _tmp38_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (page != NULL);
	_tmp0_ = page_get_width (page);
	_tmp1_ = _tmp0_;
	input_width = _tmp1_;
	_tmp2_ = page_get_height (page);
	_tmp3_ = _tmp2_;
	input_height = _tmp3_;
	if ((*output_image) == NULL) {
		_tmp5_ = TRUE;
	} else {
		gint _tmp6_;
		gint _tmp7_;
		_tmp6_ = gdk_pixbuf_get_width (*output_image);
		_tmp7_ = _tmp6_;
		_tmp5_ = _tmp7_ != output_width;
	}
	if (_tmp5_) {
		_tmp4_ = TRUE;
	} else {
		gint _tmp8_;
		gint _tmp9_;
		_tmp8_ = gdk_pixbuf_get_height (*output_image);
		_tmp9_ = _tmp8_;
		_tmp4_ = _tmp9_ != output_height;
	}
	if (_tmp4_) {
		GdkPixbuf* _tmp10_;
		_tmp10_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, FALSE, 8, output_width, output_height);
		_g_object_unref0 (*output_image);
		*output_image = _tmp10_;
		L = 0;
		R = output_width - 1;
		T = 0;
		B = output_height - 1;
	} else {
		switch (scan_direction) {
			case SCAN_DIRECTION_TOP_TO_BOTTOM:
			{
				gint _tmp11_;
				gint _tmp12_;
				L = 0;
				R = output_width - 1;
				_tmp11_ = input_height;
				T = (gint) ((((gdouble) old_scan_line) * output_height) / _tmp11_);
				_tmp12_ = input_height;
				B = (gint) (((((gdouble) scan_line) * output_height) / _tmp12_) + 0.5);
				break;
			}
			case SCAN_DIRECTION_LEFT_TO_RIGHT:
			{
				gint _tmp13_;
				gint _tmp14_;
				_tmp13_ = input_width;
				L = (gint) ((((gdouble) old_scan_line) * output_width) / _tmp13_);
				_tmp14_ = input_width;
				R = (gint) (((((gdouble) scan_line) * output_width) / _tmp14_) + 0.5);
				T = 0;
				B = output_height - 1;
				break;
			}
			case SCAN_DIRECTION_BOTTOM_TO_TOP:
			{
				gint _tmp15_;
				gint _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
				L = 0;
				R = output_width - 1;
				_tmp15_ = input_height;
				_tmp16_ = input_height;
				T = (gint) ((((gdouble) (_tmp15_ - scan_line)) * output_height) / _tmp16_);
				_tmp17_ = input_height;
				_tmp18_ = input_height;
				B = (gint) (((((gdouble) (_tmp17_ - old_scan_line)) * output_height) / _tmp18_) + 0.5);
				break;
			}
			case SCAN_DIRECTION_RIGHT_TO_LEFT:
			{
				gint _tmp19_;
				gint _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
				_tmp19_ = input_width;
				_tmp20_ = input_width;
				L = (gint) ((((gdouble) (_tmp19_ - scan_line)) * output_width) / _tmp20_);
				_tmp21_ = input_width;
				_tmp22_ = input_width;
				R = (gint) (((((gdouble) (_tmp21_ - old_scan_line)) * output_width) / _tmp22_) + 0.5);
				T = 0;
				B = output_height - 1;
				break;
			}
			default:
			{
				gint _tmp23_;
				gint _tmp24_;
				gint _tmp25_;
				T = 0;
				_tmp23_ = T;
				B = _tmp23_;
				_tmp24_ = B;
				R = _tmp24_;
				_tmp25_ = R;
				L = _tmp25_;
				break;
			}
		}
	}
	_tmp26_ = R;
	if (_tmp26_ >= output_width) {
		R = output_width - 1;
	}
	_tmp27_ = B;
	if (_tmp27_ >= output_height) {
		B = output_height - 1;
	}
	_tmp28_ = L;
	g_return_if_fail (_tmp28_ >= 0);
	_tmp29_ = R;
	g_return_if_fail (_tmp29_ < output_width);
	_tmp30_ = T;
	g_return_if_fail (_tmp30_ >= 0);
	_tmp31_ = B;
	g_return_if_fail (_tmp31_ < output_height);
	g_return_if_fail ((*output_image) != NULL);
	_tmp32_ = gdk_pixbuf_get_pixels (*output_image);
	output = _tmp32_;
	output_length1 = -1;
	_output_size_ = output_length1;
	_tmp33_ = gdk_pixbuf_get_rowstride (*output_image);
	_tmp34_ = _tmp33_;
	output_rowstride = _tmp34_;
	_tmp35_ = gdk_pixbuf_get_n_channels (*output_image);
	_tmp36_ = _tmp35_;
	output_n_channels = _tmp36_;
	_tmp37_ = page_get_has_data (page);
	_tmp38_ = _tmp37_;
	if (!_tmp38_) {
		{
			gint x = 0;
			gint _tmp39_;
			_tmp39_ = L;
			x = _tmp39_;
			{
				gboolean _tmp40_ = FALSE;
				_tmp40_ = TRUE;
				while (TRUE) {
					gint _tmp42_;
					gint _tmp43_;
					if (!_tmp40_) {
						gint _tmp41_;
						_tmp41_ = x;
						x = _tmp41_ + 1;
					}
					_tmp40_ = FALSE;
					_tmp42_ = x;
					_tmp43_ = R;
					if (!(_tmp42_ <= _tmp43_)) {
						break;
					}
					{
						gint y = 0;
						gint _tmp44_;
						_tmp44_ = T;
						y = _tmp44_;
						{
							gboolean _tmp45_ = FALSE;
							_tmp45_ = TRUE;
							while (TRUE) {
								gint _tmp47_;
								gint _tmp48_;
								gint o = 0;
								gint _tmp49_;
								gint _tmp50_;
								gint _tmp51_;
								gint _tmp52_;
								guchar* _tmp53_;
								gint _tmp53__length1;
								gint _tmp54_;
								guchar* _tmp55_;
								gint _tmp55__length1;
								gint _tmp56_;
								guchar* _tmp57_;
								gint _tmp57__length1;
								gint _tmp58_;
								guchar _tmp59_;
								guchar _tmp60_;
								guchar _tmp61_;
								if (!_tmp45_) {
									gint _tmp46_;
									_tmp46_ = y;
									y = _tmp46_ + 1;
								}
								_tmp45_ = FALSE;
								_tmp47_ = y;
								_tmp48_ = B;
								if (!(_tmp47_ <= _tmp48_)) {
									break;
								}
								_tmp49_ = output_rowstride;
								_tmp50_ = y;
								_tmp51_ = x;
								_tmp52_ = output_n_channels;
								o = (_tmp49_ * _tmp50_) + (_tmp51_ * _tmp52_);
								_tmp53_ = output;
								_tmp53__length1 = output_length1;
								_tmp54_ = o;
								_tmp55_ = output;
								_tmp55__length1 = output_length1;
								_tmp56_ = o;
								_tmp57_ = output;
								_tmp57__length1 = output_length1;
								_tmp58_ = o;
								_tmp57_[_tmp58_ + 2] = (guchar) 0xFF;
								_tmp59_ = _tmp57_[_tmp58_ + 2];
								_tmp55_[_tmp56_ + 1] = _tmp59_;
								_tmp60_ = _tmp55_[_tmp56_ + 1];
								_tmp53_[_tmp54_] = _tmp60_;
								_tmp61_ = _tmp53_[_tmp54_];
							}
						}
					}
				}
			}
		}
		return;
	}
	{
		gint x = 0;
		gint _tmp62_;
		_tmp62_ = L;
		x = _tmp62_;
		{
			gboolean _tmp63_ = FALSE;
			_tmp63_ = TRUE;
			while (TRUE) {
				gint _tmp65_;
				gint _tmp66_;
				gdouble l = 0.0;
				gint _tmp67_;
				gint _tmp68_;
				gdouble r = 0.0;
				gint _tmp69_;
				gint _tmp70_;
				if (!_tmp63_) {
					gint _tmp64_;
					_tmp64_ = x;
					x = _tmp64_ + 1;
				}
				_tmp63_ = FALSE;
				_tmp65_ = x;
				_tmp66_ = R;
				if (!(_tmp65_ <= _tmp66_)) {
					break;
				}
				_tmp67_ = x;
				_tmp68_ = input_width;
				l = (((gdouble) _tmp67_) * _tmp68_) / output_width;
				_tmp69_ = x;
				_tmp70_ = input_width;
				r = (((gdouble) (_tmp69_ + 1)) * _tmp70_) / output_width;
				{
					gint y = 0;
					gint _tmp71_;
					_tmp71_ = T;
					y = _tmp71_;
					{
						gboolean _tmp72_ = FALSE;
						_tmp72_ = TRUE;
						while (TRUE) {
							gint _tmp74_;
							gint _tmp75_;
							gdouble t = 0.0;
							gint _tmp76_;
							gint _tmp77_;
							gdouble b = 0.0;
							gint _tmp78_;
							gint _tmp79_;
							gdouble _tmp80_;
							gdouble _tmp81_;
							gdouble _tmp82_;
							gdouble _tmp83_;
							guchar* _tmp84_;
							gint _tmp84__length1;
							gint _tmp85_;
							gint _tmp86_;
							gint _tmp87_;
							gint _tmp88_;
							if (!_tmp72_) {
								gint _tmp73_;
								_tmp73_ = y;
								y = _tmp73_ + 1;
							}
							_tmp72_ = FALSE;
							_tmp74_ = y;
							_tmp75_ = B;
							if (!(_tmp74_ <= _tmp75_)) {
								break;
							}
							_tmp76_ = y;
							_tmp77_ = input_height;
							t = (((gdouble) _tmp76_) * _tmp77_) / output_height;
							_tmp78_ = y;
							_tmp79_ = input_height;
							b = (((gdouble) (_tmp78_ + 1)) * _tmp79_) / output_height;
							_tmp80_ = l;
							_tmp81_ = r;
							_tmp82_ = t;
							_tmp83_ = b;
							_tmp84_ = output;
							_tmp84__length1 = output_length1;
							_tmp85_ = output_rowstride;
							_tmp86_ = y;
							_tmp87_ = x;
							_tmp88_ = output_n_channels;
							page_view_set_pixel (self, page, _tmp80_, _tmp81_, _tmp82_, _tmp83_, _tmp84_, _tmp84__length1, (_tmp85_ * _tmp86_) + (_tmp87_ * _tmp88_));
						}
					}
				}
			}
		}
	}
}


static gint
page_view_get_preview_width (PageView* self)
{
	gint result = 0;
	gint _tmp0_;
	gint _tmp1_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->width_;
	_tmp1_ = self->priv->border_width;
	result = _tmp0_ - (_tmp1_ * 2);
	return result;
}


static gint
page_view_get_preview_height (PageView* self)
{
	gint result = 0;
	gint _tmp0_;
	gint _tmp1_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->height_;
	_tmp1_ = self->priv->border_width;
	result = _tmp0_ - (_tmp1_ * 2);
	return result;
}


static void
page_view_update_page_view (PageView* self)
{
	gboolean _tmp0_;
	gint old_scan_line = 0;
	gint _tmp1_;
	gint scan_line = 0;
	Page* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	ScanDirection left_steps = 0;
	ScanDirection _tmp5_;
	Page* _tmp6_;
	ScanDirection _tmp7_;
	ScanDirection _tmp8_;
	gboolean _tmp9_ = FALSE;
	ScanDirection _tmp10_;
	Page* _tmp12_;
	ScanDirection _tmp13_;
	ScanDirection _tmp14_;
	Page* _tmp15_;
	Page* _tmp16_;
	ScanDirection _tmp17_;
	ScanDirection _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->update_image;
	if (!_tmp0_) {
		return;
	}
	_tmp1_ = self->priv->scan_line;
	old_scan_line = _tmp1_;
	_tmp2_ = self->priv->_page;
	_tmp3_ = page_get_scan_line (_tmp2_);
	_tmp4_ = _tmp3_;
	scan_line = _tmp4_;
	_tmp5_ = self->priv->scan_direction;
	_tmp6_ = self->priv->_page;
	_tmp7_ = page_get_scan_direction (_tmp6_);
	_tmp8_ = _tmp7_;
	left_steps = _tmp5_ - _tmp8_;
	_tmp10_ = left_steps;
	if (_tmp10_ != 0) {
		GdkPixbuf* _tmp11_;
		_tmp11_ = self->priv->image;
		_tmp9_ = _tmp11_ != NULL;
	} else {
		_tmp9_ = FALSE;
	}
	if (_tmp9_) {
		_g_object_unref0 (self->priv->image);
		self->priv->image = NULL;
	}
	_tmp12_ = self->priv->_page;
	_tmp13_ = page_get_scan_direction (_tmp12_);
	_tmp14_ = _tmp13_;
	self->priv->scan_direction = _tmp14_;
	_tmp15_ = self->priv->_page;
	_tmp16_ = self->priv->_page;
	_tmp17_ = page_get_scan_direction (_tmp16_);
	_tmp18_ = _tmp17_;
	_tmp19_ = old_scan_line;
	_tmp20_ = scan_line;
	page_view_update_preview (self, _tmp15_, &self->priv->image, page_view_get_preview_width (self), page_view_get_preview_height (self), _tmp18_, _tmp19_, _tmp20_);
	self->priv->update_image = FALSE;
	_tmp21_ = scan_line;
	self->priv->scan_line = _tmp21_;
}


static gint
page_view_page_to_screen_x (PageView* self,
                            gint x)
{
	gint result = 0;
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_page;
	_tmp1_ = page_get_width (_tmp0_);
	_tmp2_ = _tmp1_;
	result = (gint) (((((gdouble) x) * page_view_get_preview_width (self)) / _tmp2_) + 0.5);
	return result;
}


static gint
page_view_page_to_screen_y (PageView* self,
                            gint y)
{
	gint result = 0;
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_page;
	_tmp1_ = page_get_height (_tmp0_);
	_tmp2_ = _tmp1_;
	result = (gint) (((((gdouble) y) * page_view_get_preview_height (self)) / _tmp2_) + 0.5);
	return result;
}


static gint
page_view_screen_to_page_x (PageView* self,
                            gint x)
{
	gint result = 0;
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_page;
	_tmp1_ = page_get_width (_tmp0_);
	_tmp2_ = _tmp1_;
	result = (gint) (((((gdouble) x) * _tmp2_) / page_view_get_preview_width (self)) + 0.5);
	return result;
}


static gint
page_view_screen_to_page_y (PageView* self,
                            gint y)
{
	gint result = 0;
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_page;
	_tmp1_ = page_get_height (_tmp0_);
	_tmp2_ = _tmp1_;
	result = (gint) (((((gdouble) y) * _tmp2_) / page_view_get_preview_height (self)) + 0.5);
	return result;
}


static CropLocation
page_view_get_crop_location (PageView* self,
                             gint x,
                             gint y)
{
	CropLocation result = 0;
	Page* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gint cx = 0;
	Page* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint cy = 0;
	Page* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint cw = 0;
	Page* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint ch = 0;
	Page* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint dx = 0;
	gint _tmp15_;
	gint dy = 0;
	gint _tmp16_;
	gint dw = 0;
	gint _tmp17_;
	gint dh = 0;
	gint _tmp18_;
	gint ix = 0;
	gint _tmp19_;
	gint iy = 0;
	gint _tmp20_;
	gboolean _tmp21_ = FALSE;
	gboolean _tmp22_ = FALSE;
	gboolean _tmp23_ = FALSE;
	gint _tmp24_;
	gchar* name = NULL;
	Page* _tmp30_;
	const gchar* _tmp31_;
	const gchar* _tmp32_;
	gchar* _tmp33_;
	const gchar* _tmp34_;
	gint crop_border = 0;
	gint _tmp35_;
	gint _tmp36_;
	gint _tmp38_;
	gint _tmp39_;
	gboolean _tmp41_ = FALSE;
	gint _tmp42_;
	gint _tmp43_;
	gboolean _tmp46_ = FALSE;
	gint _tmp47_;
	gint _tmp48_;
	gint _tmp49_;
	gboolean _tmp52_ = FALSE;
	gint _tmp53_;
	gint _tmp54_;
	gboolean _tmp58_ = FALSE;
	gint _tmp59_;
	gint _tmp60_;
	gint _tmp61_;
	gint _tmp65_;
	gint _tmp66_;
	gint _tmp67_;
	gint _tmp68_;
	gint _tmp69_;
	gint _tmp70_;
	gint _tmp71_;
	gint _tmp72_;
	gint _tmp73_;
	gint _tmp74_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_page;
	_tmp1_ = page_get_has_crop (_tmp0_);
	_tmp2_ = _tmp1_;
	if (!_tmp2_) {
		result = 0;
		return result;
	}
	_tmp3_ = self->priv->_page;
	_tmp4_ = page_get_crop_x (_tmp3_);
	_tmp5_ = _tmp4_;
	cx = _tmp5_;
	_tmp6_ = self->priv->_page;
	_tmp7_ = page_get_crop_y (_tmp6_);
	_tmp8_ = _tmp7_;
	cy = _tmp8_;
	_tmp9_ = self->priv->_page;
	_tmp10_ = page_get_crop_width (_tmp9_);
	_tmp11_ = _tmp10_;
	cw = _tmp11_;
	_tmp12_ = self->priv->_page;
	_tmp13_ = page_get_crop_height (_tmp12_);
	_tmp14_ = _tmp13_;
	ch = _tmp14_;
	_tmp15_ = cx;
	dx = page_view_page_to_screen_x (self, _tmp15_);
	_tmp16_ = cy;
	dy = page_view_page_to_screen_y (self, _tmp16_);
	_tmp17_ = cw;
	dw = page_view_page_to_screen_x (self, _tmp17_);
	_tmp18_ = ch;
	dh = page_view_page_to_screen_y (self, _tmp18_);
	_tmp19_ = dx;
	ix = x - _tmp19_;
	_tmp20_ = dy;
	iy = y - _tmp20_;
	_tmp24_ = ix;
	if (_tmp24_ < 0) {
		_tmp23_ = TRUE;
	} else {
		gint _tmp25_;
		gint _tmp26_;
		_tmp25_ = ix;
		_tmp26_ = dw;
		_tmp23_ = _tmp25_ > _tmp26_;
	}
	if (_tmp23_) {
		_tmp22_ = TRUE;
	} else {
		gint _tmp27_;
		_tmp27_ = iy;
		_tmp22_ = _tmp27_ < 0;
	}
	if (_tmp22_) {
		_tmp21_ = TRUE;
	} else {
		gint _tmp28_;
		gint _tmp29_;
		_tmp28_ = iy;
		_tmp29_ = dh;
		_tmp21_ = _tmp28_ > _tmp29_;
	}
	if (_tmp21_) {
		result = CROP_LOCATION_NONE;
		return result;
	}
	_tmp30_ = self->priv->_page;
	_tmp31_ = page_get_crop_name (_tmp30_);
	_tmp32_ = _tmp31_;
	_tmp33_ = g_strdup (_tmp32_);
	name = _tmp33_;
	_tmp34_ = name;
	if (_tmp34_ != NULL) {
		result = CROP_LOCATION_MIDDLE;
		_g_free0 (name);
		return result;
	}
	crop_border = 20;
	_tmp35_ = dw;
	_tmp36_ = crop_border;
	if (_tmp35_ < (_tmp36_ * 3)) {
		gint _tmp37_;
		_tmp37_ = dw;
		crop_border = _tmp37_ / 3;
	}
	_tmp38_ = dh;
	_tmp39_ = crop_border;
	if (_tmp38_ < (_tmp39_ * 3)) {
		gint _tmp40_;
		_tmp40_ = dh;
		crop_border = _tmp40_ / 3;
	}
	_tmp42_ = ix;
	_tmp43_ = crop_border;
	if (_tmp42_ < _tmp43_) {
		gint _tmp44_;
		gint _tmp45_;
		_tmp44_ = iy;
		_tmp45_ = crop_border;
		_tmp41_ = _tmp44_ < _tmp45_;
	} else {
		_tmp41_ = FALSE;
	}
	if (_tmp41_) {
		result = CROP_LOCATION_TOP_LEFT;
		_g_free0 (name);
		return result;
	}
	_tmp47_ = ix;
	_tmp48_ = dw;
	_tmp49_ = crop_border;
	if (_tmp47_ > (_tmp48_ - _tmp49_)) {
		gint _tmp50_;
		gint _tmp51_;
		_tmp50_ = iy;
		_tmp51_ = crop_border;
		_tmp46_ = _tmp50_ < _tmp51_;
	} else {
		_tmp46_ = FALSE;
	}
	if (_tmp46_) {
		result = CROP_LOCATION_TOP_RIGHT;
		_g_free0 (name);
		return result;
	}
	_tmp53_ = ix;
	_tmp54_ = crop_border;
	if (_tmp53_ < _tmp54_) {
		gint _tmp55_;
		gint _tmp56_;
		gint _tmp57_;
		_tmp55_ = iy;
		_tmp56_ = dh;
		_tmp57_ = crop_border;
		_tmp52_ = _tmp55_ > (_tmp56_ - _tmp57_);
	} else {
		_tmp52_ = FALSE;
	}
	if (_tmp52_) {
		result = CROP_LOCATION_BOTTOM_LEFT;
		_g_free0 (name);
		return result;
	}
	_tmp59_ = ix;
	_tmp60_ = dw;
	_tmp61_ = crop_border;
	if (_tmp59_ > (_tmp60_ - _tmp61_)) {
		gint _tmp62_;
		gint _tmp63_;
		gint _tmp64_;
		_tmp62_ = iy;
		_tmp63_ = dh;
		_tmp64_ = crop_border;
		_tmp58_ = _tmp62_ > (_tmp63_ - _tmp64_);
	} else {
		_tmp58_ = FALSE;
	}
	if (_tmp58_) {
		result = CROP_LOCATION_BOTTOM_RIGHT;
		_g_free0 (name);
		return result;
	}
	_tmp65_ = ix;
	_tmp66_ = crop_border;
	if (_tmp65_ < _tmp66_) {
		result = CROP_LOCATION_LEFT;
		_g_free0 (name);
		return result;
	}
	_tmp67_ = ix;
	_tmp68_ = dw;
	_tmp69_ = crop_border;
	if (_tmp67_ > (_tmp68_ - _tmp69_)) {
		result = CROP_LOCATION_RIGHT;
		_g_free0 (name);
		return result;
	}
	_tmp70_ = iy;
	_tmp71_ = crop_border;
	if (_tmp70_ < _tmp71_) {
		result = CROP_LOCATION_TOP;
		_g_free0 (name);
		return result;
	}
	_tmp72_ = iy;
	_tmp73_ = dh;
	_tmp74_ = crop_border;
	if (_tmp72_ > (_tmp73_ - _tmp74_)) {
		result = CROP_LOCATION_BOTTOM;
		_g_free0 (name);
		return result;
	}
	result = CROP_LOCATION_MIDDLE;
	_g_free0 (name);
	return result;
}


void
page_view_button_press (PageView* self,
                        gint x,
                        gint y)
{
	CropLocation location = 0;
	CropLocation _tmp0_;
	g_return_if_fail (self != NULL);
	location = page_view_get_crop_location (self, x, y);
	_tmp0_ = location;
	if (_tmp0_ != CROP_LOCATION_NONE) {
		CropLocation _tmp1_;
		Page* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		Page* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		Page* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		Page* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		_tmp1_ = location;
		self->priv->crop_location = _tmp1_;
		self->priv->selected_crop_px = (gdouble) x;
		self->priv->selected_crop_py = (gdouble) y;
		_tmp2_ = self->priv->_page;
		_tmp3_ = page_get_crop_x (_tmp2_);
		_tmp4_ = _tmp3_;
		self->priv->selected_crop_x = _tmp4_;
		_tmp5_ = self->priv->_page;
		_tmp6_ = page_get_crop_y (_tmp5_);
		_tmp7_ = _tmp6_;
		self->priv->selected_crop_y = _tmp7_;
		_tmp8_ = self->priv->_page;
		_tmp9_ = page_get_crop_width (_tmp8_);
		_tmp10_ = _tmp9_;
		self->priv->selected_crop_w = _tmp10_;
		_tmp11_ = self->priv->_page;
		_tmp12_ = page_get_crop_height (_tmp11_);
		_tmp13_ = _tmp12_;
		self->priv->selected_crop_h = _tmp13_;
	}
}


void
page_view_motion (PageView* self,
                  gint x,
                  gint y)
{
	CropLocation location = 0;
	GdkCursorType cursor = 0;
	CropLocation _tmp0_;
	CropLocation _tmp1_;
	gint pw = 0;
	Page* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint ph = 0;
	Page* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint cw = 0;
	Page* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint ch = 0;
	Page* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint dx = 0;
	gdouble _tmp15_;
	gint dy = 0;
	gdouble _tmp16_;
	gint new_x = 0;
	gint _tmp17_;
	gint new_y = 0;
	gint _tmp18_;
	gint new_w = 0;
	gint _tmp19_;
	gint new_h = 0;
	gint _tmp20_;
	gint min_size = 0;
	gboolean _tmp21_ = FALSE;
	gboolean _tmp22_ = FALSE;
	CropLocation _tmp23_;
	gboolean _tmp34_ = FALSE;
	gboolean _tmp35_ = FALSE;
	CropLocation _tmp36_;
	gboolean _tmp47_ = FALSE;
	gboolean _tmp48_ = FALSE;
	CropLocation _tmp49_;
	gboolean _tmp64_ = FALSE;
	gboolean _tmp65_ = FALSE;
	CropLocation _tmp66_;
	CropLocation _tmp81_;
	CropLocation _tmp102_;
	gboolean _tmp107_ = FALSE;
	gboolean _tmp108_ = FALSE;
	CropLocation _tmp109_;
	gboolean _tmp116_ = FALSE;
	gboolean _tmp117_ = FALSE;
	CropLocation _tmp118_;
	gboolean _tmp125_ = FALSE;
	gboolean _tmp126_ = FALSE;
	CropLocation _tmp127_;
	gboolean _tmp132_ = FALSE;
	gboolean _tmp133_ = FALSE;
	CropLocation _tmp134_;
	Page* _tmp139_;
	gint _tmp140_;
	gint _tmp141_;
	gboolean _tmp142_ = FALSE;
	gint _tmp143_;
	gint _tmp144_;
	g_return_if_fail (self != NULL);
	location = page_view_get_crop_location (self, x, y);
	_tmp0_ = location;
	switch (_tmp0_) {
		case CROP_LOCATION_MIDDLE:
		{
			cursor = GDK_HAND1;
			break;
		}
		case CROP_LOCATION_TOP:
		{
			cursor = GDK_TOP_SIDE;
			break;
		}
		case CROP_LOCATION_BOTTOM:
		{
			cursor = GDK_BOTTOM_SIDE;
			break;
		}
		case CROP_LOCATION_LEFT:
		{
			cursor = GDK_LEFT_SIDE;
			break;
		}
		case CROP_LOCATION_RIGHT:
		{
			cursor = GDK_RIGHT_SIDE;
			break;
		}
		case CROP_LOCATION_TOP_LEFT:
		{
			cursor = GDK_TOP_LEFT_CORNER;
			break;
		}
		case CROP_LOCATION_TOP_RIGHT:
		{
			cursor = GDK_TOP_RIGHT_CORNER;
			break;
		}
		case CROP_LOCATION_BOTTOM_LEFT:
		{
			cursor = GDK_BOTTOM_LEFT_CORNER;
			break;
		}
		case CROP_LOCATION_BOTTOM_RIGHT:
		{
			cursor = GDK_BOTTOM_RIGHT_CORNER;
			break;
		}
		default:
		{
			cursor = GDK_ARROW;
			break;
		}
	}
	_tmp1_ = self->priv->crop_location;
	if (_tmp1_ == CROP_LOCATION_NONE) {
		GdkCursorType _tmp2_;
		_tmp2_ = cursor;
		page_view_set_cursor (self, _tmp2_);
		return;
	}
	_tmp3_ = self->priv->_page;
	_tmp4_ = page_get_width (_tmp3_);
	_tmp5_ = _tmp4_;
	pw = _tmp5_;
	_tmp6_ = self->priv->_page;
	_tmp7_ = page_get_height (_tmp6_);
	_tmp8_ = _tmp7_;
	ph = _tmp8_;
	_tmp9_ = self->priv->_page;
	_tmp10_ = page_get_crop_width (_tmp9_);
	_tmp11_ = _tmp10_;
	cw = _tmp11_;
	_tmp12_ = self->priv->_page;
	_tmp13_ = page_get_crop_height (_tmp12_);
	_tmp14_ = _tmp13_;
	ch = _tmp14_;
	_tmp15_ = self->priv->selected_crop_px;
	dx = page_view_screen_to_page_x (self, x - ((gint) _tmp15_));
	_tmp16_ = self->priv->selected_crop_py;
	dy = page_view_screen_to_page_y (self, y - ((gint) _tmp16_));
	_tmp17_ = self->priv->selected_crop_x;
	new_x = _tmp17_;
	_tmp18_ = self->priv->selected_crop_y;
	new_y = _tmp18_;
	_tmp19_ = self->priv->selected_crop_w;
	new_w = _tmp19_;
	_tmp20_ = self->priv->selected_crop_h;
	new_h = _tmp20_;
	min_size = page_view_screen_to_page_x (self, 15);
	_tmp23_ = self->priv->crop_location;
	if (_tmp23_ == CROP_LOCATION_TOP_LEFT) {
		_tmp22_ = TRUE;
	} else {
		CropLocation _tmp24_;
		_tmp24_ = self->priv->crop_location;
		_tmp22_ = _tmp24_ == CROP_LOCATION_LEFT;
	}
	if (_tmp22_) {
		_tmp21_ = TRUE;
	} else {
		CropLocation _tmp25_;
		_tmp25_ = self->priv->crop_location;
		_tmp21_ = _tmp25_ == CROP_LOCATION_BOTTOM_LEFT;
	}
	if (_tmp21_) {
		gint _tmp26_;
		gint _tmp27_;
		gint _tmp28_;
		gint _tmp31_;
		gint _tmp32_;
		_tmp26_ = dx;
		_tmp27_ = new_w;
		_tmp28_ = min_size;
		if (_tmp26_ > (_tmp27_ - _tmp28_)) {
			gint _tmp29_;
			gint _tmp30_;
			_tmp29_ = new_w;
			_tmp30_ = min_size;
			dx = _tmp29_ - _tmp30_;
		}
		_tmp31_ = new_x;
		_tmp32_ = dx;
		if ((_tmp31_ + _tmp32_) < 0) {
			gint _tmp33_;
			_tmp33_ = new_x;
			dx = -_tmp33_;
		}
	}
	_tmp36_ = self->priv->crop_location;
	if (_tmp36_ == CROP_LOCATION_TOP_LEFT) {
		_tmp35_ = TRUE;
	} else {
		CropLocation _tmp37_;
		_tmp37_ = self->priv->crop_location;
		_tmp35_ = _tmp37_ == CROP_LOCATION_TOP;
	}
	if (_tmp35_) {
		_tmp34_ = TRUE;
	} else {
		CropLocation _tmp38_;
		_tmp38_ = self->priv->crop_location;
		_tmp34_ = _tmp38_ == CROP_LOCATION_TOP_RIGHT;
	}
	if (_tmp34_) {
		gint _tmp39_;
		gint _tmp40_;
		gint _tmp41_;
		gint _tmp44_;
		gint _tmp45_;
		_tmp39_ = dy;
		_tmp40_ = new_h;
		_tmp41_ = min_size;
		if (_tmp39_ > (_tmp40_ - _tmp41_)) {
			gint _tmp42_;
			gint _tmp43_;
			_tmp42_ = new_h;
			_tmp43_ = min_size;
			dy = _tmp42_ - _tmp43_;
		}
		_tmp44_ = new_y;
		_tmp45_ = dy;
		if ((_tmp44_ + _tmp45_) < 0) {
			gint _tmp46_;
			_tmp46_ = new_y;
			dy = -_tmp46_;
		}
	}
	_tmp49_ = self->priv->crop_location;
	if (_tmp49_ == CROP_LOCATION_TOP_RIGHT) {
		_tmp48_ = TRUE;
	} else {
		CropLocation _tmp50_;
		_tmp50_ = self->priv->crop_location;
		_tmp48_ = _tmp50_ == CROP_LOCATION_RIGHT;
	}
	if (_tmp48_) {
		_tmp47_ = TRUE;
	} else {
		CropLocation _tmp51_;
		_tmp51_ = self->priv->crop_location;
		_tmp47_ = _tmp51_ == CROP_LOCATION_BOTTOM_RIGHT;
	}
	if (_tmp47_) {
		gint _tmp52_;
		gint _tmp53_;
		gint _tmp54_;
		gint _tmp57_;
		gint _tmp58_;
		gint _tmp59_;
		gint _tmp60_;
		_tmp52_ = dx;
		_tmp53_ = min_size;
		_tmp54_ = new_w;
		if (_tmp52_ < (_tmp53_ - _tmp54_)) {
			gint _tmp55_;
			gint _tmp56_;
			_tmp55_ = min_size;
			_tmp56_ = new_w;
			dx = _tmp55_ - _tmp56_;
		}
		_tmp57_ = new_x;
		_tmp58_ = new_w;
		_tmp59_ = dx;
		_tmp60_ = pw;
		if (((_tmp57_ + _tmp58_) + _tmp59_) > _tmp60_) {
			gint _tmp61_;
			gint _tmp62_;
			gint _tmp63_;
			_tmp61_ = pw;
			_tmp62_ = new_x;
			_tmp63_ = new_w;
			dx = (_tmp61_ - _tmp62_) - _tmp63_;
		}
	}
	_tmp66_ = self->priv->crop_location;
	if (_tmp66_ == CROP_LOCATION_BOTTOM_LEFT) {
		_tmp65_ = TRUE;
	} else {
		CropLocation _tmp67_;
		_tmp67_ = self->priv->crop_location;
		_tmp65_ = _tmp67_ == CROP_LOCATION_BOTTOM;
	}
	if (_tmp65_) {
		_tmp64_ = TRUE;
	} else {
		CropLocation _tmp68_;
		_tmp68_ = self->priv->crop_location;
		_tmp64_ = _tmp68_ == CROP_LOCATION_BOTTOM_RIGHT;
	}
	if (_tmp64_) {
		gint _tmp69_;
		gint _tmp70_;
		gint _tmp71_;
		gint _tmp74_;
		gint _tmp75_;
		gint _tmp76_;
		gint _tmp77_;
		_tmp69_ = dy;
		_tmp70_ = min_size;
		_tmp71_ = new_h;
		if (_tmp69_ < (_tmp70_ - _tmp71_)) {
			gint _tmp72_;
			gint _tmp73_;
			_tmp72_ = min_size;
			_tmp73_ = new_h;
			dy = _tmp72_ - _tmp73_;
		}
		_tmp74_ = new_y;
		_tmp75_ = new_h;
		_tmp76_ = dy;
		_tmp77_ = ph;
		if (((_tmp74_ + _tmp75_) + _tmp76_) > _tmp77_) {
			gint _tmp78_;
			gint _tmp79_;
			gint _tmp80_;
			_tmp78_ = ph;
			_tmp79_ = new_y;
			_tmp80_ = new_h;
			dy = (_tmp78_ - _tmp79_) - _tmp80_;
		}
	}
	_tmp81_ = self->priv->crop_location;
	if (_tmp81_ == CROP_LOCATION_MIDDLE) {
		gint _tmp82_;
		gint _tmp83_;
		gint _tmp84_;
		gint _tmp85_;
		gint _tmp89_;
		gint _tmp90_;
		gint _tmp92_;
		gint _tmp93_;
		gint _tmp94_;
		gint _tmp95_;
		gint _tmp99_;
		gint _tmp100_;
		_tmp82_ = new_x;
		_tmp83_ = dx;
		_tmp84_ = new_w;
		_tmp85_ = pw;
		if (((_tmp82_ + _tmp83_) + _tmp84_) > _tmp85_) {
			gint _tmp86_;
			gint _tmp87_;
			gint _tmp88_;
			_tmp86_ = pw;
			_tmp87_ = new_x;
			_tmp88_ = new_w;
			dx = (_tmp86_ - _tmp87_) - _tmp88_;
		}
		_tmp89_ = new_x;
		_tmp90_ = dx;
		if ((_tmp89_ + _tmp90_) < 0) {
			gint _tmp91_;
			_tmp91_ = new_x;
			dx = -_tmp91_;
		}
		_tmp92_ = new_y;
		_tmp93_ = dy;
		_tmp94_ = new_h;
		_tmp95_ = ph;
		if (((_tmp92_ + _tmp93_) + _tmp94_) > _tmp95_) {
			gint _tmp96_;
			gint _tmp97_;
			gint _tmp98_;
			_tmp96_ = ph;
			_tmp97_ = new_y;
			_tmp98_ = new_h;
			dy = (_tmp96_ - _tmp97_) - _tmp98_;
		}
		_tmp99_ = new_y;
		_tmp100_ = dy;
		if ((_tmp99_ + _tmp100_) < 0) {
			gint _tmp101_;
			_tmp101_ = new_y;
			dy = -_tmp101_;
		}
	}
	_tmp102_ = self->priv->crop_location;
	if (_tmp102_ == CROP_LOCATION_MIDDLE) {
		gint _tmp103_;
		gint _tmp104_;
		gint _tmp105_;
		gint _tmp106_;
		_tmp103_ = new_x;
		_tmp104_ = dx;
		new_x = _tmp103_ + _tmp104_;
		_tmp105_ = new_y;
		_tmp106_ = dy;
		new_y = _tmp105_ + _tmp106_;
	}
	_tmp109_ = self->priv->crop_location;
	if (_tmp109_ == CROP_LOCATION_TOP_LEFT) {
		_tmp108_ = TRUE;
	} else {
		CropLocation _tmp110_;
		_tmp110_ = self->priv->crop_location;
		_tmp108_ = _tmp110_ == CROP_LOCATION_LEFT;
	}
	if (_tmp108_) {
		_tmp107_ = TRUE;
	} else {
		CropLocation _tmp111_;
		_tmp111_ = self->priv->crop_location;
		_tmp107_ = _tmp111_ == CROP_LOCATION_BOTTOM_LEFT;
	}
	if (_tmp107_) {
		gint _tmp112_;
		gint _tmp113_;
		gint _tmp114_;
		gint _tmp115_;
		_tmp112_ = new_x;
		_tmp113_ = dx;
		new_x = _tmp112_ + _tmp113_;
		_tmp114_ = new_w;
		_tmp115_ = dx;
		new_w = _tmp114_ - _tmp115_;
	}
	_tmp118_ = self->priv->crop_location;
	if (_tmp118_ == CROP_LOCATION_TOP_LEFT) {
		_tmp117_ = TRUE;
	} else {
		CropLocation _tmp119_;
		_tmp119_ = self->priv->crop_location;
		_tmp117_ = _tmp119_ == CROP_LOCATION_TOP;
	}
	if (_tmp117_) {
		_tmp116_ = TRUE;
	} else {
		CropLocation _tmp120_;
		_tmp120_ = self->priv->crop_location;
		_tmp116_ = _tmp120_ == CROP_LOCATION_TOP_RIGHT;
	}
	if (_tmp116_) {
		gint _tmp121_;
		gint _tmp122_;
		gint _tmp123_;
		gint _tmp124_;
		_tmp121_ = new_y;
		_tmp122_ = dy;
		new_y = _tmp121_ + _tmp122_;
		_tmp123_ = new_h;
		_tmp124_ = dy;
		new_h = _tmp123_ - _tmp124_;
	}
	_tmp127_ = self->priv->crop_location;
	if (_tmp127_ == CROP_LOCATION_TOP_RIGHT) {
		_tmp126_ = TRUE;
	} else {
		CropLocation _tmp128_;
		_tmp128_ = self->priv->crop_location;
		_tmp126_ = _tmp128_ == CROP_LOCATION_RIGHT;
	}
	if (_tmp126_) {
		_tmp125_ = TRUE;
	} else {
		CropLocation _tmp129_;
		_tmp129_ = self->priv->crop_location;
		_tmp125_ = _tmp129_ == CROP_LOCATION_BOTTOM_RIGHT;
	}
	if (_tmp125_) {
		gint _tmp130_;
		gint _tmp131_;
		_tmp130_ = new_w;
		_tmp131_ = dx;
		new_w = _tmp130_ + _tmp131_;
	}
	_tmp134_ = self->priv->crop_location;
	if (_tmp134_ == CROP_LOCATION_BOTTOM_LEFT) {
		_tmp133_ = TRUE;
	} else {
		CropLocation _tmp135_;
		_tmp135_ = self->priv->crop_location;
		_tmp133_ = _tmp135_ == CROP_LOCATION_BOTTOM;
	}
	if (_tmp133_) {
		_tmp132_ = TRUE;
	} else {
		CropLocation _tmp136_;
		_tmp136_ = self->priv->crop_location;
		_tmp132_ = _tmp136_ == CROP_LOCATION_BOTTOM_RIGHT;
	}
	if (_tmp132_) {
		gint _tmp137_;
		gint _tmp138_;
		_tmp137_ = new_h;
		_tmp138_ = dy;
		new_h = _tmp137_ + _tmp138_;
	}
	_tmp139_ = self->priv->_page;
	_tmp140_ = new_x;
	_tmp141_ = new_y;
	page_move_crop (_tmp139_, _tmp140_, _tmp141_);
	_tmp143_ = new_w;
	_tmp144_ = cw;
	if (_tmp143_ != _tmp144_) {
		_tmp142_ = TRUE;
	} else {
		gint _tmp145_;
		gint _tmp146_;
		_tmp145_ = new_h;
		_tmp146_ = ch;
		_tmp142_ = _tmp145_ != _tmp146_;
	}
	if (_tmp142_) {
		Page* _tmp147_;
		gint _tmp148_;
		gint _tmp149_;
		_tmp147_ = self->priv->_page;
		_tmp148_ = new_w;
		_tmp149_ = new_h;
		page_set_custom_crop (_tmp147_, _tmp148_, _tmp149_);
	}
}


void
page_view_button_release (PageView* self,
                          gint x,
                          gint y)
{
	g_return_if_fail (self != NULL);
	self->priv->crop_location = CROP_LOCATION_NONE;
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
}


static gboolean
page_view_animation_cb (PageView* self)
{
	gboolean result = FALSE;
	gint _tmp0_;
	gint _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->animate_segment;
	_tmp1_ = self->priv->animate_n_segments;
	self->priv->animate_segment = (_tmp0_ + 1) % _tmp1_;
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
	result = TRUE;
	return result;
}


static gboolean
_page_view_animation_cb_gsource_func (gpointer self)
{
	gboolean result;
	result = page_view_animation_cb ((PageView*) self);
	return result;
}


static void
page_view_update_animation (PageView* self)
{
	gboolean animate = FALSE;
	gboolean is_animating = FALSE;
	gboolean _tmp0_ = FALSE;
	Page* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	guint _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->_page;
	_tmp2_ = page_get_is_scanning (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		Page* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		_tmp4_ = self->priv->_page;
		_tmp5_ = page_get_has_data (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp0_ = !_tmp6_;
	} else {
		_tmp0_ = FALSE;
	}
	animate = _tmp0_;
	_tmp7_ = self->priv->animate_timeout;
	is_animating = _tmp7_ != ((guint) 0);
	_tmp8_ = animate;
	_tmp9_ = is_animating;
	if (_tmp8_ == _tmp9_) {
		return;
	}
	_tmp10_ = animate;
	if (_tmp10_) {
		guint _tmp11_;
		self->priv->animate_segment = 0;
		_tmp11_ = self->priv->animate_timeout;
		if (_tmp11_ == ((guint) 0)) {
			self->priv->animate_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 150, _page_view_animation_cb_gsource_func, page_view_ref (self), page_view_unref);
		}
	} else {
		guint _tmp12_;
		_tmp12_ = self->priv->animate_timeout;
		if (_tmp12_ != ((guint) 0)) {
			guint _tmp13_;
			_tmp13_ = self->priv->animate_timeout;
			g_source_remove (_tmp13_);
		}
		self->priv->animate_timeout = (guint) 0;
	}
}


void
page_view_render (PageView* self,
                  cairo_t* context)
{
	gint w = 0;
	gint h = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	GdkPixbuf* _tmp11_;
	gboolean _tmp12_ = FALSE;
	Page* _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
	gboolean _tmp49_ = FALSE;
	Page* _tmp50_;
	gboolean _tmp51_;
	gboolean _tmp52_;
	Page* _tmp89_;
	gboolean _tmp90_;
	gboolean _tmp91_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	page_view_update_animation (self);
	page_view_update_page_view (self);
	w = page_view_get_preview_width (self);
	h = page_view_get_preview_height (self);
	cairo_set_line_width (context, (gdouble) 1);
	_tmp0_ = self->priv->_x_offset;
	_tmp1_ = self->priv->_y_offset;
	cairo_translate (context, (gdouble) _tmp0_, (gdouble) _tmp1_);
	cairo_set_source_rgb (context, (gdouble) 0, (gdouble) 0, (gdouble) 0);
	_tmp2_ = self->priv->border_width;
	cairo_set_line_width (context, (gdouble) _tmp2_);
	_tmp3_ = self->priv->border_width;
	_tmp4_ = self->priv->border_width;
	_tmp5_ = self->priv->width_;
	_tmp6_ = self->priv->border_width;
	_tmp7_ = self->priv->height_;
	_tmp8_ = self->priv->border_width;
	cairo_rectangle (context, ((gdouble) _tmp3_) / 2, ((gdouble) _tmp4_) / 2, (gdouble) (_tmp5_ - _tmp6_), (gdouble) (_tmp7_ - _tmp8_));
	cairo_stroke (context);
	_tmp9_ = self->priv->border_width;
	_tmp10_ = self->priv->border_width;
	cairo_translate (context, (gdouble) _tmp9_, (gdouble) _tmp10_);
	_tmp11_ = self->priv->image;
	gdk_cairo_set_source_pixbuf (context, _tmp11_, (gdouble) 0, (gdouble) 0);
	cairo_paint (context);
	_tmp13_ = self->priv->_page;
	_tmp14_ = page_get_is_scanning (_tmp13_);
	_tmp15_ = _tmp14_;
	if (_tmp15_) {
		Page* _tmp16_;
		gboolean _tmp17_;
		gboolean _tmp18_;
		_tmp16_ = self->priv->_page;
		_tmp17_ = page_get_has_data (_tmp16_);
		_tmp18_ = _tmp17_;
		_tmp12_ = !_tmp18_;
	} else {
		_tmp12_ = FALSE;
	}
	if (_tmp12_) {
		gdouble outer_radius = 0.0;
		gint _tmp19_;
		gint _tmp20_;
		gdouble arc = 0.0;
		gint _tmp23_;
		gdouble x = 0.0;
		gdouble _tmp24_;
		gdouble _tmp25_;
		gdouble y = 0.0;
		gdouble _tmp26_;
		gdouble _tmp27_;
		gdouble inner_radius = 0.0;
		gdouble _tmp28_;
		gdouble _tmp29_;
		gdouble _tmp30_;
		gdouble _tmp31_;
		gdouble offset = 0.0;
		_tmp19_ = w;
		_tmp20_ = h;
		if (_tmp19_ > _tmp20_) {
			gint _tmp21_;
			_tmp21_ = w;
			outer_radius = 0.15 * _tmp21_;
		} else {
			gint _tmp22_;
			_tmp22_ = h;
			outer_radius = 0.15 * _tmp22_;
		}
		_tmp23_ = self->priv->animate_n_segments;
		arc = G_PI / _tmp23_;
		_tmp24_ = outer_radius;
		_tmp25_ = arc;
		x = _tmp24_ * sin (_tmp25_);
		_tmp26_ = outer_radius;
		_tmp27_ = arc;
		y = _tmp26_ * (cos (_tmp27_) - 1.0);
		_tmp28_ = x;
		_tmp29_ = x;
		_tmp30_ = y;
		_tmp31_ = y;
		inner_radius = 0.6 * sqrt ((_tmp28_ * _tmp29_) + (_tmp30_ * _tmp31_));
		offset = 0.0;
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp32_ = FALSE;
				_tmp32_ = TRUE;
				while (TRUE) {
					gint _tmp36_;
					gint _tmp37_;
					gint _tmp38_;
					gdouble _tmp39_;
					gdouble _tmp40_;
					gint _tmp41_;
					gdouble _tmp42_;
					gdouble _tmp43_;
					gdouble _tmp44_;
					gdouble _tmp45_;
					gdouble _tmp46_;
					gint _tmp47_;
					gint _tmp48_;
					if (!_tmp32_) {
						gint _tmp33_;
						gdouble _tmp34_;
						gdouble _tmp35_;
						_tmp33_ = i;
						i = _tmp33_ + 1;
						_tmp34_ = offset;
						_tmp35_ = arc;
						offset = _tmp34_ + (_tmp35_ * 2);
					}
					_tmp32_ = FALSE;
					_tmp36_ = i;
					_tmp37_ = self->priv->animate_n_segments;
					if (!(_tmp36_ < _tmp37_)) {
						break;
					}
					_tmp38_ = w;
					_tmp39_ = outer_radius;
					_tmp40_ = offset;
					x = (_tmp38_ / 2) + (_tmp39_ * sin (_tmp40_));
					_tmp41_ = h;
					_tmp42_ = outer_radius;
					_tmp43_ = offset;
					y = (_tmp41_ / 2) - (_tmp42_ * cos (_tmp43_));
					_tmp44_ = x;
					_tmp45_ = y;
					_tmp46_ = inner_radius;
					cairo_arc (context, _tmp44_, _tmp45_, _tmp46_, (gdouble) 0, 2 * G_PI);
					_tmp47_ = i;
					_tmp48_ = self->priv->animate_segment;
					if (_tmp47_ == _tmp48_) {
						cairo_set_source_rgb (context, 0.75, 0.75, 0.75);
						cairo_fill_preserve (context);
					}
					cairo_set_source_rgb (context, 0.5, 0.5, 0.5);
					cairo_stroke (context);
				}
			}
		}
	}
	_tmp50_ = self->priv->_page;
	_tmp51_ = page_get_is_scanning (_tmp50_);
	_tmp52_ = _tmp51_;
	if (_tmp52_) {
		Page* _tmp53_;
		gint _tmp54_;
		gint _tmp55_;
		_tmp53_ = self->priv->_page;
		_tmp54_ = page_get_scan_line (_tmp53_);
		_tmp55_ = _tmp54_;
		_tmp49_ = _tmp55_ > 0;
	} else {
		_tmp49_ = FALSE;
	}
	if (_tmp49_) {
		gint scan_line = 0;
		Page* _tmp56_;
		gint _tmp57_;
		gint _tmp58_;
		gdouble s = 0.0;
		gdouble x1 = 0.0;
		gdouble y1 = 0.0;
		gdouble x2 = 0.0;
		gdouble y2 = 0.0;
		Page* _tmp59_;
		ScanDirection _tmp60_;
		ScanDirection _tmp61_;
		gdouble _tmp85_;
		gdouble _tmp86_;
		gdouble _tmp87_;
		gdouble _tmp88_;
		_tmp56_ = self->priv->_page;
		_tmp57_ = page_get_scan_line (_tmp56_);
		_tmp58_ = _tmp57_;
		scan_line = _tmp58_;
		_tmp59_ = self->priv->_page;
		_tmp60_ = page_get_scan_direction (_tmp59_);
		_tmp61_ = _tmp60_;
		switch (_tmp61_) {
			case SCAN_DIRECTION_TOP_TO_BOTTOM:
			{
				gint _tmp62_;
				gdouble _tmp63_;
				gint _tmp64_;
				gdouble _tmp65_;
				_tmp62_ = scan_line;
				s = (gdouble) page_view_page_to_screen_y (self, _tmp62_);
				x1 = (gdouble) 0;
				_tmp63_ = s;
				y1 = _tmp63_ + 0.5;
				_tmp64_ = w;
				x2 = (gdouble) _tmp64_;
				_tmp65_ = s;
				y2 = _tmp65_ + 0.5;
				break;
			}
			case SCAN_DIRECTION_BOTTOM_TO_TOP:
			{
				gint _tmp66_;
				gint _tmp67_;
				gdouble _tmp68_;
				gint _tmp69_;
				gint _tmp70_;
				gdouble _tmp71_;
				_tmp66_ = scan_line;
				s = (gdouble) page_view_page_to_screen_y (self, _tmp66_);
				x1 = (gdouble) 0;
				_tmp67_ = h;
				_tmp68_ = s;
				y1 = (_tmp67_ - _tmp68_) + 0.5;
				_tmp69_ = w;
				x2 = (gdouble) _tmp69_;
				_tmp70_ = h;
				_tmp71_ = s;
				y2 = (_tmp70_ - _tmp71_) + 0.5;
				break;
			}
			case SCAN_DIRECTION_LEFT_TO_RIGHT:
			{
				gint _tmp72_;
				gdouble _tmp73_;
				gdouble _tmp74_;
				gint _tmp75_;
				_tmp72_ = scan_line;
				s = (gdouble) page_view_page_to_screen_x (self, _tmp72_);
				_tmp73_ = s;
				x1 = _tmp73_ + 0.5;
				y1 = (gdouble) 0;
				_tmp74_ = s;
				x2 = _tmp74_ + 0.5;
				_tmp75_ = h;
				y2 = (gdouble) _tmp75_;
				break;
			}
			case SCAN_DIRECTION_RIGHT_TO_LEFT:
			{
				gint _tmp76_;
				gint _tmp77_;
				gdouble _tmp78_;
				gint _tmp79_;
				gdouble _tmp80_;
				gint _tmp81_;
				_tmp76_ = scan_line;
				s = (gdouble) page_view_page_to_screen_x (self, _tmp76_);
				_tmp77_ = w;
				_tmp78_ = s;
				x1 = (_tmp77_ - _tmp78_) + 0.5;
				y1 = (gdouble) 0;
				_tmp79_ = w;
				_tmp80_ = s;
				x2 = (_tmp79_ - _tmp80_) + 0.5;
				_tmp81_ = h;
				y2 = (gdouble) _tmp81_;
				break;
			}
			default:
			{
				gdouble _tmp82_;
				gdouble _tmp83_;
				gdouble _tmp84_;
				y2 = (gdouble) 0;
				_tmp82_ = y2;
				x2 = _tmp82_;
				_tmp83_ = x2;
				y1 = _tmp83_;
				_tmp84_ = y1;
				x1 = _tmp84_;
				break;
			}
		}
		_tmp85_ = x1;
		_tmp86_ = y1;
		cairo_move_to (context, _tmp85_, _tmp86_);
		_tmp87_ = x2;
		_tmp88_ = y2;
		cairo_line_to (context, _tmp87_, _tmp88_);
		cairo_set_source_rgb (context, 1.0, 0.0, 0.0);
		cairo_stroke (context);
	}
	_tmp89_ = self->priv->_page;
	_tmp90_ = page_get_has_crop (_tmp89_);
	_tmp91_ = _tmp90_;
	if (_tmp91_) {
		gint x = 0;
		Page* _tmp92_;
		gint _tmp93_;
		gint _tmp94_;
		gint y = 0;
		Page* _tmp95_;
		gint _tmp96_;
		gint _tmp97_;
		gint crop_width = 0;
		Page* _tmp98_;
		gint _tmp99_;
		gint _tmp100_;
		gint crop_height = 0;
		Page* _tmp101_;
		gint _tmp102_;
		gint _tmp103_;
		gint dx = 0;
		gint _tmp104_;
		gint dy = 0;
		gint _tmp105_;
		gint dw = 0;
		gint _tmp106_;
		gint dh = 0;
		gint _tmp107_;
		gint _tmp108_;
		gint _tmp109_;
		gint _tmp110_;
		gint _tmp111_;
		gint _tmp112_;
		gint _tmp113_;
		gint _tmp114_;
		gint _tmp115_;
		gint _tmp116_;
		gint _tmp117_;
		gint _tmp118_;
		gint _tmp119_;
		gint _tmp120_;
		gint _tmp121_;
		_tmp92_ = self->priv->_page;
		_tmp93_ = page_get_crop_x (_tmp92_);
		_tmp94_ = _tmp93_;
		x = _tmp94_;
		_tmp95_ = self->priv->_page;
		_tmp96_ = page_get_crop_y (_tmp95_);
		_tmp97_ = _tmp96_;
		y = _tmp97_;
		_tmp98_ = self->priv->_page;
		_tmp99_ = page_get_crop_width (_tmp98_);
		_tmp100_ = _tmp99_;
		crop_width = _tmp100_;
		_tmp101_ = self->priv->_page;
		_tmp102_ = page_get_crop_height (_tmp101_);
		_tmp103_ = _tmp102_;
		crop_height = _tmp103_;
		_tmp104_ = x;
		dx = page_view_page_to_screen_x (self, _tmp104_);
		_tmp105_ = y;
		dy = page_view_page_to_screen_y (self, _tmp105_);
		_tmp106_ = crop_width;
		dw = page_view_page_to_screen_x (self, _tmp106_);
		_tmp107_ = crop_height;
		dh = page_view_page_to_screen_y (self, _tmp107_);
		_tmp108_ = w;
		_tmp109_ = h;
		cairo_rectangle (context, (gdouble) 0, (gdouble) 0, (gdouble) _tmp108_, (gdouble) _tmp109_);
		cairo_new_sub_path (context);
		_tmp110_ = dx;
		_tmp111_ = dy;
		_tmp112_ = dw;
		_tmp113_ = dh;
		cairo_rectangle (context, (gdouble) _tmp110_, (gdouble) _tmp111_, (gdouble) _tmp112_, (gdouble) _tmp113_);
		cairo_set_fill_rule (context, CAIRO_FILL_RULE_EVEN_ODD);
		cairo_set_source_rgba (context, 0.25, 0.25, 0.25, 0.2);
		cairo_fill (context);
		_tmp114_ = dx;
		_tmp115_ = dy;
		_tmp116_ = dw;
		_tmp117_ = dh;
		cairo_rectangle (context, _tmp114_ - 1.5, _tmp115_ - 1.5, (gdouble) (_tmp116_ + 3), (gdouble) (_tmp117_ + 3));
		cairo_set_source_rgb (context, 1.0, 1.0, 1.0);
		cairo_stroke (context);
		_tmp118_ = dx;
		_tmp119_ = dy;
		_tmp120_ = dw;
		_tmp121_ = dh;
		cairo_rectangle (context, _tmp118_ - 0.5, _tmp119_ - 0.5, (gdouble) (_tmp120_ + 1), (gdouble) (_tmp121_ + 1));
		cairo_set_source_rgb (context, 0.0, 0.0, 0.0);
		cairo_stroke (context);
	}
}


static void
page_view_page_pixels_changed_cb (PageView* self,
                                  Page* p)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (p != NULL);
	self->priv->update_image = TRUE;
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
}


static void
page_view_page_size_changed_cb (PageView* self,
                                Page* p)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (p != NULL);
	self->priv->update_image = TRUE;
	g_signal_emit (self, page_view_signals[PAGE_VIEW_SIZE_CHANGED_SIGNAL], 0);
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
}


static void
page_view_page_overlay_changed_cb (PageView* self,
                                   Page* p)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (p != NULL);
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
}


static void
page_view_scan_direction_changed_cb (PageView* self,
                                     Page* p)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (p != NULL);
	self->priv->update_image = TRUE;
	g_signal_emit (self, page_view_signals[PAGE_VIEW_SIZE_CHANGED_SIGNAL], 0);
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
}


Page*
page_view_get_page (PageView* self)
{
	Page* result;
	Page* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_page;
	result = _tmp0_;
	return result;
}


static gpointer
_page_ref0 (gpointer self)
{
	return self ? page_ref (self) : NULL;
}


static void
page_view_set_page (PageView* self,
                    Page* value)
{
	Page* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _page_ref0 (value);
	_page_unref0 (self->priv->_page);
	self->priv->_page = _tmp0_;
}


gboolean
page_view_get_selected (PageView* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->selected_;
	result = _tmp0_;
	return result;
}


void
page_view_set_selected (PageView* self,
                        gboolean value)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	g_return_if_fail (self != NULL);
	_tmp2_ = page_view_get_selected (self);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		gboolean _tmp4_;
		gboolean _tmp5_;
		_tmp4_ = page_view_get_selected (self);
		_tmp5_ = _tmp4_;
		_tmp1_ = _tmp5_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_;
		gboolean _tmp8_;
		_tmp7_ = page_view_get_selected (self);
		_tmp8_ = _tmp7_;
		if (!_tmp8_) {
			gboolean _tmp9_;
			gboolean _tmp10_;
			_tmp9_ = page_view_get_selected (self);
			_tmp10_ = _tmp9_;
			_tmp6_ = !_tmp10_;
		} else {
			_tmp6_ = FALSE;
		}
		_tmp0_ = _tmp6_;
	}
	if (_tmp0_) {
		return;
	}
	_tmp11_ = page_view_get_selected (self);
	_tmp12_ = _tmp11_;
	page_view_set_selected (self, _tmp12_);
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
}


gint
page_view_get_x_offset (PageView* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_x_offset;
	result = _tmp0_;
	return result;
}


void
page_view_set_x_offset (PageView* self,
                        gint value)
{
	g_return_if_fail (self != NULL);
	self->priv->_x_offset = value;
}


gint
page_view_get_y_offset (PageView* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_y_offset;
	result = _tmp0_;
	return result;
}


void
page_view_set_y_offset (PageView* self,
                        gint value)
{
	g_return_if_fail (self != NULL);
	self->priv->_y_offset = value;
}


GdkCursorType
page_view_get_cursor (PageView* self)
{
	GdkCursorType result;
	GdkCursorType _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_cursor;
	result = _tmp0_;
	return result;
}


static void
page_view_set_cursor (PageView* self,
                      GdkCursorType value)
{
	g_return_if_fail (self != NULL);
	self->priv->_cursor = value;
}


gint
page_view_get_width (PageView* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->width_;
	result = _tmp0_;
	return result;
}


void
page_view_set_width (PageView* self,
                     gint value)
{
	gint h = 0;
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	Page* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gboolean _tmp6_ = FALSE;
	gint _tmp7_;
	gint _tmp10_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_page;
	_tmp1_ = page_get_height (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->_page;
	_tmp4_ = page_get_width (_tmp3_);
	_tmp5_ = _tmp4_;
	h = (gint) ((((gdouble) value) * _tmp2_) / _tmp5_);
	_tmp7_ = self->priv->width_;
	if (_tmp7_ == value) {
		gint _tmp8_;
		gint _tmp9_;
		_tmp8_ = self->priv->height_;
		_tmp9_ = h;
		_tmp6_ = _tmp8_ == _tmp9_;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		return;
	}
	self->priv->width_ = value;
	_tmp10_ = h;
	self->priv->height_ = _tmp10_;
	self->priv->update_image = TRUE;
	g_signal_emit (self, page_view_signals[PAGE_VIEW_SIZE_CHANGED_SIGNAL], 0);
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
}


gint
page_view_get_height (PageView* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->height_;
	result = _tmp0_;
	return result;
}


void
page_view_set_height (PageView* self,
                      gint value)
{
	gint w = 0;
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	Page* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gboolean _tmp6_ = FALSE;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp10_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_page;
	_tmp1_ = page_get_width (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->_page;
	_tmp4_ = page_get_height (_tmp3_);
	_tmp5_ = _tmp4_;
	w = (gint) ((((gdouble) value) * _tmp2_) / _tmp5_);
	_tmp7_ = self->priv->width_;
	_tmp8_ = w;
	if (_tmp7_ == _tmp8_) {
		gint _tmp9_;
		_tmp9_ = self->priv->height_;
		_tmp6_ = _tmp9_ == value;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		return;
	}
	_tmp10_ = w;
	self->priv->width_ = _tmp10_;
	self->priv->height_ = value;
	self->priv->update_image = TRUE;
	g_signal_emit (self, page_view_signals[PAGE_VIEW_SIZE_CHANGED_SIGNAL], 0);
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
}


static void
value_page_view_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}


static void
value_page_view_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		page_view_unref (value->data[0].v_pointer);
	}
}


static void
value_page_view_copy_value (const GValue* src_value,
                            GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = page_view_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer
value_page_view_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}


static gchar*
value_page_view_collect_value (GValue* value,
                               guint n_collect_values,
                               GTypeCValue* collect_values,
                               guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		PageView * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = page_view_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar*
value_page_view_lcopy_value (const GValue* value,
                             guint n_collect_values,
                             GTypeCValue* collect_values,
                             guint collect_flags)
{
	PageView ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = page_view_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec*
param_spec_page_view (const gchar* name,
                      const gchar* nick,
                      const gchar* blurb,
                      GType object_type,
                      GParamFlags flags)
{
	ParamSpecPageView* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PAGE_VIEW), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer
value_get_page_view (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PAGE_VIEW), NULL);
	return value->data[0].v_pointer;
}


void
value_set_page_view (GValue* value,
                     gpointer v_object)
{
	PageView * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PAGE_VIEW));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PAGE_VIEW));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		page_view_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		page_view_unref (old);
	}
}


void
value_take_page_view (GValue* value,
                      gpointer v_object)
{
	PageView * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PAGE_VIEW));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PAGE_VIEW));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		page_view_unref (old);
	}
}


static void
page_view_class_init (PageViewClass * klass)
{
	page_view_parent_class = g_type_class_peek_parent (klass);
	((PageViewClass *) klass)->finalize = page_view_finalize;
	g_type_class_add_private (klass, sizeof (PageViewPrivate));
	page_view_signals[PAGE_VIEW_SIZE_CHANGED_SIGNAL] = g_signal_new ("size-changed", TYPE_PAGE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	page_view_signals[PAGE_VIEW_CHANGED_SIGNAL] = g_signal_new ("changed", TYPE_PAGE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void
page_view_instance_init (PageView * self)
{
	self->priv = PAGE_VIEW_GET_PRIVATE (self);
	self->priv->image = NULL;
	self->priv->selected_ = FALSE;
	self->priv->border_width = 1;
	self->priv->update_image = TRUE;
	self->priv->_cursor = GDK_ARROW;
	self->priv->animate_n_segments = 7;
	self->ref_count = 1;
}


static void
page_view_finalize (PageView * obj)
{
	PageView * self;
	Page* _tmp0_;
	guint _tmp1_;
	Page* _tmp2_;
	guint _tmp3_;
	Page* _tmp4_;
	guint _tmp5_;
	Page* _tmp6_;
	guint _tmp7_;
	Page* _tmp8_;
	guint _tmp9_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PAGE_VIEW, PageView);
	g_signal_handlers_destroy (self);
	_tmp0_ = self->priv->_page;
	g_signal_parse_name ("pixels-changed", TYPE_PAGE, &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _page_view_page_pixels_changed_cb_page_pixels_changed, self);
	_tmp2_ = self->priv->_page;
	g_signal_parse_name ("size-changed", TYPE_PAGE, &_tmp3_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _page_view_page_size_changed_cb_page_size_changed, self);
	_tmp4_ = self->priv->_page;
	g_signal_parse_name ("crop-changed", TYPE_PAGE, &_tmp5_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _page_view_page_overlay_changed_cb_page_crop_changed, self);
	_tmp6_ = self->priv->_page;
	g_signal_parse_name ("scan-line-changed", TYPE_PAGE, &_tmp7_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _page_view_page_overlay_changed_cb_page_scan_line_changed, self);
	_tmp8_ = self->priv->_page;
	g_signal_parse_name ("scan-direction-changed", TYPE_PAGE, &_tmp9_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _page_view_scan_direction_changed_cb_page_scan_direction_changed, self);
	_page_unref0 (self->priv->_page);
	_g_object_unref0 (self->priv->image);
}


GType
page_view_get_type (void)
{
	static volatile gsize page_view_type_id__volatile = 0;
	if (g_once_init_enter (&page_view_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_page_view_init, value_page_view_free_value, value_page_view_copy_value, value_page_view_peek_pointer, "p", value_page_view_collect_value, "p", value_page_view_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PageViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) page_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PageView), 0, (GInstanceInitFunc) page_view_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType page_view_type_id;
		page_view_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PageView", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&page_view_type_id__volatile, page_view_type_id);
	}
	return page_view_type_id__volatile;
}


gpointer
page_view_ref (gpointer instance)
{
	PageView * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void
page_view_unref (gpointer instance)
{
	PageView * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		PAGE_VIEW_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}



