/* page.c generated by valac 0.40.8, the Vala compiler
 * generated from page.vala, do not modify */

/*
 * Copyright (C) 2009-2015 Canonical Ltd.
 * Author: Robert Ancell <robert.ancell@canonical.com>
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <glib/gstdio.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gio/gio.h>
#include <gobject/gvaluecollector.h>


#define TYPE_SCAN_DIRECTION (scan_direction_get_type ())

#define TYPE_PAGE (page_get_type ())
#define PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE, Page))
#define PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE, PageClass))
#define IS_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE))
#define IS_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE))
#define PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE, PageClass))

typedef struct _Page Page;
typedef struct _PageClass PageClass;
typedef struct _PagePrivate PagePrivate;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_SCAN_PAGE_INFO (scan_page_info_get_type ())
#define SCAN_PAGE_INFO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SCAN_PAGE_INFO, ScanPageInfo))
#define SCAN_PAGE_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SCAN_PAGE_INFO, ScanPageInfoClass))
#define IS_SCAN_PAGE_INFO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SCAN_PAGE_INFO))
#define IS_SCAN_PAGE_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SCAN_PAGE_INFO))
#define SCAN_PAGE_INFO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SCAN_PAGE_INFO, ScanPageInfoClass))

typedef struct _ScanPageInfo ScanPageInfo;
typedef struct _ScanPageInfoClass ScanPageInfoClass;
typedef struct _ScanPageInfoPrivate ScanPageInfoPrivate;

#define TYPE_SCAN_LINE (scan_line_get_type ())
#define SCAN_LINE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SCAN_LINE, ScanLine))
#define SCAN_LINE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SCAN_LINE, ScanLineClass))
#define IS_SCAN_LINE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SCAN_LINE))
#define IS_SCAN_LINE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SCAN_LINE))
#define SCAN_LINE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SCAN_LINE, ScanLineClass))

typedef struct _ScanLine ScanLine;
typedef struct _ScanLineClass ScanLineClass;
typedef struct _ScanLinePrivate ScanLinePrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block6Data Block6Data;
#define _page_unref0(var) ((var == NULL) ? NULL : (var = (page_unref (var), NULL)))
typedef struct _ParamSpecPage ParamSpecPage;
enum  {
	PAGE_PIXELS_CHANGED_SIGNAL,
	PAGE_SIZE_CHANGED_SIGNAL,
	PAGE_SCAN_LINE_CHANGED_SIGNAL,
	PAGE_SCAN_DIRECTION_CHANGED_SIGNAL,
	PAGE_CROP_CHANGED_SIGNAL,
	PAGE_SCAN_FINISHED_SIGNAL,
	PAGE_NUM_SIGNALS
};
static guint page_signals[PAGE_NUM_SIGNALS] = {0};

typedef enum  {
	SCAN_DIRECTION_TOP_TO_BOTTOM,
	SCAN_DIRECTION_LEFT_TO_RIGHT,
	SCAN_DIRECTION_BOTTOM_TO_TOP,
	SCAN_DIRECTION_RIGHT_TO_LEFT
} ScanDirection;

struct _Page {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PagePrivate * priv;
};

struct _PageClass {
	GTypeClass parent_class;
	void (*finalize) (Page *self);
};

struct _PagePrivate {
	gint _dpi;
	gint expected_rows;
	gint _depth;
	gchar* _color_profile;
	gint _scan_width;
	gint _scan_height;
	gint _rowstride;
	gint _n_channels;
	guchar* pixels;
	gint pixels_length1;
	gint _pixels_size_;
	gboolean _is_scanning;
	gboolean _has_data;
	gint _scan_line;
	ScanDirection scan_direction_;
	gboolean _has_crop;
	gchar* _crop_name;
	gint _crop_x;
	gint _crop_y;
	gint _crop_width;
	gint _crop_height;
};

struct _ScanPageInfo {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ScanPageInfoPrivate * priv;
	gint width;
	gint height;
	gint depth;
	gint n_channels;
	gdouble dpi;
	gchar* device;
};

struct _ScanPageInfoClass {
	GTypeClass parent_class;
	void (*finalize) (ScanPageInfo *self);
};

struct _ScanLine {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ScanLinePrivate * priv;
	gint number;
	gint n_lines;
	gint width;
	gint depth;
	gint channel;
	guchar* data;
	gint data_length1;
	gint data_length;
};

struct _ScanLineClass {
	GTypeClass parent_class;
	void (*finalize) (ScanLine *self);
};

struct _Block6Data {
	int _ref_count_;
	Page* self;
	GFileOutputStream* stream;
};

struct _ParamSpecPage {
	GParamSpec parent_instance;
};


static gpointer page_parent_class = NULL;

GType scan_direction_get_type (void) G_GNUC_CONST;
gpointer page_ref (gpointer instance);
void page_unref (gpointer instance);
GParamSpec* param_spec_page (const gchar* name,
                             const gchar* nick,
                             const gchar* blurb,
                             GType object_type,
                             GParamFlags flags);
void value_set_page (GValue* value,
                     gpointer v_object);
void value_take_page (GValue* value,
                      gpointer v_object);
gpointer value_get_page (const GValue* value);
GType page_get_type (void) G_GNUC_CONST;
#define PAGE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PAGE, PagePrivate))
Page* page_new (gint width,
                gint height,
                gint dpi,
                ScanDirection scan_direction);
Page* page_construct (GType object_type,
                      gint width,
                      gint height,
                      gint dpi,
                      ScanDirection scan_direction);
static void page_set_scan_width (Page* self,
                          gint value);
static void page_set_scan_height (Page* self,
                           gint value);
static void page_set_dpi (Page* self,
                   gint value);
void page_set_scan_direction (Page* self,
                              ScanDirection value);
Page* page_new_from_data (gint scan_width,
                          gint scan_height,
                          gint rowstride,
                          gint n_channels,
                          gint depth,
                          gint dpi,
                          ScanDirection scan_direction,
                          const gchar* color_profile,
                          guchar* pixels,
                          int pixels_length1,
                          gboolean has_crop,
                          const gchar* crop_name,
                          gint crop_x,
                          gint crop_y,
                          gint crop_width,
                          gint crop_height);
Page* page_construct_from_data (GType object_type,
                                gint scan_width,
                                gint scan_height,
                                gint rowstride,
                                gint n_channels,
                                gint depth,
                                gint dpi,
                                ScanDirection scan_direction,
                                const gchar* color_profile,
                                guchar* pixels,
                                int pixels_length1,
                                gboolean has_crop,
                                const gchar* crop_name,
                                gint crop_x,
                                gint crop_y,
                                gint crop_width,
                                gint crop_height);
static void page_set_rowstride (Page* self,
                         gint value);
static void page_set_n_channels (Page* self,
                          gint value);
static void page_set_depth (Page* self,
                     gint value);
void page_set_color_profile (Page* self,
                             const gchar* value);
static guchar* _vala_array_dup5 (guchar* self,
                          int length);
static void page_set_has_data (Page* self,
                        gboolean value);
static void page_set_has_crop (Page* self,
                        gboolean value);
static void page_set_crop_name (Page* self,
                         const gchar* value);
static void page_set_crop_x (Page* self,
                      gint value);
static void page_set_crop_y (Page* self,
                      gint value);
static void page_set_crop_width (Page* self,
                          gint value);
static void page_set_crop_height (Page* self,
                           gint value);
gpointer scan_page_info_ref (gpointer instance);
void scan_page_info_unref (gpointer instance);
GParamSpec* param_spec_scan_page_info (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_scan_page_info (GValue* value,
                               gpointer v_object);
void value_take_scan_page_info (GValue* value,
                                gpointer v_object);
gpointer value_get_scan_page_info (const GValue* value);
GType scan_page_info_get_type (void) G_GNUC_CONST;
void page_set_page_info (Page* self,
                         ScanPageInfo* info);
gint page_get_scan_height (Page* self);
gint page_get_scan_width (Page* self);
gint page_get_depth (Page* self);
gint page_get_n_channels (Page* self);
gint page_get_rowstride (Page* self);
void page_start (Page* self);
static void page_set_is_scanning (Page* self,
                           gboolean value);
gpointer scan_line_ref (gpointer instance);
void scan_line_unref (gpointer instance);
GParamSpec* param_spec_scan_line (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
void value_set_scan_line (GValue* value,
                          gpointer v_object);
void value_take_scan_line (GValue* value,
                           gpointer v_object);
gpointer value_get_scan_line (const GValue* value);
GType scan_line_get_type (void) G_GNUC_CONST;
static void page_parse_line (Page* self,
                      ScanLine* line,
                      gint n,
                      gboolean* size_changed);
static void page_set_scan_line (Page* self,
                         gint value);
void page_parse_scan_line (Page* self,
                           ScanLine* line);
void page_finish (Page* self);
gint page_get_scan_line (Page* self);
void page_rotate_left (Page* self);
ScanDirection page_get_scan_direction (Page* self);
void page_rotate_right (Page* self);
void page_set_no_crop (Page* self);
gboolean page_get_has_crop (Page* self);
void page_set_custom_crop (Page* self,
                           gint width,
                           gint height);
const gchar* page_get_crop_name (Page* self);
gint page_get_crop_width (Page* self);
gint page_get_crop_height (Page* self);
void page_set_named_crop (Page* self,
                          const gchar* name);
gint page_get_width (Page* self);
gint page_get_height (Page* self);
gint page_get_dpi (Page* self);
void page_move_crop (Page* self,
                     gint x,
                     gint y);
void page_rotate_crop (Page* self);
gint page_get_crop_x (Page* self);
gint page_get_crop_y (Page* self);
guchar* page_get_pixels (Page* self,
                         int* result_length1);
static guchar page_get_sample (Page* self,
                        guchar* pixels,
                        int pixels_length1,
                        gint offset,
                        gint x,
                        gint depth,
                        gint n_channels,
                        gint channel);
static void page_get_pixel (Page* self,
                     gint x,
                     gint y,
                     guchar* pixel,
                     int pixel_length1,
                     gint offset);
GdkPixbuf* page_get_image (Page* self,
                           gboolean apply_crop);
gchar* page_get_icc_data_encoded (Page* self);
const gchar* page_get_color_profile (Page* self);
void page_copy_to_clipboard (Page* self,
                             GtkWindow* window);
void page_save_png (Page* self,
                    GFile* file,
                    GError** error);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static gboolean __lambda17_ (Block6Data* _data6_,
                      guint8* buf,
                      int buf_length1,
                      GError** error);
static gboolean ___lambda17__gdk_pixbuf_save_func (guint8* buf,
                                            gsize buf_length1,
                                            GError** error,
                                            gpointer self);
gboolean page_get_is_landscape (Page* self);
gboolean page_get_is_scanning (Page* self);
gboolean page_get_has_data (Page* self);
gboolean page_get_is_color (Page* self);
static void page_finalize (Page * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


GType
scan_direction_get_type (void)
{
	static volatile gsize scan_direction_type_id__volatile = 0;
	if (g_once_init_enter (&scan_direction_type_id__volatile)) {
		static const GEnumValue values[] = {{SCAN_DIRECTION_TOP_TO_BOTTOM, "SCAN_DIRECTION_TOP_TO_BOTTOM", "top-to-bottom"}, {SCAN_DIRECTION_LEFT_TO_RIGHT, "SCAN_DIRECTION_LEFT_TO_RIGHT", "left-to-right"}, {SCAN_DIRECTION_BOTTOM_TO_TOP, "SCAN_DIRECTION_BOTTOM_TO_TOP", "bottom-to-top"}, {SCAN_DIRECTION_RIGHT_TO_LEFT, "SCAN_DIRECTION_RIGHT_TO_LEFT", "right-to-left"}, {0, NULL, NULL}};
		GType scan_direction_type_id;
		scan_direction_type_id = g_enum_register_static ("ScanDirection", values);
		g_once_init_leave (&scan_direction_type_id__volatile, scan_direction_type_id);
	}
	return scan_direction_type_id__volatile;
}


Page*
page_construct (GType object_type,
                gint width,
                gint height,
                gint dpi,
                ScanDirection scan_direction)
{
	Page* self = NULL;
	gboolean _tmp0_ = FALSE;
	self = (Page*) g_type_create_instance (object_type);
	if (scan_direction == SCAN_DIRECTION_TOP_TO_BOTTOM) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = scan_direction == SCAN_DIRECTION_BOTTOM_TO_TOP;
	}
	if (_tmp0_) {
		page_set_scan_width (self, width);
		page_set_scan_height (self, height);
	} else {
		page_set_scan_width (self, height);
		page_set_scan_height (self, width);
	}
	page_set_dpi (self, dpi);
	page_set_scan_direction (self, scan_direction);
	return self;
}


Page*
page_new (gint width,
          gint height,
          gint dpi,
          ScanDirection scan_direction)
{
	return page_construct (TYPE_PAGE, width, height, dpi, scan_direction);
}


static guchar*
_vala_array_dup5 (guchar* self,
                  int length)
{
	return g_memdup (self, length * sizeof (guchar));
}


Page*
page_construct_from_data (GType object_type,
                          gint scan_width,
                          gint scan_height,
                          gint rowstride,
                          gint n_channels,
                          gint depth,
                          gint dpi,
                          ScanDirection scan_direction,
                          const gchar* color_profile,
                          guchar* pixels,
                          int pixels_length1,
                          gboolean has_crop,
                          const gchar* crop_name,
                          gint crop_x,
                          gint crop_y,
                          gint crop_width,
                          gint crop_height)
{
	Page* self = NULL;
	guchar* _tmp0_;
	gint _tmp0__length1;
	self = (Page*) g_type_create_instance (object_type);
	page_set_scan_width (self, scan_width);
	page_set_scan_height (self, scan_height);
	self->priv->expected_rows = scan_height;
	page_set_rowstride (self, rowstride);
	page_set_n_channels (self, n_channels);
	page_set_depth (self, depth);
	page_set_dpi (self, dpi);
	page_set_scan_direction (self, scan_direction);
	page_set_color_profile (self, color_profile);
	_tmp0_ = (pixels != NULL) ? _vala_array_dup5 (pixels, pixels_length1) : ((gpointer) pixels);
	_tmp0__length1 = pixels_length1;
	self->priv->pixels = (g_free (self->priv->pixels), NULL);
	self->priv->pixels = _tmp0_;
	self->priv->pixels_length1 = _tmp0__length1;
	self->priv->_pixels_size_ = self->priv->pixels_length1;
	page_set_has_data (self, pixels != NULL);
	page_set_has_crop (self, has_crop);
	page_set_crop_name (self, crop_name);
	page_set_crop_x (self, crop_x);
	page_set_crop_y (self, crop_y);
	page_set_crop_width (self, crop_width);
	page_set_crop_height (self, crop_height);
	return self;
}


Page*
page_new_from_data (gint scan_width,
                    gint scan_height,
                    gint rowstride,
                    gint n_channels,
                    gint depth,
                    gint dpi,
                    ScanDirection scan_direction,
                    const gchar* color_profile,
                    guchar* pixels,
                    int pixels_length1,
                    gboolean has_crop,
                    const gchar* crop_name,
                    gint crop_x,
                    gint crop_y,
                    gint crop_width,
                    gint crop_height)
{
	return page_construct_from_data (TYPE_PAGE, scan_width, scan_height, rowstride, n_channels, depth, dpi, scan_direction, color_profile, pixels, pixels_length1, has_crop, crop_name, crop_x, crop_y, crop_width, crop_height);
}


void
page_set_page_info (Page* self,
                    ScanPageInfo* info)
{
	gint _tmp0_;
	gdouble _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	guchar* _tmp14_;
	gint _tmp14__length1;
	gint _tmp15_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (info != NULL);
	_tmp0_ = info->height;
	self->priv->expected_rows = _tmp0_;
	_tmp1_ = info->dpi;
	page_set_dpi (self, (gint) _tmp1_);
	_tmp2_ = info->width;
	page_set_scan_width (self, _tmp2_);
	_tmp3_ = info->height;
	page_set_scan_height (self, _tmp3_);
	_tmp4_ = self->priv->_scan_height;
	if (_tmp4_ < 0) {
		gint _tmp5_;
		_tmp5_ = self->priv->_scan_width;
		page_set_scan_height (self, _tmp5_ / 2);
	}
	_tmp6_ = info->depth;
	page_set_depth (self, _tmp6_);
	_tmp7_ = info->n_channels;
	page_set_n_channels (self, _tmp7_);
	_tmp8_ = self->priv->_scan_width;
	_tmp9_ = self->priv->_depth;
	_tmp10_ = self->priv->_n_channels;
	page_set_rowstride (self, (((_tmp8_ * _tmp9_) * _tmp10_) + 7) / 8);
	_tmp11_ = self->priv->_scan_height;
	_tmp12_ = self->priv->_rowstride;
	_tmp13_ = _tmp11_ * _tmp12_;
	self->priv->pixels = g_renew (guchar, self->priv->pixels, _tmp11_ * _tmp12_);
	(_tmp13_ > self->priv->pixels_length1) ? memset (self->priv->pixels + self->priv->pixels_length1, 0, sizeof (guchar) * (_tmp13_ - self->priv->pixels_length1)) : NULL;
	self->priv->pixels_length1 = _tmp13_;
	self->priv->_pixels_size_ = _tmp13_;
	_tmp14_ = self->priv->pixels;
	_tmp14__length1 = self->priv->pixels_length1;
	g_return_if_fail (_tmp14_ != NULL);
	_tmp15_ = self->priv->_depth;
	if (_tmp15_ == 1) {
		guchar* _tmp16_;
		gint _tmp16__length1;
		gint _tmp17_;
		gint _tmp18_;
		_tmp16_ = self->priv->pixels;
		_tmp16__length1 = self->priv->pixels_length1;
		_tmp17_ = self->priv->_scan_height;
		_tmp18_ = self->priv->_rowstride;
		memset (_tmp16_, 0x00, (gsize) (_tmp17_ * _tmp18_));
	} else {
		guchar* _tmp19_;
		gint _tmp19__length1;
		gint _tmp20_;
		gint _tmp21_;
		_tmp19_ = self->priv->pixels;
		_tmp19__length1 = self->priv->pixels_length1;
		_tmp20_ = self->priv->_scan_height;
		_tmp21_ = self->priv->_rowstride;
		memset (_tmp19_, 0xFF, (gsize) (_tmp20_ * _tmp21_));
	}
	g_signal_emit (self, page_signals[PAGE_SIZE_CHANGED_SIGNAL], 0);
	g_signal_emit (self, page_signals[PAGE_PIXELS_CHANGED_SIGNAL], 0);
}


void
page_start (Page* self)
{
	g_return_if_fail (self != NULL);
	page_set_is_scanning (self, TRUE);
	g_signal_emit (self, page_signals[PAGE_SCAN_LINE_CHANGED_SIGNAL], 0);
}


static void
page_parse_line (Page* self,
                 ScanLine* line,
                 gint n,
                 gboolean* size_changed)
{
	gboolean _vala_size_changed = FALSE;
	gint line_number = 0;
	gint _tmp0_;
	gint offset = 0;
	gint _tmp11_;
	gint _tmp12_;
	gint line_offset = 0;
	gint _tmp13_;
	gint _tmp26_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (line != NULL);
	_tmp0_ = line->number;
	line_number = _tmp0_ + n;
	_vala_size_changed = FALSE;
	while (TRUE) {
		gint _tmp1_;
		gint _tmp2_;
		gint rows = 0;
		gint _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		_tmp1_ = line_number;
		_tmp2_ = self->priv->_scan_height;
		if (!(_tmp1_ >= _tmp2_)) {
			break;
		}
		_tmp3_ = self->priv->_scan_height;
		rows = _tmp3_;
		_tmp4_ = rows;
		_tmp5_ = self->priv->_scan_width;
		page_set_scan_height (self, _tmp4_ + (_tmp5_ / 2));
		_tmp6_ = rows;
		_tmp7_ = self->priv->_scan_height;
		g_debug ("page.vala:269: Extending image from %d lines to %d lines", _tmp6_, _tmp7_);
		_tmp8_ = self->priv->_scan_height;
		_tmp9_ = self->priv->_rowstride;
		_tmp10_ = _tmp8_ * _tmp9_;
		self->priv->pixels = g_renew (guchar, self->priv->pixels, _tmp8_ * _tmp9_);
		(_tmp10_ > self->priv->pixels_length1) ? memset (self->priv->pixels + self->priv->pixels_length1, 0, sizeof (guchar) * (_tmp10_ - self->priv->pixels_length1)) : NULL;
		self->priv->pixels_length1 = _tmp10_;
		self->priv->_pixels_size_ = _tmp10_;
		_vala_size_changed = TRUE;
	}
	_tmp11_ = line_number;
	_tmp12_ = self->priv->_rowstride;
	offset = _tmp11_ * _tmp12_;
	_tmp13_ = line->data_length;
	line_offset = n * _tmp13_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp14_ = FALSE;
			_tmp14_ = TRUE;
			while (TRUE) {
				gint _tmp16_;
				gint _tmp17_;
				guchar* _tmp18_;
				gint _tmp18__length1;
				gint _tmp19_;
				gint _tmp20_;
				guchar* _tmp21_;
				gint _tmp21__length1;
				gint _tmp22_;
				gint _tmp23_;
				guchar _tmp24_;
				guchar _tmp25_;
				if (!_tmp14_) {
					gint _tmp15_;
					_tmp15_ = i;
					i = _tmp15_ + 1;
				}
				_tmp14_ = FALSE;
				_tmp16_ = i;
				_tmp17_ = line->data_length;
				if (!(_tmp16_ < _tmp17_)) {
					break;
				}
				_tmp18_ = self->priv->pixels;
				_tmp18__length1 = self->priv->pixels_length1;
				_tmp19_ = offset;
				_tmp20_ = i;
				_tmp21_ = line->data;
				_tmp21__length1 = line->data_length1;
				_tmp22_ = line_offset;
				_tmp23_ = i;
				_tmp24_ = _tmp21_[_tmp22_ + _tmp23_];
				_tmp18_[_tmp19_ + _tmp20_] = _tmp24_;
				_tmp25_ = _tmp18_[_tmp19_ + _tmp20_];
			}
		}
	}
	_tmp26_ = line_number;
	page_set_scan_line (self, _tmp26_);
	if (size_changed) {
		*size_changed = _vala_size_changed;
	}
}


void
page_parse_scan_line (Page* self,
                      ScanLine* line)
{
	gboolean size_has_changed = FALSE;
	gboolean _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (line != NULL);
	size_has_changed = FALSE;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				gboolean _tmp5_ = FALSE;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = i;
				_tmp3_ = line->n_lines;
				if (!(_tmp2_ < _tmp3_)) {
					break;
				}
				_tmp4_ = i;
				page_parse_line (self, line, _tmp4_, &_tmp5_);
				size_has_changed = _tmp5_;
			}
		}
	}
	page_set_has_data (self, TRUE);
	_tmp6_ = size_has_changed;
	if (_tmp6_) {
		g_signal_emit (self, page_signals[PAGE_SIZE_CHANGED_SIGNAL], 0);
	}
	g_signal_emit (self, page_signals[PAGE_SCAN_LINE_CHANGED_SIGNAL], 0);
	g_signal_emit (self, page_signals[PAGE_PIXELS_CHANGED_SIGNAL], 0);
}


void
page_finish (Page* self)
{
	gboolean size_has_changed = FALSE;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gboolean _tmp11_;
	g_return_if_fail (self != NULL);
	size_has_changed = FALSE;
	_tmp1_ = self->priv->expected_rows;
	if (_tmp1_ < 0) {
		gint _tmp2_;
		gint _tmp3_;
		_tmp2_ = self->priv->_scan_line;
		_tmp3_ = self->priv->_scan_height;
		_tmp0_ = _tmp2_ != _tmp3_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gint rows = 0;
		gint _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		_tmp4_ = self->priv->_scan_height;
		rows = _tmp4_;
		_tmp5_ = self->priv->_scan_line;
		page_set_scan_height (self, _tmp5_);
		_tmp6_ = self->priv->_scan_height;
		_tmp7_ = self->priv->_rowstride;
		_tmp8_ = _tmp6_ * _tmp7_;
		self->priv->pixels = g_renew (guchar, self->priv->pixels, _tmp6_ * _tmp7_);
		(_tmp8_ > self->priv->pixels_length1) ? memset (self->priv->pixels + self->priv->pixels_length1, 0, sizeof (guchar) * (_tmp8_ - self->priv->pixels_length1)) : NULL;
		self->priv->pixels_length1 = _tmp8_;
		self->priv->_pixels_size_ = _tmp8_;
		_tmp9_ = rows;
		_tmp10_ = self->priv->_scan_height;
		g_debug ("page.vala:309: Trimming page from %d lines to %d lines", _tmp9_, _tmp10_);
		size_has_changed = TRUE;
	}
	page_set_is_scanning (self, FALSE);
	_tmp11_ = size_has_changed;
	if (_tmp11_) {
		g_signal_emit (self, page_signals[PAGE_SIZE_CHANGED_SIGNAL], 0);
	}
	g_signal_emit (self, page_signals[PAGE_SCAN_LINE_CHANGED_SIGNAL], 0);
	g_signal_emit (self, page_signals[PAGE_SCAN_FINISHED_SIGNAL], 0);
}


void
page_rotate_left (Page* self)
{
	ScanDirection _tmp0_;
	ScanDirection _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = page_get_scan_direction (self);
	_tmp1_ = _tmp0_;
	switch (_tmp1_) {
		case SCAN_DIRECTION_TOP_TO_BOTTOM:
		{
			page_set_scan_direction (self, SCAN_DIRECTION_LEFT_TO_RIGHT);
			break;
		}
		case SCAN_DIRECTION_LEFT_TO_RIGHT:
		{
			page_set_scan_direction (self, SCAN_DIRECTION_BOTTOM_TO_TOP);
			break;
		}
		case SCAN_DIRECTION_BOTTOM_TO_TOP:
		{
			page_set_scan_direction (self, SCAN_DIRECTION_RIGHT_TO_LEFT);
			break;
		}
		case SCAN_DIRECTION_RIGHT_TO_LEFT:
		{
			page_set_scan_direction (self, SCAN_DIRECTION_TOP_TO_BOTTOM);
			break;
		}
		default:
		break;
	}
}


void
page_rotate_right (Page* self)
{
	ScanDirection _tmp0_;
	ScanDirection _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = page_get_scan_direction (self);
	_tmp1_ = _tmp0_;
	switch (_tmp1_) {
		case SCAN_DIRECTION_TOP_TO_BOTTOM:
		{
			page_set_scan_direction (self, SCAN_DIRECTION_RIGHT_TO_LEFT);
			break;
		}
		case SCAN_DIRECTION_LEFT_TO_RIGHT:
		{
			page_set_scan_direction (self, SCAN_DIRECTION_TOP_TO_BOTTOM);
			break;
		}
		case SCAN_DIRECTION_BOTTOM_TO_TOP:
		{
			page_set_scan_direction (self, SCAN_DIRECTION_LEFT_TO_RIGHT);
			break;
		}
		case SCAN_DIRECTION_RIGHT_TO_LEFT:
		{
			page_set_scan_direction (self, SCAN_DIRECTION_BOTTOM_TO_TOP);
			break;
		}
		default:
		break;
	}
}


void
page_set_no_crop (Page* self)
{
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_has_crop;
	if (!_tmp0_) {
		return;
	}
	page_set_has_crop (self, FALSE);
	page_set_crop_name (self, NULL);
	page_set_crop_x (self, 0);
	page_set_crop_y (self, 0);
	page_set_crop_width (self, 0);
	page_set_crop_height (self, 0);
	g_signal_emit (self, page_signals[PAGE_CROP_CHANGED_SIGNAL], 0);
}


void
page_set_custom_crop (Page* self,
                      gint width,
                      gint height)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (width >= 1);
	g_return_if_fail (height >= 1);
	_tmp3_ = self->priv->_crop_name;
	if (_tmp3_ == NULL) {
		gboolean _tmp4_;
		_tmp4_ = self->priv->_has_crop;
		_tmp2_ = _tmp4_;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		gint _tmp5_;
		_tmp5_ = self->priv->_crop_width;
		_tmp1_ = _tmp5_ == width;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		gint _tmp6_;
		_tmp6_ = self->priv->_crop_height;
		_tmp0_ = _tmp6_ == height;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		return;
	}
	page_set_crop_name (self, NULL);
	page_set_has_crop (self, TRUE);
	page_set_crop_width (self, width);
	page_set_crop_height (self, height);
	g_signal_emit (self, page_signals[PAGE_CROP_CHANGED_SIGNAL], 0);
}


void
page_set_named_crop (Page* self,
                     const gchar* name)
{
	gdouble w = 0.0;
	gdouble h = 0.0;
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
	static GQuark _tmp1_label0 = 0;
	static GQuark _tmp1_label1 = 0;
	static GQuark _tmp1_label2 = 0;
	static GQuark _tmp1_label3 = 0;
	static GQuark _tmp1_label4 = 0;
	static GQuark _tmp1_label5 = 0;
	gint pw = 0;
	gint _tmp3_;
	gint _tmp4_;
	gint ph = 0;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gdouble _tmp12_;
	gint _tmp13_;
	gdouble _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gint _tmp20_;
	gint _tmp21_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	_tmp0_ = name;
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("A4")))) {
		switch (0) {
			default:
			{
				w = 8.3;
				h = 11.7;
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("A5")))) {
		switch (0) {
			default:
			{
				w = 5.8;
				h = 8.3;
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("A6")))) {
		switch (0) {
			default:
			{
				w = 4.1;
				h = 5.8;
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("letter")))) {
		switch (0) {
			default:
			{
				w = 8.5;
				h = (gdouble) 11;
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("legal")))) {
		switch (0) {
			default:
			{
				w = 8.5;
				h = (gdouble) 14;
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label5) ? _tmp1_label5 : (_tmp1_label5 = g_quark_from_static_string ("4x6")))) {
		switch (0) {
			default:
			{
				w = (gdouble) 4;
				h = (gdouble) 6;
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				g_warning ("page.vala:429: Unknown paper size '%s'", name);
				return;
			}
		}
	}
	page_set_crop_name (self, name);
	page_set_has_crop (self, TRUE);
	_tmp3_ = page_get_width (self);
	_tmp4_ = _tmp3_;
	pw = _tmp4_;
	_tmp5_ = page_get_height (self);
	_tmp6_ = _tmp5_;
	ph = _tmp6_;
	_tmp7_ = pw;
	_tmp8_ = ph;
	if (_tmp7_ > _tmp8_) {
		gdouble t = 0.0;
		gdouble _tmp9_;
		gdouble _tmp10_;
		gdouble _tmp11_;
		_tmp9_ = w;
		t = _tmp9_;
		_tmp10_ = h;
		w = _tmp10_;
		_tmp11_ = t;
		h = _tmp11_;
	}
	_tmp12_ = w;
	_tmp13_ = self->priv->_dpi;
	page_set_crop_width (self, (gint) ((_tmp12_ * _tmp13_) + 0.5));
	_tmp14_ = h;
	_tmp15_ = self->priv->_dpi;
	page_set_crop_height (self, (gint) ((_tmp14_ * _tmp15_) + 0.5));
	_tmp16_ = self->priv->_crop_width;
	_tmp17_ = pw;
	if (_tmp16_ < _tmp17_) {
		gint _tmp18_;
		gint _tmp19_;
		_tmp18_ = pw;
		_tmp19_ = self->priv->_crop_width;
		page_set_crop_x (self, (_tmp18_ - _tmp19_) / 2);
	} else {
		page_set_crop_x (self, 0);
	}
	_tmp20_ = self->priv->_crop_height;
	_tmp21_ = ph;
	if (_tmp20_ < _tmp21_) {
		gint _tmp22_;
		gint _tmp23_;
		_tmp22_ = ph;
		_tmp23_ = self->priv->_crop_height;
		page_set_crop_y (self, (_tmp22_ - _tmp23_) / 2);
	} else {
		page_set_crop_y (self, 0);
	}
	g_signal_emit (self, page_signals[PAGE_CROP_CHANGED_SIGNAL], 0);
}


void
page_move_crop (Page* self,
                gint x,
                gint y)
{
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (x >= 0);
	g_return_if_fail (y >= 0);
	_tmp0_ = page_get_width (self);
	_tmp1_ = _tmp0_;
	g_return_if_fail (x < _tmp1_);
	_tmp2_ = page_get_height (self);
	_tmp3_ = _tmp2_;
	g_return_if_fail (y < _tmp3_);
	page_set_crop_x (self, x);
	page_set_crop_y (self, y);
	g_signal_emit (self, page_signals[PAGE_CROP_CHANGED_SIGNAL], 0);
}


void
page_rotate_crop (Page* self)
{
	gboolean _tmp0_;
	gint t = 0;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	const gchar* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_has_crop;
	if (!_tmp0_) {
		return;
	}
	_tmp1_ = self->priv->_crop_width;
	t = _tmp1_;
	_tmp2_ = self->priv->_crop_height;
	page_set_crop_width (self, _tmp2_);
	_tmp3_ = t;
	page_set_crop_height (self, _tmp3_);
	_tmp4_ = self->priv->_crop_name;
	if (_tmp4_ == NULL) {
		gint w = 0;
		gint _tmp5_;
		gint _tmp6_;
		gint h = 0;
		gint _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		gint _tmp14_;
		gint _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
		gint _tmp21_;
		_tmp5_ = page_get_width (self);
		_tmp6_ = _tmp5_;
		w = _tmp6_;
		_tmp7_ = page_get_height (self);
		_tmp8_ = _tmp7_;
		h = _tmp8_;
		_tmp9_ = self->priv->_crop_x;
		_tmp10_ = self->priv->_crop_width;
		_tmp11_ = w;
		if ((_tmp9_ + _tmp10_) > _tmp11_) {
			gint _tmp12_;
			gint _tmp13_;
			_tmp12_ = w;
			_tmp13_ = self->priv->_crop_width;
			page_set_crop_x (self, _tmp12_ - _tmp13_);
		}
		_tmp14_ = self->priv->_crop_x;
		if (_tmp14_ < 0) {
			gint _tmp15_;
			page_set_crop_x (self, 0);
			_tmp15_ = w;
			page_set_crop_width (self, _tmp15_);
		}
		_tmp16_ = self->priv->_crop_y;
		_tmp17_ = self->priv->_crop_height;
		_tmp18_ = h;
		if ((_tmp16_ + _tmp17_) > _tmp18_) {
			gint _tmp19_;
			gint _tmp20_;
			_tmp19_ = h;
			_tmp20_ = self->priv->_crop_height;
			page_set_crop_y (self, _tmp19_ - _tmp20_);
		}
		_tmp21_ = self->priv->_crop_y;
		if (_tmp21_ < 0) {
			gint _tmp22_;
			page_set_crop_y (self, 0);
			_tmp22_ = h;
			page_set_crop_height (self, _tmp22_);
		}
	}
	g_signal_emit (self, page_signals[PAGE_CROP_CHANGED_SIGNAL], 0);
}


guchar*
page_get_pixels (Page* self,
                 int* result_length1)
{
	guchar* result = NULL;
	guchar* _tmp0_;
	gint _tmp0__length1;
	guchar* _tmp1_;
	gint _tmp1__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->pixels;
	_tmp0__length1 = self->priv->pixels_length1;
	_tmp1_ = _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	if (result_length1) {
		*result_length1 = _tmp1__length1;
	}
	result = _tmp1_;
	return result;
}


static guchar
page_get_sample (Page* self,
                 guchar* pixels,
                 int pixels_length1,
                 gint offset,
                 gint x,
                 gint depth,
                 gint n_channels,
                 gint channel)
{
	guchar result = '\0';
	g_return_val_if_fail (self != NULL, '\0');
	result = (guchar) 0xFF;
	return result;
}


static void
page_get_pixel (Page* self,
                gint x,
                gint y,
                guchar* pixel,
                int pixel_length1,
                gint offset)
{
	ScanDirection _tmp0_;
	ScanDirection _tmp1_;
	gint line_offset = 0;
	gint _tmp8_;
	gboolean _tmp9_ = FALSE;
	gint _tmp10_;
	guchar* _tmp61_;
	gint _tmp61__length1;
	gint _tmp62_;
	gint _tmp63_;
	gint _tmp64_;
	guchar _tmp65_;
	guchar* _tmp66_;
	gint _tmp66__length1;
	gint _tmp67_;
	gint _tmp68_;
	gint _tmp69_;
	guchar _tmp70_;
	guchar* _tmp71_;
	gint _tmp71__length1;
	gint _tmp72_;
	gint _tmp73_;
	gint _tmp74_;
	guchar _tmp75_;
	g_return_if_fail (self != NULL);
	_tmp0_ = page_get_scan_direction (self);
	_tmp1_ = _tmp0_;
	switch (_tmp1_) {
		case SCAN_DIRECTION_TOP_TO_BOTTOM:
		{
			break;
		}
		case SCAN_DIRECTION_BOTTOM_TO_TOP:
		{
			gint _tmp2_;
			gint _tmp3_;
			_tmp2_ = self->priv->_scan_width;
			x = (_tmp2_ - x) - 1;
			_tmp3_ = self->priv->_scan_height;
			y = (_tmp3_ - y) - 1;
			break;
		}
		case SCAN_DIRECTION_LEFT_TO_RIGHT:
		{
			gint t = 0;
			gint _tmp4_;
			gint _tmp5_;
			t = x;
			_tmp4_ = self->priv->_scan_width;
			x = (_tmp4_ - y) - 1;
			_tmp5_ = t;
			y = _tmp5_;
			break;
		}
		case SCAN_DIRECTION_RIGHT_TO_LEFT:
		{
			gint t = 0;
			gint _tmp6_;
			gint _tmp7_;
			t = x;
			x = y;
			_tmp6_ = self->priv->_scan_height;
			_tmp7_ = t;
			y = (_tmp6_ - _tmp7_) - 1;
			break;
		}
		default:
		break;
	}
	_tmp8_ = self->priv->_rowstride;
	line_offset = _tmp8_ * y;
	_tmp10_ = self->priv->_depth;
	if (_tmp10_ == 8) {
		gint _tmp11_;
		_tmp11_ = self->priv->_n_channels;
		_tmp9_ = _tmp11_ == 3;
	} else {
		_tmp9_ = FALSE;
	}
	if (_tmp9_) {
		gint o = 0;
		gint _tmp12_;
		gint _tmp13_;
		guchar* _tmp14_;
		gint _tmp14__length1;
		gint _tmp15_;
		guchar _tmp16_;
		guchar _tmp17_;
		guchar* _tmp18_;
		gint _tmp18__length1;
		gint _tmp19_;
		guchar _tmp20_;
		guchar _tmp21_;
		guchar* _tmp22_;
		gint _tmp22__length1;
		gint _tmp23_;
		guchar _tmp24_;
		guchar _tmp25_;
		_tmp12_ = line_offset;
		_tmp13_ = self->priv->_n_channels;
		o = _tmp12_ + (x * _tmp13_);
		_tmp14_ = self->priv->pixels;
		_tmp14__length1 = self->priv->pixels_length1;
		_tmp15_ = o;
		_tmp16_ = _tmp14_[_tmp15_];
		pixel[offset + 0] = _tmp16_;
		_tmp17_ = pixel[offset + 0];
		_tmp18_ = self->priv->pixels;
		_tmp18__length1 = self->priv->pixels_length1;
		_tmp19_ = o;
		_tmp20_ = _tmp18_[_tmp19_ + 1];
		pixel[offset + 1] = _tmp20_;
		_tmp21_ = pixel[offset + 1];
		_tmp22_ = self->priv->pixels;
		_tmp22__length1 = self->priv->pixels_length1;
		_tmp23_ = o;
		_tmp24_ = _tmp22_[_tmp23_ + 2];
		pixel[offset + 2] = _tmp24_;
		_tmp25_ = pixel[offset + 2];
		return;
	} else {
		gboolean _tmp26_ = FALSE;
		gint _tmp27_;
		_tmp27_ = self->priv->_depth;
		if (_tmp27_ == 8) {
			gint _tmp28_;
			_tmp28_ = self->priv->_n_channels;
			_tmp26_ = _tmp28_ == 1;
		} else {
			_tmp26_ = FALSE;
		}
		if (_tmp26_) {
			guchar p = '\0';
			guchar* _tmp29_;
			gint _tmp29__length1;
			gint _tmp30_;
			guchar _tmp31_;
			guchar _tmp32_;
			guchar _tmp33_;
			guchar _tmp34_;
			guchar _tmp35_;
			_tmp29_ = self->priv->pixels;
			_tmp29__length1 = self->priv->pixels_length1;
			_tmp30_ = line_offset;
			_tmp31_ = _tmp29_[_tmp30_ + x];
			p = _tmp31_;
			_tmp32_ = p;
			pixel[offset + 2] = _tmp32_;
			_tmp33_ = pixel[offset + 2];
			pixel[offset + 1] = _tmp33_;
			_tmp34_ = pixel[offset + 1];
			pixel[offset + 0] = _tmp34_;
			_tmp35_ = pixel[offset + 0];
			return;
		} else {
			gboolean _tmp36_ = FALSE;
			gint _tmp37_;
			_tmp37_ = self->priv->_depth;
			if (_tmp37_ == 1) {
				gint _tmp38_;
				_tmp38_ = self->priv->_n_channels;
				_tmp36_ = _tmp38_ == 1;
			} else {
				_tmp36_ = FALSE;
			}
			if (_tmp36_) {
				guchar p = '\0';
				guchar* _tmp39_;
				gint _tmp39__length1;
				gint _tmp40_;
				guchar _tmp41_;
				gint _tmp42_ = 0;
				guchar _tmp43_;
				guchar _tmp44_;
				guchar _tmp45_;
				guchar _tmp46_;
				_tmp39_ = self->priv->pixels;
				_tmp39__length1 = self->priv->pixels_length1;
				_tmp40_ = line_offset;
				_tmp41_ = _tmp39_[_tmp40_ + (x / 8)];
				p = _tmp41_;
				_tmp43_ = p;
				if (((gint) (_tmp43_ & (0x80 >> (x % 8)))) != 0) {
					_tmp42_ = 0x00;
				} else {
					_tmp42_ = 0xFF;
				}
				pixel[offset + 2] = (guchar) _tmp42_;
				_tmp44_ = pixel[offset + 2];
				pixel[offset + 1] = _tmp44_;
				_tmp45_ = pixel[offset + 1];
				pixel[offset + 0] = _tmp45_;
				_tmp46_ = pixel[offset + 0];
				return;
			} else {
				gboolean _tmp47_ = FALSE;
				gint _tmp48_;
				_tmp48_ = self->priv->_depth;
				if (_tmp48_ == 2) {
					gint _tmp49_;
					_tmp49_ = self->priv->_n_channels;
					_tmp47_ = _tmp49_ == 1;
				} else {
					_tmp47_ = FALSE;
				}
				if (_tmp47_) {
					gint block_shift[4] = {0};
					gint _tmp50_[4] = {0};
					guchar p = '\0';
					guchar* _tmp51_;
					gint _tmp51__length1;
					gint _tmp52_;
					guchar _tmp53_;
					gint sample = 0;
					guchar _tmp54_;
					gint _tmp55_;
					gint _tmp56_;
					gint _tmp57_;
					guchar _tmp58_;
					guchar _tmp59_;
					guchar _tmp60_;
					_tmp50_[0] = 6;
					_tmp50_[1] = 4;
					_tmp50_[2] = 2;
					_tmp50_[3] = 0;
					memcpy (block_shift, _tmp50_, 4 * sizeof (gint));
					_tmp51_ = self->priv->pixels;
					_tmp51__length1 = self->priv->pixels_length1;
					_tmp52_ = line_offset;
					_tmp53_ = _tmp51_[_tmp52_ + (x / 4)];
					p = _tmp53_;
					_tmp54_ = p;
					_tmp55_ = block_shift[x % 4];
					sample = (_tmp54_ >> _tmp55_) & 0x3;
					_tmp56_ = sample;
					sample = (_tmp56_ * 255) / 3;
					_tmp57_ = sample;
					pixel[offset + 2] = (guchar) _tmp57_;
					_tmp58_ = pixel[offset + 2];
					pixel[offset + 1] = _tmp58_;
					_tmp59_ = pixel[offset + 1];
					pixel[offset + 0] = _tmp59_;
					_tmp60_ = pixel[offset + 0];
					return;
				}
			}
		}
	}
	_tmp61_ = self->priv->pixels;
	_tmp61__length1 = self->priv->pixels_length1;
	_tmp62_ = line_offset;
	_tmp63_ = self->priv->_depth;
	_tmp64_ = self->priv->_n_channels;
	pixel[offset + 0] = page_get_sample (self, _tmp61_, _tmp61__length1, _tmp62_, x, _tmp63_, _tmp64_, 0);
	_tmp65_ = pixel[offset + 0];
	_tmp66_ = self->priv->pixels;
	_tmp66__length1 = self->priv->pixels_length1;
	_tmp67_ = line_offset;
	_tmp68_ = self->priv->_depth;
	_tmp69_ = self->priv->_n_channels;
	pixel[offset + 1] = page_get_sample (self, _tmp66_, _tmp66__length1, _tmp67_, x, _tmp68_, _tmp69_, 1);
	_tmp70_ = pixel[offset + 1];
	_tmp71_ = self->priv->pixels;
	_tmp71__length1 = self->priv->pixels_length1;
	_tmp72_ = line_offset;
	_tmp73_ = self->priv->_depth;
	_tmp74_ = self->priv->_n_channels;
	pixel[offset + 2] = page_get_sample (self, _tmp71_, _tmp71__length1, _tmp72_, x, _tmp73_, _tmp74_, 2);
	_tmp75_ = pixel[offset + 2];
}


GdkPixbuf*
page_get_image (Page* self,
                gboolean apply_crop)
{
	GdkPixbuf* result = NULL;
	gint l = 0;
	gint r = 0;
	gint t = 0;
	gint b = 0;
	gboolean _tmp0_ = FALSE;
	GdkPixbuf* image = NULL;
	gint _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	gint _tmp27_;
	GdkPixbuf* _tmp28_;
	guint8* image_pixels = NULL;
	GdkPixbuf* _tmp29_;
	guint8* _tmp30_;
	gint image_pixels_length1;
	gint _image_pixels_size_;
	g_return_val_if_fail (self != NULL, NULL);
	if (apply_crop) {
		gboolean _tmp1_;
		_tmp1_ = self->priv->_has_crop;
		_tmp0_ = _tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gint _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		gint _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		_tmp2_ = self->priv->_crop_x;
		l = _tmp2_;
		_tmp3_ = l;
		_tmp4_ = self->priv->_crop_width;
		r = _tmp3_ + _tmp4_;
		_tmp5_ = self->priv->_crop_y;
		t = _tmp5_;
		_tmp6_ = t;
		_tmp7_ = self->priv->_crop_height;
		b = _tmp6_ + _tmp7_;
		_tmp8_ = l;
		if (_tmp8_ < 0) {
			l = 0;
		}
		_tmp9_ = r;
		_tmp10_ = page_get_width (self);
		_tmp11_ = _tmp10_;
		if (_tmp9_ > _tmp11_) {
			gint _tmp12_;
			gint _tmp13_;
			_tmp12_ = page_get_width (self);
			_tmp13_ = _tmp12_;
			r = _tmp13_;
		}
		_tmp14_ = t;
		if (_tmp14_ < 0) {
			t = 0;
		}
		_tmp15_ = b;
		_tmp16_ = page_get_height (self);
		_tmp17_ = _tmp16_;
		if (_tmp15_ > _tmp17_) {
			gint _tmp18_;
			gint _tmp19_;
			_tmp18_ = page_get_height (self);
			_tmp19_ = _tmp18_;
			b = _tmp19_;
		}
	} else {
		gint _tmp20_;
		gint _tmp21_;
		gint _tmp22_;
		gint _tmp23_;
		l = 0;
		_tmp20_ = page_get_width (self);
		_tmp21_ = _tmp20_;
		r = _tmp21_;
		t = 0;
		_tmp22_ = page_get_height (self);
		_tmp23_ = _tmp22_;
		b = _tmp23_;
	}
	_tmp24_ = r;
	_tmp25_ = l;
	_tmp26_ = b;
	_tmp27_ = t;
	_tmp28_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, FALSE, 8, _tmp24_ - _tmp25_, _tmp26_ - _tmp27_);
	image = _tmp28_;
	_tmp29_ = image;
	_tmp30_ = gdk_pixbuf_get_pixels (_tmp29_);
	image_pixels = _tmp30_;
	image_pixels_length1 = -1;
	_image_pixels_size_ = image_pixels_length1;
	{
		gint y = 0;
		gint _tmp31_;
		_tmp31_ = t;
		y = _tmp31_;
		{
			gboolean _tmp32_ = FALSE;
			_tmp32_ = TRUE;
			while (TRUE) {
				gint _tmp34_;
				gint _tmp35_;
				gint offset = 0;
				GdkPixbuf* _tmp36_;
				gint _tmp37_;
				gint _tmp38_;
				if (!_tmp32_) {
					gint _tmp33_;
					_tmp33_ = y;
					y = _tmp33_ + 1;
				}
				_tmp32_ = FALSE;
				_tmp34_ = y;
				_tmp35_ = b;
				if (!(_tmp34_ < _tmp35_)) {
					break;
				}
				_tmp36_ = image;
				_tmp37_ = y;
				_tmp38_ = t;
				offset = gdk_pixbuf_get_rowstride (_tmp36_) * (_tmp37_ - _tmp38_);
				{
					gint x = 0;
					gint _tmp39_;
					_tmp39_ = l;
					x = _tmp39_;
					{
						gboolean _tmp40_ = FALSE;
						_tmp40_ = TRUE;
						while (TRUE) {
							gint _tmp42_;
							gint _tmp43_;
							gint _tmp44_;
							gint _tmp45_;
							guint8* _tmp46_;
							gint _tmp46__length1;
							gint _tmp47_;
							gint _tmp48_;
							gint _tmp49_;
							if (!_tmp40_) {
								gint _tmp41_;
								_tmp41_ = x;
								x = _tmp41_ + 1;
							}
							_tmp40_ = FALSE;
							_tmp42_ = x;
							_tmp43_ = r;
							if (!(_tmp42_ < _tmp43_)) {
								break;
							}
							_tmp44_ = x;
							_tmp45_ = y;
							_tmp46_ = image_pixels;
							_tmp46__length1 = image_pixels_length1;
							_tmp47_ = offset;
							_tmp48_ = x;
							_tmp49_ = l;
							page_get_pixel (self, _tmp44_, _tmp45_, _tmp46_, _tmp46__length1, _tmp47_ + ((_tmp48_ - _tmp49_) * 3));
						}
					}
				}
			}
		}
	}
	result = image;
	return result;
}


static gchar*
string_to_utf8 (const gchar* self,
                int* result_length1)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_;
	gint _result__length1;
	gint __result__size_;
	gint _tmp3_;
	gchar* _tmp4_;
	gint _tmp4__length1;
	gint _tmp5_;
	gint _tmp6_;
	gchar* _tmp7_;
	gint _tmp7__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_new0 (gchar, _tmp1_ + 1);
	_result_ = _tmp2_;
	_result__length1 = _tmp1_ + 1;
	__result__size_ = _result__length1;
	_tmp3_ = _result__length1;
	_result__length1 = _tmp3_ - 1;
	_tmp4_ = _result_;
	_tmp4__length1 = _result__length1;
	_tmp5_ = strlen (self);
	_tmp6_ = _tmp5_;
	memcpy (_tmp4_, self, (gsize) _tmp6_);
	_tmp7_ = _result_;
	_tmp7__length1 = _result__length1;
	if (result_length1) {
		*result_length1 = _tmp7__length1;
	}
	result = _tmp7_;
	return result;
}


gchar*
page_get_icc_data_encoded (Page* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* contents = NULL;
	const gchar* _tmp5_;
	gint _tmp6_;
	gchar* _tmp7_;
	guchar* _tmp8_;
	gint _tmp8__length1;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_color_profile;
	if (_tmp0_ == NULL) {
		result = NULL;
		return result;
	}
	{
		const gchar* _tmp1_;
		gchar* _tmp2_ = NULL;
		_tmp1_ = self->priv->_color_profile;
		g_file_get_contents (_tmp1_, &_tmp2_, NULL, &_inner_error_);
		_g_free0 (contents);
		contents = _tmp2_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch17_g_error;
		}
	}
	goto __finally17;
	__catch17_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		g_warning ("page.vala:640: failed to get icc profile data: %s", _tmp4_);
		result = NULL;
		_g_error_free0 (e);
		_g_free0 (contents);
		return result;
	}
	__finally17:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_free0 (contents);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp5_ = contents;
	_tmp7_ = string_to_utf8 (_tmp5_, &_tmp6_);
	_tmp8_ = (guchar*) _tmp7_;
	_tmp8__length1 = (_tmp6_ * sizeof (gchar)) / sizeof (guchar);
	_tmp9_ = g_base64_encode (_tmp8_, (_tmp6_ * sizeof (gchar)) / sizeof (guchar));
	_tmp10_ = _tmp9_;
	_tmp8_ = (g_free (_tmp8_), NULL);
	result = _tmp10_;
	_g_free0 (contents);
	return result;
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


void
page_copy_to_clipboard (Page* self,
                        GtkWindow* window)
{
	GdkDisplay* display = NULL;
	GdkDisplay* _tmp0_;
	GdkDisplay* _tmp1_;
	GtkClipboard* clipboard = NULL;
	GtkClipboard* _tmp2_;
	GtkClipboard* _tmp3_;
	GdkPixbuf* image = NULL;
	GdkPixbuf* _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (window != NULL);
	_tmp0_ = gtk_widget_get_display ((GtkWidget*) window);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	display = _tmp1_;
	_tmp2_ = gtk_clipboard_get_for_display (display, GDK_SELECTION_CLIPBOARD);
	_tmp3_ = _g_object_ref0 (_tmp2_);
	clipboard = _tmp3_;
	_tmp4_ = page_get_image (self, TRUE);
	image = _tmp4_;
	gtk_clipboard_set_image (clipboard, image);
	_g_object_unref0 (image);
	_g_object_unref0 (clipboard);
	_g_object_unref0 (display);
}


static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
	g_atomic_int_inc (&_data6_->_ref_count_);
	return _data6_;
}


static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
		Page* self;
		self = _data6_->self;
		_g_object_unref0 (_data6_->stream);
		_page_unref0 (self);
		g_slice_free (Block6Data, _data6_);
	}
}


static gboolean
__lambda17_ (Block6Data* _data6_,
             guint8* buf,
             int buf_length1,
             GError** error)
{
	Page* self;
	gboolean result = FALSE;
	GFileOutputStream* _tmp0_;
	GError * _inner_error_ = NULL;
	self = _data6_->self;
	_tmp0_ = _data6_->stream;
	g_output_stream_write_all ((GOutputStream*) _tmp0_, buf, (gsize) buf_length1, NULL, NULL, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gboolean _tmp1_ = FALSE;
		g_propagate_error (error, _inner_error_);
		return _tmp1_;
	}
	result = TRUE;
	return result;
}


static gboolean
___lambda17__gdk_pixbuf_save_func (guint8* buf,
                                   gsize buf_length1,
                                   GError** error,
                                   gpointer self)
{
	gboolean result;
	result = __lambda17_ (self, buf, buf_length1, error);
	return result;
}


void
page_save_png (Page* self,
               GFile* file,
               GError** error)
{
	Block6Data* _data6_;
	GFileOutputStream* _tmp0_;
	GdkPixbuf* image = NULL;
	GdkPixbuf* _tmp1_;
	gchar* icc_profile_data = NULL;
	const gchar* _tmp2_;
	gchar** keys = NULL;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gint keys_length1;
	gint _keys_size_;
	gchar** values = NULL;
	gint _tmp8_;
	gchar* _tmp9_;
	gint _tmp10_;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gchar** _tmp14_;
	gint values_length1;
	gint _values_size_;
	const gchar* _tmp15_;
	GdkPixbuf* _tmp18_;
	gchar** _tmp19_;
	gint _tmp19__length1;
	gchar** _tmp20_;
	gint _tmp20__length1;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	_data6_ = g_slice_new0 (Block6Data);
	_data6_->_ref_count_ = 1;
	_data6_->self = page_ref (self);
	_tmp0_ = g_file_replace (file, NULL, FALSE, G_FILE_CREATE_NONE, NULL, &_inner_error_);
	_data6_->stream = _tmp0_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		block6_data_unref (_data6_);
		_data6_ = NULL;
		return;
	}
	_tmp1_ = page_get_image (self, TRUE);
	image = _tmp1_;
	icc_profile_data = NULL;
	_tmp2_ = self->priv->_color_profile;
	if (_tmp2_ != NULL) {
		gchar* _tmp3_;
		_tmp3_ = page_get_icc_data_encoded (self);
		_g_free0 (icc_profile_data);
		icc_profile_data = _tmp3_;
	}
	_tmp4_ = g_strdup ("x-dpi");
	_tmp5_ = g_strdup ("y-dpi");
	_tmp6_ = g_strdup ("icc-profile");
	_tmp7_ = g_new0 (gchar*, 4 + 1);
	_tmp7_[0] = _tmp4_;
	_tmp7_[1] = _tmp5_;
	_tmp7_[2] = _tmp6_;
	_tmp7_[3] = NULL;
	keys = _tmp7_;
	keys_length1 = 4;
	_keys_size_ = keys_length1;
	_tmp8_ = self->priv->_dpi;
	_tmp9_ = g_strdup_printf ("%d", _tmp8_);
	_tmp10_ = self->priv->_dpi;
	_tmp11_ = g_strdup_printf ("%d", _tmp10_);
	_tmp12_ = icc_profile_data;
	_tmp13_ = g_strdup (_tmp12_);
	_tmp14_ = g_new0 (gchar*, 4 + 1);
	_tmp14_[0] = _tmp9_;
	_tmp14_[1] = _tmp11_;
	_tmp14_[2] = _tmp13_;
	_tmp14_[3] = NULL;
	values = _tmp14_;
	values_length1 = 4;
	_values_size_ = values_length1;
	_tmp15_ = icc_profile_data;
	if (_tmp15_ == NULL) {
		gchar** _tmp16_;
		gint _tmp16__length1;
		gchar* _tmp17_;
		_tmp16_ = keys;
		_tmp16__length1 = keys_length1;
		_g_free0 (_tmp16_[2]);
		_tmp16_[2] = NULL;
		_tmp17_ = _tmp16_[2];
	}
	_tmp18_ = image;
	_tmp19_ = keys;
	_tmp19__length1 = keys_length1;
	_tmp20_ = values;
	_tmp20__length1 = values_length1;
	gdk_pixbuf_save_to_callbackv (_tmp18_, ___lambda17__gdk_pixbuf_save_func, _data6_, "png", _tmp19_, _tmp20_, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
		keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
		_g_free0 (icc_profile_data);
		_g_object_unref0 (image);
		block6_data_unref (_data6_);
		_data6_ = NULL;
		return;
	}
	values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
	keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (icc_profile_data);
	_g_object_unref0 (image);
	block6_data_unref (_data6_);
	_data6_ = NULL;
}


gint
page_get_width (Page* self)
{
	gint result;
	gboolean _tmp0_ = FALSE;
	ScanDirection _tmp1_;
	ScanDirection _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp1_ = page_get_scan_direction (self);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == SCAN_DIRECTION_TOP_TO_BOTTOM) {
		_tmp0_ = TRUE;
	} else {
		ScanDirection _tmp3_;
		ScanDirection _tmp4_;
		_tmp3_ = page_get_scan_direction (self);
		_tmp4_ = _tmp3_;
		_tmp0_ = _tmp4_ == SCAN_DIRECTION_BOTTOM_TO_TOP;
	}
	if (_tmp0_) {
		gint _tmp5_;
		_tmp5_ = self->priv->_scan_width;
		result = _tmp5_;
		return result;
	} else {
		gint _tmp6_;
		_tmp6_ = self->priv->_scan_height;
		result = _tmp6_;
		return result;
	}
}


gint
page_get_height (Page* self)
{
	gint result;
	gboolean _tmp0_ = FALSE;
	ScanDirection _tmp1_;
	ScanDirection _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp1_ = page_get_scan_direction (self);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == SCAN_DIRECTION_TOP_TO_BOTTOM) {
		_tmp0_ = TRUE;
	} else {
		ScanDirection _tmp3_;
		ScanDirection _tmp4_;
		_tmp3_ = page_get_scan_direction (self);
		_tmp4_ = _tmp3_;
		_tmp0_ = _tmp4_ == SCAN_DIRECTION_BOTTOM_TO_TOP;
	}
	if (_tmp0_) {
		gint _tmp5_;
		_tmp5_ = self->priv->_scan_height;
		result = _tmp5_;
		return result;
	} else {
		gint _tmp6_;
		_tmp6_ = self->priv->_scan_width;
		result = _tmp6_;
		return result;
	}
}


gboolean
page_get_is_landscape (Page* self)
{
	gboolean result;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = page_get_width (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = page_get_height (self);
	_tmp3_ = _tmp2_;
	result = _tmp1_ > _tmp3_;
	return result;
}


gint
page_get_dpi (Page* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_dpi;
	result = _tmp0_;
	return result;
}


static void
page_set_dpi (Page* self,
              gint value)
{
	g_return_if_fail (self != NULL);
	self->priv->_dpi = value;
}


gint
page_get_depth (Page* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_depth;
	result = _tmp0_;
	return result;
}


static void
page_set_depth (Page* self,
                gint value)
{
	g_return_if_fail (self != NULL);
	self->priv->_depth = value;
}


const gchar*
page_get_color_profile (Page* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_color_profile;
	result = _tmp0_;
	return result;
}


void
page_set_color_profile (Page* self,
                        const gchar* value)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_color_profile);
	self->priv->_color_profile = _tmp0_;
}


gint
page_get_scan_width (Page* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_scan_width;
	result = _tmp0_;
	return result;
}


static void
page_set_scan_width (Page* self,
                     gint value)
{
	g_return_if_fail (self != NULL);
	self->priv->_scan_width = value;
}


gint
page_get_scan_height (Page* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_scan_height;
	result = _tmp0_;
	return result;
}


static void
page_set_scan_height (Page* self,
                      gint value)
{
	g_return_if_fail (self != NULL);
	self->priv->_scan_height = value;
}


gint
page_get_rowstride (Page* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_rowstride;
	result = _tmp0_;
	return result;
}


static void
page_set_rowstride (Page* self,
                    gint value)
{
	g_return_if_fail (self != NULL);
	self->priv->_rowstride = value;
}


gint
page_get_n_channels (Page* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_n_channels;
	result = _tmp0_;
	return result;
}


static void
page_set_n_channels (Page* self,
                     gint value)
{
	g_return_if_fail (self != NULL);
	self->priv->_n_channels = value;
}


gboolean
page_get_is_scanning (Page* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_is_scanning;
	result = _tmp0_;
	return result;
}


static void
page_set_is_scanning (Page* self,
                      gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_is_scanning = value;
}


gboolean
page_get_has_data (Page* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_has_data;
	result = _tmp0_;
	return result;
}


static void
page_set_has_data (Page* self,
                   gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_has_data = value;
}


gint
page_get_scan_line (Page* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_scan_line;
	result = _tmp0_;
	return result;
}


static void
page_set_scan_line (Page* self,
                    gint value)
{
	g_return_if_fail (self != NULL);
	self->priv->_scan_line = value;
}


gboolean
page_get_is_color (Page* self)
{
	gboolean result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_n_channels;
	result = _tmp0_ > 1;
	return result;
}


ScanDirection
page_get_scan_direction (Page* self)
{
	ScanDirection result;
	ScanDirection _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->scan_direction_;
	result = _tmp0_;
	return result;
}


void
page_set_scan_direction (Page* self,
                         ScanDirection value)
{
	ScanDirection _tmp0_;
	gboolean size_has_changed = FALSE;
	gint left_steps = 0;
	ScanDirection _tmp1_;
	gint _tmp2_;
	gint _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp33_;
	gboolean _tmp34_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->scan_direction_;
	if (_tmp0_ == value) {
		return;
	}
	size_has_changed = FALSE;
	_tmp1_ = self->priv->scan_direction_;
	left_steps = (gint) (value - _tmp1_);
	_tmp2_ = left_steps;
	if (_tmp2_ < 0) {
		gint _tmp3_;
		_tmp3_ = left_steps;
		left_steps = _tmp3_ + 4;
	}
	_tmp4_ = left_steps;
	if (_tmp4_ != 2) {
		size_has_changed = TRUE;
	}
	_tmp5_ = self->priv->_has_crop;
	if (_tmp5_) {
		gint _tmp6_;
		_tmp6_ = left_steps;
		switch (_tmp6_) {
			case 1:
			{
				gint t = 0;
				gint _tmp7_;
				gint _tmp8_;
				gint _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
				gint _tmp12_;
				gint _tmp13_;
				gint _tmp14_;
				gint _tmp15_;
				_tmp7_ = self->priv->_crop_x;
				t = _tmp7_;
				_tmp8_ = self->priv->_crop_y;
				page_set_crop_x (self, _tmp8_);
				_tmp9_ = page_get_width (self);
				_tmp10_ = _tmp9_;
				_tmp11_ = t;
				_tmp12_ = self->priv->_crop_width;
				page_set_crop_y (self, _tmp10_ - (_tmp11_ + _tmp12_));
				_tmp13_ = self->priv->_crop_width;
				t = _tmp13_;
				_tmp14_ = self->priv->_crop_height;
				page_set_crop_width (self, _tmp14_);
				_tmp15_ = t;
				page_set_crop_height (self, _tmp15_);
				break;
			}
			case 2:
			{
				gint _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
				gint _tmp19_;
				gint _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
				gint _tmp23_;
				_tmp16_ = page_get_width (self);
				_tmp17_ = _tmp16_;
				_tmp18_ = self->priv->_crop_x;
				_tmp19_ = self->priv->_crop_width;
				page_set_crop_x (self, _tmp17_ - (_tmp18_ + _tmp19_));
				_tmp20_ = page_get_width (self);
				_tmp21_ = _tmp20_;
				_tmp22_ = self->priv->_crop_y;
				_tmp23_ = self->priv->_crop_height;
				page_set_crop_y (self, _tmp21_ - (_tmp22_ + _tmp23_));
				break;
			}
			case 3:
			{
				gint t = 0;
				gint _tmp24_;
				gint _tmp25_;
				gint _tmp26_;
				gint _tmp27_;
				gint _tmp28_;
				gint _tmp29_;
				gint _tmp30_;
				gint _tmp31_;
				gint _tmp32_;
				_tmp24_ = self->priv->_crop_y;
				t = _tmp24_;
				_tmp25_ = self->priv->_crop_x;
				page_set_crop_y (self, _tmp25_);
				_tmp26_ = page_get_height (self);
				_tmp27_ = _tmp26_;
				_tmp28_ = t;
				_tmp29_ = self->priv->_crop_height;
				page_set_crop_x (self, _tmp27_ - (_tmp28_ + _tmp29_));
				_tmp30_ = self->priv->_crop_width;
				t = _tmp30_;
				_tmp31_ = self->priv->_crop_height;
				page_set_crop_width (self, _tmp31_);
				_tmp32_ = t;
				page_set_crop_height (self, _tmp32_);
				break;
			}
			default:
			break;
		}
	}
	self->priv->scan_direction_ = value;
	_tmp33_ = size_has_changed;
	if (_tmp33_) {
		g_signal_emit (self, page_signals[PAGE_SIZE_CHANGED_SIGNAL], 0);
	}
	g_signal_emit (self, page_signals[PAGE_SCAN_DIRECTION_CHANGED_SIGNAL], 0);
	_tmp34_ = self->priv->_has_crop;
	if (_tmp34_) {
		g_signal_emit (self, page_signals[PAGE_CROP_CHANGED_SIGNAL], 0);
	}
}


gboolean
page_get_has_crop (Page* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_has_crop;
	result = _tmp0_;
	return result;
}


static void
page_set_has_crop (Page* self,
                   gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_has_crop = value;
}


const gchar*
page_get_crop_name (Page* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_crop_name;
	result = _tmp0_;
	return result;
}


static void
page_set_crop_name (Page* self,
                    const gchar* value)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_crop_name);
	self->priv->_crop_name = _tmp0_;
}


gint
page_get_crop_x (Page* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_crop_x;
	result = _tmp0_;
	return result;
}


static void
page_set_crop_x (Page* self,
                 gint value)
{
	g_return_if_fail (self != NULL);
	self->priv->_crop_x = value;
}


gint
page_get_crop_y (Page* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_crop_y;
	result = _tmp0_;
	return result;
}


static void
page_set_crop_y (Page* self,
                 gint value)
{
	g_return_if_fail (self != NULL);
	self->priv->_crop_y = value;
}


gint
page_get_crop_width (Page* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_crop_width;
	result = _tmp0_;
	return result;
}


static void
page_set_crop_width (Page* self,
                     gint value)
{
	g_return_if_fail (self != NULL);
	self->priv->_crop_width = value;
}


gint
page_get_crop_height (Page* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_crop_height;
	result = _tmp0_;
	return result;
}


static void
page_set_crop_height (Page* self,
                      gint value)
{
	g_return_if_fail (self != NULL);
	self->priv->_crop_height = value;
}


static void
value_page_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}


static void
value_page_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		page_unref (value->data[0].v_pointer);
	}
}


static void
value_page_copy_value (const GValue* src_value,
                       GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = page_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer
value_page_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}


static gchar*
value_page_collect_value (GValue* value,
                          guint n_collect_values,
                          GTypeCValue* collect_values,
                          guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		Page * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = page_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar*
value_page_lcopy_value (const GValue* value,
                        guint n_collect_values,
                        GTypeCValue* collect_values,
                        guint collect_flags)
{
	Page ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = page_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec*
param_spec_page (const gchar* name,
                 const gchar* nick,
                 const gchar* blurb,
                 GType object_type,
                 GParamFlags flags)
{
	ParamSpecPage* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PAGE), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer
value_get_page (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PAGE), NULL);
	return value->data[0].v_pointer;
}


void
value_set_page (GValue* value,
                gpointer v_object)
{
	Page * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PAGE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PAGE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		page_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		page_unref (old);
	}
}


void
value_take_page (GValue* value,
                 gpointer v_object)
{
	Page * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PAGE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PAGE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		page_unref (old);
	}
}


static void
page_class_init (PageClass * klass)
{
	page_parent_class = g_type_class_peek_parent (klass);
	((PageClass *) klass)->finalize = page_finalize;
	g_type_class_add_private (klass, sizeof (PagePrivate));
	page_signals[PAGE_PIXELS_CHANGED_SIGNAL] = g_signal_new ("pixels-changed", TYPE_PAGE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	page_signals[PAGE_SIZE_CHANGED_SIGNAL] = g_signal_new ("size-changed", TYPE_PAGE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	page_signals[PAGE_SCAN_LINE_CHANGED_SIGNAL] = g_signal_new ("scan-line-changed", TYPE_PAGE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	page_signals[PAGE_SCAN_DIRECTION_CHANGED_SIGNAL] = g_signal_new ("scan-direction-changed", TYPE_PAGE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	page_signals[PAGE_CROP_CHANGED_SIGNAL] = g_signal_new ("crop-changed", TYPE_PAGE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	page_signals[PAGE_SCAN_FINISHED_SIGNAL] = g_signal_new ("scan-finished", TYPE_PAGE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void
page_instance_init (Page * self)
{
	self->priv = PAGE_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void
page_finalize (Page * obj)
{
	Page * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PAGE, Page);
	g_signal_handlers_destroy (self);
	_g_free0 (self->priv->_color_profile);
	self->priv->pixels = (g_free (self->priv->pixels), NULL);
	_g_free0 (self->priv->_crop_name);
}


GType
page_get_type (void)
{
	static volatile gsize page_type_id__volatile = 0;
	if (g_once_init_enter (&page_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_page_init, value_page_free_value, value_page_copy_value, value_page_peek_pointer, "p", value_page_collect_value, "p", value_page_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) page_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Page), 0, (GInstanceInitFunc) page_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType page_type_id;
		page_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Page", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&page_type_id__volatile, page_type_id);
	}
	return page_type_id__volatile;
}


gpointer
page_ref (gpointer instance)
{
	Page * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void
page_unref (gpointer instance)
{
	Page * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		PAGE_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



