/* preferences-dialog.c generated by valac 0.40.8, the Vala compiler
 * generated from preferences-dialog.vala, do not modify */

/*
 * Copyright (C) 2009-2017 Canonical Ltd.
 * Author: Robert Ancell <robert.ancell@canonical.com>,
 *         Eduard Gotwig <g@ox.io>
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <cairo.h>


#define TYPE_PREFERENCES_DIALOG (preferences_dialog_get_type ())
#define PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREFERENCES_DIALOG, PreferencesDialog))
#define PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREFERENCES_DIALOG, PreferencesDialogClass))
#define IS_PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREFERENCES_DIALOG))
#define IS_PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREFERENCES_DIALOG))
#define PREFERENCES_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREFERENCES_DIALOG, PreferencesDialogClass))

typedef struct _PreferencesDialog PreferencesDialog;
typedef struct _PreferencesDialogClass PreferencesDialogClass;
typedef struct _PreferencesDialogPrivate PreferencesDialogPrivate;
enum  {
	PREFERENCES_DIALOG_0_PROPERTY,
	PREFERENCES_DIALOG_NUM_PROPERTIES
};
static GParamSpec* preferences_dialog_properties[PREFERENCES_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block7Data Block7Data;

#define TYPE_SCAN_TYPE (scan_type_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_SCAN_DEVICE (scan_device_get_type ())
#define SCAN_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SCAN_DEVICE, ScanDevice))
#define SCAN_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SCAN_DEVICE, ScanDeviceClass))
#define IS_SCAN_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SCAN_DEVICE))
#define IS_SCAN_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SCAN_DEVICE))
#define SCAN_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SCAN_DEVICE, ScanDeviceClass))

typedef struct _ScanDevice ScanDevice;
typedef struct _ScanDeviceClass ScanDeviceClass;
typedef struct _ScanDevicePrivate ScanDevicePrivate;
#define _scan_device_unref0(var) ((var == NULL) ? NULL : (var = (scan_device_unref (var), NULL)))

#define TYPE_PAGE_ICON (page_icon_get_type ())
#define PAGE_ICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE_ICON, PageIcon))
#define PAGE_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE_ICON, PageIconClass))
#define IS_PAGE_ICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE_ICON))
#define IS_PAGE_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE_ICON))
#define PAGE_ICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE_ICON, PageIconClass))

typedef struct _PageIcon PageIcon;
typedef struct _PageIconClass PageIconClass;
typedef struct _PageIconPrivate PageIconPrivate;
enum  {
	PAGE_ICON_0_PROPERTY,
	PAGE_ICON_NUM_PROPERTIES
};
static GParamSpec* page_icon_properties[PAGE_ICON_NUM_PROPERTIES];

struct _PreferencesDialog {
	GtkDialog parent_instance;
	PreferencesDialogPrivate * priv;
};

struct _PreferencesDialogClass {
	GtkDialogClass parent_class;
};

struct _PreferencesDialogPrivate {
	GSettings* settings;
	gboolean setting_devices;
	gboolean user_selected_device;
	GtkComboBox* device_combo;
	GtkComboBox* text_dpi_combo;
	GtkComboBox* photo_dpi_combo;
	GtkComboBox* paper_size_combo;
	GtkScale* brightness_scale;
	GtkScale* contrast_scale;
	GtkListStore* device_model;
	GtkRadioButton* page_delay_3s_button;
	GtkRadioButton* page_delay_5s_button;
	GtkRadioButton* page_delay_7s_button;
	GtkRadioButton* page_delay_10s_button;
	GtkRadioButton* page_delay_15s_button;
	GtkListStore* text_dpi_model;
	GtkListStore* photo_dpi_model;
	GtkRadioButton* front_side_button;
	GtkRadioButton* back_side_button;
	GtkRadioButton* both_side_button;
	GtkListStore* paper_size_model;
	GtkAdjustment* brightness_adjustment;
	GtkAdjustment* contrast_adjustment;
	GtkButton* preferences_close_button;
};

struct _Block7Data {
	int _ref_count_;
	PreferencesDialog* self;
	GSettings* settings;
};

typedef enum  {
	SCAN_TYPE_SINGLE,
	SCAN_TYPE_ADF_FRONT,
	SCAN_TYPE_ADF_BACK,
	SCAN_TYPE_ADF_BOTH,
	SCAN_TYPE_BATCH
} ScanType;

struct _ScanDevice {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ScanDevicePrivate * priv;
	gchar* name;
	gchar* label;
};

struct _ScanDeviceClass {
	GTypeClass parent_class;
	void (*finalize) (ScanDevice *self);
};

struct _PageIcon {
	GtkDrawingArea parent_instance;
	PageIconPrivate * priv;
};

struct _PageIconClass {
	GtkDrawingAreaClass parent_class;
};

struct _PageIconPrivate {
	gchar* text;
	gdouble r;
	gdouble g;
	gdouble b;
};


static gpointer preferences_dialog_parent_class = NULL;
static gpointer page_icon_parent_class = NULL;

GType preferences_dialog_get_type (void) G_GNUC_CONST;
#define PREFERENCES_DIALOG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PREFERENCES_DIALOG, PreferencesDialogPrivate))
PreferencesDialog* preferences_dialog_new (GSettings* settings,
                                           gboolean use_header_bar);
PreferencesDialog* preferences_dialog_construct (GType object_type,
                                                 GSettings* settings,
                                                 gboolean use_header_bar);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
#define DEFAULT_TEXT_DPI 150
static void preferences_dialog_set_dpi_combo (PreferencesDialog* self,
                                       GtkComboBox* combo,
                                       gint default_dpi,
                                       gint current_dpi);
static void __lambda4_ (Block7Data* _data7_);
gint preferences_dialog_get_text_dpi (PreferencesDialog* self);
static void ___lambda4__gtk_combo_box_changed (GtkComboBox* _sender,
                                        gpointer self);
#define DEFAULT_PHOTO_DPI 300
static void __lambda5_ (Block7Data* _data7_);
gint preferences_dialog_get_photo_dpi (PreferencesDialog* self);
static void ___lambda5__gtk_combo_box_changed (GtkComboBox* _sender,
                                        gpointer self);
GType scan_type_get_type (void) G_GNUC_CONST;
static void preferences_dialog_set_page_side (PreferencesDialog* self,
                                       ScanType page_side);
static void __lambda6_ (Block7Data* _data7_,
                 GtkToggleButton* button);
static void ___lambda6__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                            gpointer self);
static void __lambda7_ (Block7Data* _data7_,
                 GtkToggleButton* button);
static void ___lambda7__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                            gpointer self);
static void __lambda8_ (Block7Data* _data7_,
                 GtkToggleButton* button);
static void ___lambda8__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                            gpointer self);
static void __lambda9_ (Block7Data* _data7_);
gint preferences_dialog_get_brightness (PreferencesDialog* self);
static void ___lambda9__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                               gpointer self);
static void __lambda10_ (Block7Data* _data7_);
gint preferences_dialog_get_contrast (PreferencesDialog* self);
static void ___lambda10__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                gpointer self);
void preferences_dialog_set_paper_size (PreferencesDialog* self,
                                        gint width,
                                        gint height);
static void __lambda11_ (Block7Data* _data7_);
gboolean preferences_dialog_get_paper_size (PreferencesDialog* self,
                                            gint* width,
                                            gint* height);
static void ___lambda11__gtk_combo_box_changed (GtkComboBox* _sender,
                                         gpointer self);
void preferences_dialog_set_page_delay (PreferencesDialog* self,
                                        gint page_delay);
static void __lambda12_ (Block7Data* _data7_,
                  GtkToggleButton* button);
static void ___lambda12__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                             gpointer self);
static void __lambda13_ (Block7Data* _data7_,
                  GtkToggleButton* button);
static void ___lambda13__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                             gpointer self);
static void __lambda14_ (Block7Data* _data7_,
                  GtkToggleButton* button);
static void ___lambda14__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                             gpointer self);
static void __lambda15_ (Block7Data* _data7_,
                  GtkToggleButton* button);
static void ___lambda15__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                             gpointer self);
static void __lambda16_ (Block7Data* _data7_,
                  GtkToggleButton* button);
static void ___lambda16__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                             gpointer self);
gpointer scan_device_ref (gpointer instance);
void scan_device_unref (gpointer instance);
GParamSpec* param_spec_scan_device (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags);
void value_set_scan_device (GValue* value,
                            gpointer v_object);
void value_take_scan_device (GValue* value,
                             gpointer v_object);
gpointer value_get_scan_device (const GValue* value);
GType scan_device_get_type (void) G_GNUC_CONST;
void preferences_dialog_set_scan_devices (PreferencesDialog* self,
                                          GList* devices);
static gboolean preferences_dialog_find_scan_device (PreferencesDialog* self,
                                              const gchar* device,
                                              GtkTreeIter* iter);
gchar* preferences_dialog_get_selected_device (PreferencesDialog* self);
gchar* preferences_dialog_get_selected_device_label (PreferencesDialog* self);
void preferences_dialog_set_selected_device (PreferencesDialog* self,
                                             const gchar* device);
ScanType preferences_dialog_get_page_side (PreferencesDialog* self);
void preferences_dialog_set_brightness (PreferencesDialog* self,
                                        gint brightness);
void preferences_dialog_set_contrast (PreferencesDialog* self,
                                      gint contrast);
gint preferences_dialog_get_page_delay (PreferencesDialog* self);
static void preferences_dialog_device_combo_changed_cb (PreferencesDialog* self,
                                                 GtkWidget* widget);
static void _preferences_dialog_device_combo_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                        gpointer self);
static void preferences_dialog_finalize (GObject * obj);
GType page_icon_get_type (void) G_GNUC_CONST;
#define PAGE_ICON_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PAGE_ICON, PageIconPrivate))
#define PAGE_ICON_MINIMUM_WIDTH 20
PageIcon* page_icon_new (const gchar* text,
                         gdouble r,
                         gdouble g,
                         gdouble b);
PageIcon* page_icon_construct (GType object_type,
                               const gchar* text,
                               gdouble r,
                               gdouble g,
                               gdouble b);
static void page_icon_real_get_preferred_width (GtkWidget* base,
                                         gint* minimum_width,
                                         gint* natural_width);
static void page_icon_real_get_preferred_height (GtkWidget* base,
                                          gint* minimum_height,
                                          gint* natural_height);
static void page_icon_real_get_preferred_height_for_width (GtkWidget* base,
                                                    gint width,
                                                    gint* minimum_height,
                                                    gint* natural_height);
static void page_icon_real_get_preferred_width_for_height (GtkWidget* base,
                                                    gint height,
                                                    gint* minimum_width,
                                                    gint* natural_width);
static gboolean page_icon_real_draw (GtkWidget* base,
                              cairo_t* c);
static void page_icon_finalize (GObject * obj);


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
	g_atomic_int_inc (&_data7_->_ref_count_);
	return _data7_;
}


static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
		PreferencesDialog* self;
		self = _data7_->self;
		_g_object_unref0 (_data7_->settings);
		_g_object_unref0 (self);
		g_slice_free (Block7Data, _data7_);
	}
}


static void
__lambda4_ (Block7Data* _data7_)
{
	PreferencesDialog* self;
	self = _data7_->self;
	g_settings_set_int (_data7_->settings, "text-dpi", preferences_dialog_get_text_dpi (self));
}


static void
___lambda4__gtk_combo_box_changed (GtkComboBox* _sender,
                                   gpointer self)
{
	__lambda4_ (self);
}


static void
__lambda5_ (Block7Data* _data7_)
{
	PreferencesDialog* self;
	self = _data7_->self;
	g_settings_set_int (_data7_->settings, "photo-dpi", preferences_dialog_get_photo_dpi (self));
}


static void
___lambda5__gtk_combo_box_changed (GtkComboBox* _sender,
                                   gpointer self)
{
	__lambda5_ (self);
}


static void
__lambda6_ (Block7Data* _data7_,
            GtkToggleButton* button)
{
	PreferencesDialog* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	self = _data7_->self;
	g_return_if_fail (button != NULL);
	_tmp0_ = gtk_toggle_button_get_active (button);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		g_settings_set_enum (_data7_->settings, "page-side", (gint) SCAN_TYPE_ADF_FRONT);
	}
}


static void
___lambda6__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                       gpointer self)
{
	__lambda6_ (self, _sender);
}


static void
__lambda7_ (Block7Data* _data7_,
            GtkToggleButton* button)
{
	PreferencesDialog* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	self = _data7_->self;
	g_return_if_fail (button != NULL);
	_tmp0_ = gtk_toggle_button_get_active (button);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		g_settings_set_enum (_data7_->settings, "page-side", (gint) SCAN_TYPE_ADF_BACK);
	}
}


static void
___lambda7__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                       gpointer self)
{
	__lambda7_ (self, _sender);
}


static void
__lambda8_ (Block7Data* _data7_,
            GtkToggleButton* button)
{
	PreferencesDialog* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	self = _data7_->self;
	g_return_if_fail (button != NULL);
	_tmp0_ = gtk_toggle_button_get_active (button);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		g_settings_set_enum (_data7_->settings, "page-side", (gint) SCAN_TYPE_ADF_BOTH);
	}
}


static void
___lambda8__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                       gpointer self)
{
	__lambda8_ (self, _sender);
}


static void
__lambda9_ (Block7Data* _data7_)
{
	PreferencesDialog* self;
	self = _data7_->self;
	g_settings_set_int (_data7_->settings, "brightness", preferences_dialog_get_brightness (self));
}


static void
___lambda9__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                          gpointer self)
{
	__lambda9_ (self);
}


static void
__lambda10_ (Block7Data* _data7_)
{
	PreferencesDialog* self;
	self = _data7_->self;
	g_settings_set_int (_data7_->settings, "contrast", preferences_dialog_get_contrast (self));
}


static void
___lambda10__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                           gpointer self)
{
	__lambda10_ (self);
}


static void
__lambda11_ (Block7Data* _data7_)
{
	PreferencesDialog* self;
	gint w = 0;
	gint h = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	self = _data7_->self;
	preferences_dialog_get_paper_size (self, &_tmp0_, &_tmp1_);
	w = _tmp0_;
	h = _tmp1_;
	g_settings_set_int (_data7_->settings, "paper-width", w);
	g_settings_set_int (_data7_->settings, "paper-height", h);
}


static void
___lambda11__gtk_combo_box_changed (GtkComboBox* _sender,
                                    gpointer self)
{
	__lambda11_ (self);
}


static void
__lambda12_ (Block7Data* _data7_,
             GtkToggleButton* button)
{
	PreferencesDialog* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	self = _data7_->self;
	g_return_if_fail (button != NULL);
	_tmp0_ = gtk_toggle_button_get_active (button);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		g_settings_set_int (_data7_->settings, "page-delay", 3000);
	}
}


static void
___lambda12__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                        gpointer self)
{
	__lambda12_ (self, _sender);
}


static void
__lambda13_ (Block7Data* _data7_,
             GtkToggleButton* button)
{
	PreferencesDialog* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	self = _data7_->self;
	g_return_if_fail (button != NULL);
	_tmp0_ = gtk_toggle_button_get_active (button);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		g_settings_set_int (_data7_->settings, "page-delay", 5000);
	}
}


static void
___lambda13__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                        gpointer self)
{
	__lambda13_ (self, _sender);
}


static void
__lambda14_ (Block7Data* _data7_,
             GtkToggleButton* button)
{
	PreferencesDialog* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	self = _data7_->self;
	g_return_if_fail (button != NULL);
	_tmp0_ = gtk_toggle_button_get_active (button);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		g_settings_set_int (_data7_->settings, "page-delay", 7000);
	}
}


static void
___lambda14__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                        gpointer self)
{
	__lambda14_ (self, _sender);
}


static void
__lambda15_ (Block7Data* _data7_,
             GtkToggleButton* button)
{
	PreferencesDialog* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	self = _data7_->self;
	g_return_if_fail (button != NULL);
	_tmp0_ = gtk_toggle_button_get_active (button);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		g_settings_set_int (_data7_->settings, "page-delay", 10000);
	}
}


static void
___lambda15__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                        gpointer self)
{
	__lambda15_ (self, _sender);
}


static void
__lambda16_ (Block7Data* _data7_,
             GtkToggleButton* button)
{
	PreferencesDialog* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	self = _data7_->self;
	g_return_if_fail (button != NULL);
	_tmp0_ = gtk_toggle_button_get_active (button);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		g_settings_set_int (_data7_->settings, "page-delay", 15000);
	}
}


static void
___lambda16__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                        gpointer self)
{
	__lambda16_ (self, _sender);
}


PreferencesDialog*
preferences_dialog_construct (GType object_type,
                              GSettings* settings,
                              gboolean use_header_bar)
{
	PreferencesDialog * self = NULL;
	Block7Data* _data7_;
	GSettings* _tmp0_;
	gint _tmp1_ = 0;
	GSettings* _tmp3_;
	GtkTreeIter iter = {0};
	GtkListStore* _tmp4_;
	GtkTreeIter _tmp5_ = {0};
	GtkListStore* _tmp6_;
	GtkTreeIter _tmp7_;
	GtkListStore* _tmp8_;
	GtkTreeIter _tmp9_ = {0};
	GtkListStore* _tmp10_;
	GtkTreeIter _tmp11_;
	GtkListStore* _tmp12_;
	GtkTreeIter _tmp13_ = {0};
	GtkListStore* _tmp14_;
	GtkTreeIter _tmp15_;
	GtkListStore* _tmp16_;
	GtkTreeIter _tmp17_ = {0};
	GtkListStore* _tmp18_;
	GtkTreeIter _tmp19_;
	GtkListStore* _tmp20_;
	GtkTreeIter _tmp21_ = {0};
	GtkListStore* _tmp22_;
	GtkTreeIter _tmp23_;
	GtkListStore* _tmp24_;
	GtkTreeIter _tmp25_ = {0};
	GtkListStore* _tmp26_;
	GtkTreeIter _tmp27_;
	GtkListStore* _tmp28_;
	GtkTreeIter _tmp29_ = {0};
	GtkListStore* _tmp30_;
	GtkTreeIter _tmp31_;
	GtkCellRendererText* renderer = NULL;
	GtkCellRendererText* _tmp32_;
	GtkComboBox* _tmp33_;
	GtkCellRendererText* _tmp34_;
	GtkComboBox* _tmp35_;
	GtkCellRendererText* _tmp36_;
	gint dpi = 0;
	gint _tmp37_;
	GtkComboBox* _tmp38_;
	gint _tmp39_;
	GtkComboBox* _tmp40_;
	gint _tmp41_;
	GtkComboBox* _tmp42_;
	gint _tmp43_;
	GtkComboBox* _tmp44_;
	GtkRadioButton* _tmp45_;
	GtkRadioButton* _tmp46_;
	GtkRadioButton* _tmp47_;
	GtkCellRendererText* _tmp48_;
	GtkComboBox* _tmp49_;
	GtkCellRendererText* _tmp50_;
	GtkComboBox* _tmp51_;
	GtkCellRendererText* _tmp52_;
	gdouble lower = 0.0;
	GtkAdjustment* _tmp53_;
	gdouble _tmp54_;
	gdouble _tmp55_;
	gchar* darker_label = NULL;
	gchar* _tmp56_;
	gdouble upper = 0.0;
	GtkAdjustment* _tmp57_;
	gdouble _tmp58_;
	gdouble _tmp59_;
	gchar* lighter_label = NULL;
	gchar* _tmp60_;
	GtkScale* _tmp61_;
	gdouble _tmp62_;
	GtkScale* _tmp63_;
	GtkScale* _tmp64_;
	gdouble _tmp65_;
	GtkAdjustment* _tmp66_;
	GtkAdjustment* _tmp67_;
	GtkAdjustment* _tmp68_;
	gdouble _tmp69_;
	gdouble _tmp70_;
	gchar* less_label = NULL;
	gchar* _tmp71_;
	GtkAdjustment* _tmp72_;
	gdouble _tmp73_;
	gdouble _tmp74_;
	gchar* more_label = NULL;
	gchar* _tmp75_;
	GtkScale* _tmp76_;
	gdouble _tmp77_;
	GtkScale* _tmp78_;
	GtkScale* _tmp79_;
	gdouble _tmp80_;
	GtkAdjustment* _tmp81_;
	GtkAdjustment* _tmp82_;
	gint paper_width = 0;
	gint paper_height = 0;
	GtkComboBox* _tmp83_;
	GtkRadioButton* _tmp84_;
	GtkRadioButton* _tmp85_;
	GtkRadioButton* _tmp86_;
	GtkRadioButton* _tmp87_;
	GtkRadioButton* _tmp88_;
	g_return_val_if_fail (settings != NULL, NULL);
	_data7_ = g_slice_new0 (Block7Data);
	_data7_->_ref_count_ = 1;
	_tmp0_ = _g_object_ref0 (settings);
	_g_object_unref0 (_data7_->settings);
	_data7_->settings = _tmp0_;
	if (use_header_bar) {
		_tmp1_ = 1;
	} else {
		_tmp1_ = -1;
	}
	self = (PreferencesDialog*) g_object_new (object_type, "use-header-bar", _tmp1_, NULL);
	_data7_->self = g_object_ref (self);
	if (use_header_bar) {
		GtkButton* _tmp2_;
		_tmp2_ = self->priv->preferences_close_button;
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, FALSE);
	}
	_tmp3_ = _g_object_ref0 (_data7_->settings);
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = _tmp3_;
	_tmp4_ = self->priv->paper_size_model;
	gtk_list_store_append (_tmp4_, &_tmp5_);
	iter = _tmp5_;
	_tmp6_ = self->priv->paper_size_model;
	_tmp7_ = iter;
	gtk_list_store_set (_tmp6_, &_tmp7_, 0, 0, 1, 0, 2, _ ("Automatic"), -1, -1);
	_tmp8_ = self->priv->paper_size_model;
	gtk_list_store_append (_tmp8_, &_tmp9_);
	iter = _tmp9_;
	_tmp10_ = self->priv->paper_size_model;
	_tmp11_ = iter;
	gtk_list_store_set (_tmp10_, &_tmp11_, 0, 1050, 1, 1480, 2, "A6", -1, -1);
	_tmp12_ = self->priv->paper_size_model;
	gtk_list_store_append (_tmp12_, &_tmp13_);
	iter = _tmp13_;
	_tmp14_ = self->priv->paper_size_model;
	_tmp15_ = iter;
	gtk_list_store_set (_tmp14_, &_tmp15_, 0, 1480, 1, 2100, 2, "A5", -1, -1);
	_tmp16_ = self->priv->paper_size_model;
	gtk_list_store_append (_tmp16_, &_tmp17_);
	iter = _tmp17_;
	_tmp18_ = self->priv->paper_size_model;
	_tmp19_ = iter;
	gtk_list_store_set (_tmp18_, &_tmp19_, 0, 2100, 1, 2970, 2, "A4", -1, -1);
	_tmp20_ = self->priv->paper_size_model;
	gtk_list_store_append (_tmp20_, &_tmp21_);
	iter = _tmp21_;
	_tmp22_ = self->priv->paper_size_model;
	_tmp23_ = iter;
	gtk_list_store_set (_tmp22_, &_tmp23_, 0, 2159, 1, 2794, 2, "Letter", -1, -1);
	_tmp24_ = self->priv->paper_size_model;
	gtk_list_store_append (_tmp24_, &_tmp25_);
	iter = _tmp25_;
	_tmp26_ = self->priv->paper_size_model;
	_tmp27_ = iter;
	gtk_list_store_set (_tmp26_, &_tmp27_, 0, 2159, 1, 3556, 2, "Legal", -1, -1);
	_tmp28_ = self->priv->paper_size_model;
	gtk_list_store_append (_tmp28_, &_tmp29_);
	iter = _tmp29_;
	_tmp30_ = self->priv->paper_size_model;
	_tmp31_ = iter;
	gtk_list_store_set (_tmp30_, &_tmp31_, 0, 1016, 1, 1524, 2, "4×6", -1, -1);
	_tmp32_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
	g_object_ref_sink (_tmp32_);
	renderer = _tmp32_;
	_tmp33_ = self->priv->device_combo;
	_tmp34_ = renderer;
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp33_, (GtkCellRenderer*) _tmp34_, TRUE);
	_tmp35_ = self->priv->device_combo;
	_tmp36_ = renderer;
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp35_, (GtkCellRenderer*) _tmp36_, "text", 1);
	dpi = g_settings_get_int (_data7_->settings, "text-dpi");
	_tmp37_ = dpi;
	if (_tmp37_ <= 0) {
		dpi = DEFAULT_TEXT_DPI;
	}
	_tmp38_ = self->priv->text_dpi_combo;
	_tmp39_ = dpi;
	preferences_dialog_set_dpi_combo (self, _tmp38_, DEFAULT_TEXT_DPI, _tmp39_);
	_tmp40_ = self->priv->text_dpi_combo;
	g_signal_connect_data (_tmp40_, "changed", (GCallback) ___lambda4__gtk_combo_box_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	dpi = g_settings_get_int (_data7_->settings, "photo-dpi");
	_tmp41_ = dpi;
	if (_tmp41_ <= 0) {
		dpi = DEFAULT_PHOTO_DPI;
	}
	_tmp42_ = self->priv->photo_dpi_combo;
	_tmp43_ = dpi;
	preferences_dialog_set_dpi_combo (self, _tmp42_, DEFAULT_PHOTO_DPI, _tmp43_);
	_tmp44_ = self->priv->photo_dpi_combo;
	g_signal_connect_data (_tmp44_, "changed", (GCallback) ___lambda5__gtk_combo_box_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	preferences_dialog_set_page_side (self, (ScanType) g_settings_get_enum (_data7_->settings, "page-side"));
	_tmp45_ = self->priv->front_side_button;
	g_signal_connect_data ((GtkToggleButton*) _tmp45_, "toggled", (GCallback) ___lambda6__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_tmp46_ = self->priv->back_side_button;
	g_signal_connect_data ((GtkToggleButton*) _tmp46_, "toggled", (GCallback) ___lambda7__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_tmp47_ = self->priv->both_side_button;
	g_signal_connect_data ((GtkToggleButton*) _tmp47_, "toggled", (GCallback) ___lambda8__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_tmp48_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
	g_object_ref_sink (_tmp48_);
	_g_object_unref0 (renderer);
	renderer = _tmp48_;
	_tmp49_ = self->priv->paper_size_combo;
	_tmp50_ = renderer;
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp49_, (GtkCellRenderer*) _tmp50_, TRUE);
	_tmp51_ = self->priv->paper_size_combo;
	_tmp52_ = renderer;
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp51_, (GtkCellRenderer*) _tmp52_, "text", 2);
	_tmp53_ = self->priv->brightness_adjustment;
	_tmp54_ = gtk_adjustment_get_lower (_tmp53_);
	_tmp55_ = _tmp54_;
	lower = _tmp55_;
	_tmp56_ = g_strdup_printf ("<small>%s</small>", _ ("Darker"));
	darker_label = _tmp56_;
	_tmp57_ = self->priv->brightness_adjustment;
	_tmp58_ = gtk_adjustment_get_upper (_tmp57_);
	_tmp59_ = _tmp58_;
	upper = _tmp59_;
	_tmp60_ = g_strdup_printf ("<small>%s</small>", _ ("Lighter"));
	lighter_label = _tmp60_;
	_tmp61_ = self->priv->brightness_scale;
	_tmp62_ = lower;
	gtk_scale_add_mark (_tmp61_, _tmp62_, GTK_POS_BOTTOM, darker_label);
	_tmp63_ = self->priv->brightness_scale;
	gtk_scale_add_mark (_tmp63_, (gdouble) 0, GTK_POS_BOTTOM, NULL);
	_tmp64_ = self->priv->brightness_scale;
	_tmp65_ = upper;
	gtk_scale_add_mark (_tmp64_, _tmp65_, GTK_POS_BOTTOM, lighter_label);
	_tmp66_ = self->priv->brightness_adjustment;
	gtk_adjustment_set_value (_tmp66_, (gdouble) g_settings_get_int (_data7_->settings, "brightness"));
	_tmp67_ = self->priv->brightness_adjustment;
	g_signal_connect_data (_tmp67_, "value-changed", (GCallback) ___lambda9__gtk_adjustment_value_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_tmp68_ = self->priv->contrast_adjustment;
	_tmp69_ = gtk_adjustment_get_lower (_tmp68_);
	_tmp70_ = _tmp69_;
	lower = _tmp70_;
	_tmp71_ = g_strdup_printf ("<small>%s</small>", _ ("Less"));
	less_label = _tmp71_;
	_tmp72_ = self->priv->contrast_adjustment;
	_tmp73_ = gtk_adjustment_get_upper (_tmp72_);
	_tmp74_ = _tmp73_;
	upper = _tmp74_;
	_tmp75_ = g_strdup_printf ("<small>%s</small>", _ ("More"));
	more_label = _tmp75_;
	_tmp76_ = self->priv->contrast_scale;
	_tmp77_ = lower;
	gtk_scale_add_mark (_tmp76_, _tmp77_, GTK_POS_BOTTOM, less_label);
	_tmp78_ = self->priv->contrast_scale;
	gtk_scale_add_mark (_tmp78_, (gdouble) 0, GTK_POS_BOTTOM, NULL);
	_tmp79_ = self->priv->contrast_scale;
	_tmp80_ = upper;
	gtk_scale_add_mark (_tmp79_, _tmp80_, GTK_POS_BOTTOM, more_label);
	_tmp81_ = self->priv->contrast_adjustment;
	gtk_adjustment_set_value (_tmp81_, (gdouble) g_settings_get_int (_data7_->settings, "contrast"));
	_tmp82_ = self->priv->contrast_adjustment;
	g_signal_connect_data (_tmp82_, "value-changed", (GCallback) ___lambda10__gtk_adjustment_value_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	paper_width = g_settings_get_int (_data7_->settings, "paper-width");
	paper_height = g_settings_get_int (_data7_->settings, "paper-height");
	preferences_dialog_set_paper_size (self, paper_width, paper_height);
	_tmp83_ = self->priv->paper_size_combo;
	g_signal_connect_data (_tmp83_, "changed", (GCallback) ___lambda11__gtk_combo_box_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	preferences_dialog_set_page_delay (self, g_settings_get_int (_data7_->settings, "page-delay"));
	_tmp84_ = self->priv->page_delay_3s_button;
	g_signal_connect_data ((GtkToggleButton*) _tmp84_, "toggled", (GCallback) ___lambda12__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_tmp85_ = self->priv->page_delay_5s_button;
	g_signal_connect_data ((GtkToggleButton*) _tmp85_, "toggled", (GCallback) ___lambda13__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_tmp86_ = self->priv->page_delay_7s_button;
	g_signal_connect_data ((GtkToggleButton*) _tmp86_, "toggled", (GCallback) ___lambda14__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_tmp87_ = self->priv->page_delay_10s_button;
	g_signal_connect_data ((GtkToggleButton*) _tmp87_, "toggled", (GCallback) ___lambda15__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_tmp88_ = self->priv->page_delay_15s_button;
	g_signal_connect_data ((GtkToggleButton*) _tmp88_, "toggled", (GCallback) ___lambda16__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_g_free0 (more_label);
	_g_free0 (less_label);
	_g_free0 (lighter_label);
	_g_free0 (darker_label);
	_g_object_unref0 (renderer);
	block7_data_unref (_data7_);
	_data7_ = NULL;
	return self;
}


PreferencesDialog*
preferences_dialog_new (GSettings* settings,
                        gboolean use_header_bar)
{
	return preferences_dialog_construct (TYPE_PREFERENCES_DIALOG, settings, use_header_bar);
}


static gpointer
_scan_device_ref0 (gpointer self)
{
	return self ? scan_device_ref (self) : NULL;
}


void
preferences_dialog_set_scan_devices (PreferencesDialog* self,
                                     GList* devices)
{
	gboolean have_selection = FALSE;
	gboolean _tmp0_;
	gint index = 0;
	GtkTreeIter iter = {0};
	gboolean _tmp48_;
	g_return_if_fail (self != NULL);
	self->priv->setting_devices = TRUE;
	have_selection = FALSE;
	_tmp0_ = self->priv->user_selected_device;
	if (_tmp0_) {
		GtkComboBox* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		_tmp1_ = self->priv->device_combo;
		_tmp2_ = gtk_combo_box_get_active (_tmp1_);
		_tmp3_ = _tmp2_;
		have_selection = _tmp3_ >= 0;
	}
	index = 0;
	{
		GList* device_collection = NULL;
		GList* device_it = NULL;
		device_collection = devices;
		for (device_it = device_collection; device_it != NULL; device_it = device_it->next) {
			ScanDevice* _tmp4_;
			ScanDevice* device = NULL;
			_tmp4_ = _scan_device_ref0 ((ScanDevice*) device_it->data);
			device = _tmp4_;
			{
				gint n_delete = 0;
				GtkListStore* _tmp5_;
				gint _tmp6_;
				GtkTreeIter _tmp7_ = {0};
				gboolean _tmp8_;
				gint _tmp20_;
				gint _tmp42_;
				n_delete = -1;
				_tmp5_ = self->priv->device_model;
				_tmp6_ = index;
				_tmp8_ = gtk_tree_model_iter_nth_child ((GtkTreeModel*) _tmp5_, &_tmp7_, NULL, _tmp6_);
				iter = _tmp7_;
				if (_tmp8_) {
					gint i = 0;
					i = 0;
					{
						gboolean _tmp9_ = FALSE;
						_tmp9_ = TRUE;
						while (TRUE) {
							gchar* name = NULL;
							gboolean matched = FALSE;
							GtkListStore* _tmp12_;
							GtkTreeIter _tmp13_;
							const gchar* _tmp14_;
							ScanDevice* _tmp15_;
							const gchar* _tmp16_;
							gboolean _tmp17_;
							gint _tmp19_;
							if (!_tmp9_) {
								GtkListStore* _tmp10_;
								gboolean _tmp11_;
								_tmp10_ = self->priv->device_model;
								_tmp11_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp10_, &iter);
								if (!_tmp11_) {
									break;
								}
							}
							_tmp9_ = FALSE;
							_tmp12_ = self->priv->device_model;
							_tmp13_ = iter;
							gtk_tree_model_get ((GtkTreeModel*) _tmp12_, &_tmp13_, 0, &name, -1, -1);
							_tmp14_ = name;
							_tmp15_ = device;
							_tmp16_ = _tmp15_->name;
							matched = g_strcmp0 (_tmp14_, _tmp16_) == 0;
							_tmp17_ = matched;
							if (_tmp17_) {
								gint _tmp18_;
								_tmp18_ = i;
								n_delete = _tmp18_;
								_g_free0 (name);
								break;
							}
							_tmp19_ = i;
							i = _tmp19_ + 1;
							_g_free0 (name);
						}
					}
				}
				_tmp20_ = n_delete;
				if (_tmp20_ >= 0) {
					gint i = 0;
					GtkListStore* _tmp21_;
					GtkTreeIter _tmp22_;
					ScanDevice* _tmp23_;
					const gchar* _tmp24_;
					_tmp21_ = self->priv->device_model;
					_tmp22_ = iter;
					_tmp23_ = device;
					_tmp24_ = _tmp23_->label;
					gtk_list_store_set (_tmp21_, &_tmp22_, 1, _tmp24_, -1, -1);
					{
						gboolean _tmp25_ = FALSE;
						i = 0;
						_tmp25_ = TRUE;
						while (TRUE) {
							gint _tmp27_;
							gint _tmp28_;
							GtkListStore* _tmp29_;
							gint _tmp30_;
							GtkTreeIter _tmp31_ = {0};
							GtkListStore* _tmp32_;
							if (!_tmp25_) {
								gint _tmp26_;
								_tmp26_ = i;
								i = _tmp26_ + 1;
							}
							_tmp25_ = FALSE;
							_tmp27_ = i;
							_tmp28_ = n_delete;
							if (!(_tmp27_ < _tmp28_)) {
								break;
							}
							_tmp29_ = self->priv->device_model;
							_tmp30_ = index;
							gtk_tree_model_iter_nth_child ((GtkTreeModel*) _tmp29_, &_tmp31_, NULL, _tmp30_);
							iter = _tmp31_;
							_tmp32_ = self->priv->device_model;
							gtk_list_store_remove (_tmp32_, &iter);
						}
					}
				} else {
					GtkListStore* _tmp33_;
					gint _tmp34_;
					GtkTreeIter _tmp35_ = {0};
					GtkListStore* _tmp36_;
					GtkTreeIter _tmp37_;
					ScanDevice* _tmp38_;
					const gchar* _tmp39_;
					ScanDevice* _tmp40_;
					const gchar* _tmp41_;
					_tmp33_ = self->priv->device_model;
					_tmp34_ = index;
					gtk_list_store_insert (_tmp33_, &_tmp35_, _tmp34_);
					iter = _tmp35_;
					_tmp36_ = self->priv->device_model;
					_tmp37_ = iter;
					_tmp38_ = device;
					_tmp39_ = _tmp38_->name;
					_tmp40_ = device;
					_tmp41_ = _tmp40_->label;
					gtk_list_store_set (_tmp36_, &_tmp37_, 0, _tmp39_, 1, _tmp41_, -1, -1);
				}
				_tmp42_ = index;
				index = _tmp42_ + 1;
				_scan_device_unref0 (device);
			}
		}
	}
	while (TRUE) {
		GtkListStore* _tmp43_;
		gint _tmp44_;
		GtkTreeIter _tmp45_ = {0};
		gboolean _tmp46_;
		GtkListStore* _tmp47_;
		_tmp43_ = self->priv->device_model;
		_tmp44_ = index;
		_tmp46_ = gtk_tree_model_iter_nth_child ((GtkTreeModel*) _tmp43_, &_tmp45_, NULL, _tmp44_);
		iter = _tmp45_;
		if (!_tmp46_) {
			break;
		}
		_tmp47_ = self->priv->device_model;
		gtk_list_store_remove (_tmp47_, &iter);
	}
	_tmp48_ = have_selection;
	if (!_tmp48_) {
		gchar* device = NULL;
		GSettings* _tmp49_;
		gchar* _tmp50_;
		gboolean _tmp51_ = FALSE;
		const gchar* _tmp52_;
		_tmp49_ = self->priv->settings;
		_tmp50_ = g_settings_get_string (_tmp49_, "selected-device");
		device = _tmp50_;
		_tmp52_ = device;
		if (_tmp52_ != NULL) {
			const gchar* _tmp53_;
			GtkTreeIter _tmp54_ = {0};
			gboolean _tmp55_;
			_tmp53_ = device;
			_tmp55_ = preferences_dialog_find_scan_device (self, _tmp53_, &_tmp54_);
			iter = _tmp54_;
			_tmp51_ = _tmp55_;
		} else {
			_tmp51_ = FALSE;
		}
		if (_tmp51_) {
			GtkComboBox* _tmp56_;
			GtkTreeIter _tmp57_;
			_tmp56_ = self->priv->device_combo;
			_tmp57_ = iter;
			gtk_combo_box_set_active_iter (_tmp56_, &_tmp57_);
		} else {
			GtkComboBox* _tmp58_;
			_tmp58_ = self->priv->device_combo;
			gtk_combo_box_set_active (_tmp58_, 0);
		}
		_g_free0 (device);
	}
	self->priv->setting_devices = FALSE;
}


gchar*
preferences_dialog_get_selected_device (PreferencesDialog* self)
{
	gchar* result = NULL;
	GtkTreeIter iter = {0};
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->device_combo;
	_tmp2_ = gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
	iter = _tmp1_;
	if (_tmp2_) {
		gchar* device = NULL;
		GtkListStore* _tmp3_;
		GtkTreeIter _tmp4_;
		_tmp3_ = self->priv->device_model;
		_tmp4_ = iter;
		gtk_tree_model_get ((GtkTreeModel*) _tmp3_, &_tmp4_, 0, &device, -1, -1);
		result = device;
		return result;
	}
	result = NULL;
	return result;
}


gchar*
preferences_dialog_get_selected_device_label (PreferencesDialog* self)
{
	gchar* result = NULL;
	GtkTreeIter iter = {0};
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->device_combo;
	_tmp2_ = gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
	iter = _tmp1_;
	if (_tmp2_) {
		gchar* label = NULL;
		GtkListStore* _tmp3_;
		GtkTreeIter _tmp4_;
		_tmp3_ = self->priv->device_model;
		_tmp4_ = iter;
		gtk_tree_model_get ((GtkTreeModel*) _tmp3_, &_tmp4_, 1, &label, -1, -1);
		result = label;
		return result;
	}
	result = NULL;
	return result;
}


void
preferences_dialog_set_selected_device (PreferencesDialog* self,
                                        const gchar* device)
{
	GtkTreeIter iter = {0};
	GtkTreeIter _tmp0_ = {0};
	gboolean _tmp1_;
	GtkComboBox* _tmp2_;
	GtkTreeIter _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (device != NULL);
	self->priv->user_selected_device = TRUE;
	_tmp1_ = preferences_dialog_find_scan_device (self, device, &_tmp0_);
	iter = _tmp0_;
	if (!_tmp1_) {
		return;
	}
	_tmp2_ = self->priv->device_combo;
	_tmp3_ = iter;
	gtk_combo_box_set_active_iter (_tmp2_, &_tmp3_);
}


static gboolean
preferences_dialog_find_scan_device (PreferencesDialog* self,
                                     const gchar* device,
                                     GtkTreeIter* iter)
{
	GtkTreeIter _vala_iter = {0};
	gboolean result = FALSE;
	gboolean have_iter = FALSE;
	GtkListStore* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (device != NULL, FALSE);
	have_iter = FALSE;
	_tmp0_ = self->priv->device_model;
	_tmp2_ = gtk_tree_model_get_iter_first ((GtkTreeModel*) _tmp0_, &_tmp1_);
	_vala_iter = _tmp1_;
	if (_tmp2_) {
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gchar* d = NULL;
				GtkListStore* _tmp8_;
				GtkTreeIter _tmp9_;
				const gchar* _tmp10_;
				if (!_tmp3_) {
					gboolean _tmp4_ = FALSE;
					gboolean _tmp5_;
					_tmp5_ = have_iter;
					if (!_tmp5_) {
						GtkListStore* _tmp6_;
						gboolean _tmp7_;
						_tmp6_ = self->priv->device_model;
						_tmp7_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp6_, &_vala_iter);
						_tmp4_ = _tmp7_;
					} else {
						_tmp4_ = FALSE;
					}
					if (!_tmp4_) {
						break;
					}
				}
				_tmp3_ = FALSE;
				_tmp8_ = self->priv->device_model;
				_tmp9_ = _vala_iter;
				gtk_tree_model_get ((GtkTreeModel*) _tmp8_, &_tmp9_, 0, &d, -1, -1);
				_tmp10_ = d;
				if (g_strcmp0 (_tmp10_, device) == 0) {
					have_iter = TRUE;
				}
				_g_free0 (d);
			}
		}
	}
	result = have_iter;
	if (iter) {
		*iter = _vala_iter;
	}
	return result;
}


static void
preferences_dialog_set_page_side (PreferencesDialog* self,
                                  ScanType page_side)
{
	g_return_if_fail (self != NULL);
	switch (page_side) {
		case SCAN_TYPE_ADF_FRONT:
		{
			GtkRadioButton* _tmp0_;
			_tmp0_ = self->priv->front_side_button;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, TRUE);
			break;
		}
		case SCAN_TYPE_ADF_BACK:
		{
			GtkRadioButton* _tmp1_;
			_tmp1_ = self->priv->back_side_button;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp1_, TRUE);
			break;
		}
		default:
		case SCAN_TYPE_ADF_BOTH:
		{
			GtkRadioButton* _tmp2_;
			_tmp2_ = self->priv->both_side_button;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp2_, TRUE);
			break;
		}
	}
}


ScanType
preferences_dialog_get_page_side (PreferencesDialog* self)
{
	ScanType result = 0;
	GtkRadioButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->front_side_button;
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		result = SCAN_TYPE_ADF_FRONT;
		return result;
	} else {
		GtkRadioButton* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
		_tmp3_ = self->priv->back_side_button;
		_tmp4_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp3_);
		_tmp5_ = _tmp4_;
		if (_tmp5_) {
			result = SCAN_TYPE_ADF_BACK;
			return result;
		} else {
			result = SCAN_TYPE_ADF_BOTH;
			return result;
		}
	}
}


void
preferences_dialog_set_paper_size (PreferencesDialog* self,
                                   gint width,
                                   gint height)
{
	GtkTreeIter iter = {0};
	gboolean have_iter = FALSE;
	gboolean _tmp12_;
	gboolean _tmp16_;
	g_return_if_fail (self != NULL);
	{
		GtkListStore* _tmp0_;
		GtkTreeIter _tmp1_ = {0};
		gboolean _tmp2_;
		gboolean _tmp3_ = FALSE;
		_tmp0_ = self->priv->paper_size_model;
		_tmp2_ = gtk_tree_model_get_iter_first ((GtkTreeModel*) _tmp0_, &_tmp1_);
		iter = _tmp1_;
		have_iter = _tmp2_;
		_tmp3_ = TRUE;
		while (TRUE) {
			gboolean _tmp6_;
			gint w = 0;
			gint h = 0;
			GtkListStore* _tmp7_;
			GtkTreeIter _tmp8_;
			gboolean _tmp9_ = FALSE;
			gint _tmp10_;
			if (!_tmp3_) {
				GtkListStore* _tmp4_;
				gboolean _tmp5_;
				_tmp4_ = self->priv->paper_size_model;
				_tmp5_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp4_, &iter);
				have_iter = _tmp5_;
			}
			_tmp3_ = FALSE;
			_tmp6_ = have_iter;
			if (!_tmp6_) {
				break;
			}
			_tmp7_ = self->priv->paper_size_model;
			_tmp8_ = iter;
			gtk_tree_model_get ((GtkTreeModel*) _tmp7_, &_tmp8_, 0, &w, 1, &h, -1, -1);
			_tmp10_ = w;
			if (_tmp10_ == width) {
				gint _tmp11_;
				_tmp11_ = h;
				_tmp9_ = _tmp11_ == height;
			} else {
				_tmp9_ = FALSE;
			}
			if (_tmp9_) {
				break;
			}
		}
	}
	_tmp12_ = have_iter;
	if (!_tmp12_) {
		GtkListStore* _tmp13_;
		GtkTreeIter _tmp14_ = {0};
		gboolean _tmp15_;
		_tmp13_ = self->priv->paper_size_model;
		_tmp15_ = gtk_tree_model_get_iter_first ((GtkTreeModel*) _tmp13_, &_tmp14_);
		iter = _tmp14_;
		have_iter = _tmp15_;
	}
	_tmp16_ = have_iter;
	if (_tmp16_) {
		GtkComboBox* _tmp17_;
		GtkTreeIter _tmp18_;
		_tmp17_ = self->priv->paper_size_combo;
		_tmp18_ = iter;
		gtk_combo_box_set_active_iter (_tmp17_, &_tmp18_);
	}
}


gint
preferences_dialog_get_text_dpi (PreferencesDialog* self)
{
	gint result = 0;
	GtkTreeIter iter = {0};
	gint dpi = 0;
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	dpi = DEFAULT_TEXT_DPI;
	_tmp0_ = self->priv->text_dpi_combo;
	_tmp2_ = gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
	iter = _tmp1_;
	if (_tmp2_) {
		GtkListStore* _tmp3_;
		GtkTreeIter _tmp4_;
		_tmp3_ = self->priv->text_dpi_model;
		_tmp4_ = iter;
		gtk_tree_model_get ((GtkTreeModel*) _tmp3_, &_tmp4_, 0, &dpi, -1, -1);
	}
	result = dpi;
	return result;
}


gint
preferences_dialog_get_photo_dpi (PreferencesDialog* self)
{
	gint result = 0;
	GtkTreeIter iter = {0};
	gint dpi = 0;
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	dpi = DEFAULT_PHOTO_DPI;
	_tmp0_ = self->priv->photo_dpi_combo;
	_tmp2_ = gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
	iter = _tmp1_;
	if (_tmp2_) {
		GtkListStore* _tmp3_;
		GtkTreeIter _tmp4_;
		_tmp3_ = self->priv->photo_dpi_model;
		_tmp4_ = iter;
		gtk_tree_model_get ((GtkTreeModel*) _tmp3_, &_tmp4_, 0, &dpi, -1, -1);
	}
	result = dpi;
	return result;
}


gboolean
preferences_dialog_get_paper_size (PreferencesDialog* self,
                                   gint* width,
                                   gint* height)
{
	gint _vala_width = 0;
	gint _vala_height = 0;
	gboolean result = FALSE;
	GtkTreeIter iter = {0};
	gint _tmp0_;
	GtkComboBox* _tmp1_;
	GtkTreeIter _tmp2_ = {0};
	gboolean _tmp3_;
	g_return_val_if_fail (self != NULL, FALSE);
	_vala_height = 0;
	_tmp0_ = _vala_height;
	_vala_width = _tmp0_;
	_tmp1_ = self->priv->paper_size_combo;
	_tmp3_ = gtk_combo_box_get_active_iter (_tmp1_, &_tmp2_);
	iter = _tmp2_;
	if (_tmp3_) {
		GtkListStore* _tmp4_;
		GtkTreeIter _tmp5_;
		_tmp4_ = self->priv->paper_size_model;
		_tmp5_ = iter;
		gtk_tree_model_get ((GtkTreeModel*) _tmp4_, &_tmp5_, 0, &_vala_width, 1, &_vala_height, -1, -1);
		result = TRUE;
		if (width) {
			*width = _vala_width;
		}
		if (height) {
			*height = _vala_height;
		}
		return result;
	}
	result = FALSE;
	if (width) {
		*width = _vala_width;
	}
	if (height) {
		*height = _vala_height;
	}
	return result;
}


gint
preferences_dialog_get_brightness (PreferencesDialog* self)
{
	gint result = 0;
	GtkAdjustment* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->brightness_adjustment;
	_tmp1_ = gtk_adjustment_get_value (_tmp0_);
	_tmp2_ = _tmp1_;
	result = (gint) _tmp2_;
	return result;
}


void
preferences_dialog_set_brightness (PreferencesDialog* self,
                                   gint brightness)
{
	GtkAdjustment* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->brightness_adjustment;
	gtk_adjustment_set_value (_tmp0_, (gdouble) brightness);
}


gint
preferences_dialog_get_contrast (PreferencesDialog* self)
{
	gint result = 0;
	GtkAdjustment* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->contrast_adjustment;
	_tmp1_ = gtk_adjustment_get_value (_tmp0_);
	_tmp2_ = _tmp1_;
	result = (gint) _tmp2_;
	return result;
}


void
preferences_dialog_set_contrast (PreferencesDialog* self,
                                 gint contrast)
{
	GtkAdjustment* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->contrast_adjustment;
	gtk_adjustment_set_value (_tmp0_, (gdouble) contrast);
}


gint
preferences_dialog_get_page_delay (PreferencesDialog* self)
{
	gint result = 0;
	GtkRadioButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->page_delay_15s_button;
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		result = 15000;
		return result;
	} else {
		GtkRadioButton* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
		_tmp3_ = self->priv->page_delay_10s_button;
		_tmp4_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp3_);
		_tmp5_ = _tmp4_;
		if (_tmp5_) {
			result = 10000;
			return result;
		} else {
			GtkRadioButton* _tmp6_;
			gboolean _tmp7_;
			gboolean _tmp8_;
			_tmp6_ = self->priv->page_delay_7s_button;
			_tmp7_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp6_);
			_tmp8_ = _tmp7_;
			if (_tmp8_) {
				result = 7000;
				return result;
			} else {
				GtkRadioButton* _tmp9_;
				gboolean _tmp10_;
				gboolean _tmp11_;
				_tmp9_ = self->priv->page_delay_5s_button;
				_tmp10_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp9_);
				_tmp11_ = _tmp10_;
				if (_tmp11_) {
					result = 5000;
					return result;
				} else {
					result = 3000;
					return result;
				}
			}
		}
	}
}


void
preferences_dialog_set_page_delay (PreferencesDialog* self,
                                   gint page_delay)
{
	g_return_if_fail (self != NULL);
	if (page_delay >= 15000) {
		GtkRadioButton* _tmp0_;
		_tmp0_ = self->priv->page_delay_15s_button;
		gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, TRUE);
	} else {
		if (page_delay >= 1000) {
			GtkRadioButton* _tmp1_;
			_tmp1_ = self->priv->page_delay_10s_button;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp1_, TRUE);
		} else {
			if (page_delay >= 7000) {
				GtkRadioButton* _tmp2_;
				_tmp2_ = self->priv->page_delay_7s_button;
				gtk_toggle_button_set_active ((GtkToggleButton*) _tmp2_, TRUE);
			} else {
				if (page_delay >= 5000) {
					GtkRadioButton* _tmp3_;
					_tmp3_ = self->priv->page_delay_5s_button;
					gtk_toggle_button_set_active ((GtkToggleButton*) _tmp3_, TRUE);
				} else {
					GtkRadioButton* _tmp4_;
					_tmp4_ = self->priv->page_delay_3s_button;
					gtk_toggle_button_set_active ((GtkToggleButton*) _tmp4_, TRUE);
				}
			}
		}
	}
}


static void
preferences_dialog_set_dpi_combo (PreferencesDialog* self,
                                  GtkComboBox* combo,
                                  gint default_dpi,
                                  gint current_dpi)
{
	GtkCellRendererText* renderer = NULL;
	GtkCellRendererText* _tmp0_;
	GtkCellRendererText* _tmp1_;
	GtkCellRendererText* _tmp2_;
	GtkListStore* model = NULL;
	GtkTreeModel* _tmp3_;
	GtkTreeModel* _tmp4_;
	GtkListStore* _tmp5_;
	gint* scan_resolutions = NULL;
	gint* _tmp6_;
	gint scan_resolutions_length1;
	gint _scan_resolutions_size_;
	gint* _tmp7_;
	gint _tmp7__length1;
	g_return_if_fail (self != NULL);
	g_return_if_fail (combo != NULL);
	_tmp0_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
	g_object_ref_sink (_tmp0_);
	renderer = _tmp0_;
	_tmp1_ = renderer;
	gtk_cell_layout_pack_start ((GtkCellLayout*) combo, (GtkCellRenderer*) _tmp1_, TRUE);
	_tmp2_ = renderer;
	gtk_cell_layout_add_attribute ((GtkCellLayout*) combo, (GtkCellRenderer*) _tmp2_, "text", 1);
	_tmp3_ = gtk_combo_box_get_model (combo);
	_tmp4_ = _tmp3_;
	_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, gtk_list_store_get_type ()) ? ((GtkListStore*) _tmp4_) : NULL);
	model = _tmp5_;
	_tmp6_ = g_new0 (gint, 6);
	_tmp6_[0] = 75;
	_tmp6_[1] = 150;
	_tmp6_[2] = 300;
	_tmp6_[3] = 600;
	_tmp6_[4] = 1200;
	_tmp6_[5] = 2400;
	scan_resolutions = _tmp6_;
	scan_resolutions_length1 = 6;
	_scan_resolutions_size_ = scan_resolutions_length1;
	_tmp7_ = scan_resolutions;
	_tmp7__length1 = scan_resolutions_length1;
	{
		gint* dpi_collection = NULL;
		gint dpi_collection_length1 = 0;
		gint _dpi_collection_size_ = 0;
		gint dpi_it = 0;
		dpi_collection = _tmp7_;
		dpi_collection_length1 = _tmp7__length1;
		for (dpi_it = 0; dpi_it < _tmp7__length1; dpi_it = dpi_it + 1) {
			gint dpi = 0;
			dpi = dpi_collection[dpi_it];
			{
				gchar* label = NULL;
				gint _tmp8_;
				GtkTreeIter iter = {0};
				GtkListStore* _tmp19_;
				GtkTreeIter _tmp20_ = {0};
				GtkListStore* _tmp21_;
				GtkTreeIter _tmp22_;
				gint _tmp23_;
				const gchar* _tmp24_;
				gint _tmp25_;
				_tmp8_ = dpi;
				if (_tmp8_ == default_dpi) {
					gint _tmp9_;
					gchar* _tmp10_;
					_tmp9_ = dpi;
					_tmp10_ = g_strdup_printf (_ ("%d dpi (default)"), _tmp9_);
					_g_free0 (label);
					label = _tmp10_;
				} else {
					gint _tmp11_;
					_tmp11_ = dpi;
					if (_tmp11_ == 75) {
						gint _tmp12_;
						gchar* _tmp13_;
						_tmp12_ = dpi;
						_tmp13_ = g_strdup_printf (_ ("%d dpi (draft)"), _tmp12_);
						_g_free0 (label);
						label = _tmp13_;
					} else {
						gint _tmp14_;
						_tmp14_ = dpi;
						if (_tmp14_ == 1200) {
							gint _tmp15_;
							gchar* _tmp16_;
							_tmp15_ = dpi;
							_tmp16_ = g_strdup_printf (_ ("%d dpi (high resolution)"), _tmp15_);
							_g_free0 (label);
							label = _tmp16_;
						} else {
							gint _tmp17_;
							gchar* _tmp18_;
							_tmp17_ = dpi;
							_tmp18_ = g_strdup_printf (_ ("%d dpi"), _tmp17_);
							_g_free0 (label);
							label = _tmp18_;
						}
					}
				}
				_tmp19_ = model;
				gtk_list_store_append (_tmp19_, &_tmp20_);
				iter = _tmp20_;
				_tmp21_ = model;
				_tmp22_ = iter;
				_tmp23_ = dpi;
				_tmp24_ = label;
				gtk_list_store_set (_tmp21_, &_tmp22_, 0, _tmp23_, 1, _tmp24_, -1, -1);
				_tmp25_ = dpi;
				if (_tmp25_ == current_dpi) {
					GtkTreeIter _tmp26_;
					_tmp26_ = iter;
					gtk_combo_box_set_active_iter (combo, &_tmp26_);
				}
				_g_free0 (label);
			}
		}
	}
	scan_resolutions = (g_free (scan_resolutions), NULL);
	_g_object_unref0 (model);
	_g_object_unref0 (renderer);
}


static void
preferences_dialog_device_combo_changed_cb (PreferencesDialog* self,
                                            GtkWidget* widget)
{
	gboolean _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	_tmp0_ = self->priv->setting_devices;
	if (_tmp0_) {
		return;
	}
	self->priv->user_selected_device = TRUE;
	_tmp1_ = preferences_dialog_get_selected_device (self);
	_tmp2_ = _tmp1_;
	_tmp3_ = _tmp2_ != NULL;
	_g_free0 (_tmp2_);
	if (_tmp3_) {
		GSettings* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp4_ = self->priv->settings;
		_tmp5_ = preferences_dialog_get_selected_device (self);
		_tmp6_ = _tmp5_;
		g_settings_set_string (_tmp4_, "selected-device", _tmp6_);
		_g_free0 (_tmp6_);
	}
}


static void
_preferences_dialog_device_combo_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                   gpointer self)
{
	preferences_dialog_device_combo_changed_cb ((PreferencesDialog*) self, _sender);
}


static void
preferences_dialog_class_init (PreferencesDialogClass * klass)
{
	gint PreferencesDialog_private_offset;
	preferences_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PreferencesDialogPrivate));
	G_OBJECT_CLASS (klass)->finalize = preferences_dialog_finalize;
	PreferencesDialog_private_offset = g_type_class_get_instance_private_offset (klass);
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/SimpleScan/preferences-dialog.ui");
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "device_combo", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, device_combo));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "text_dpi_combo", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, text_dpi_combo));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "photo_dpi_combo", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, photo_dpi_combo));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "paper_size_combo", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, paper_size_combo));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "brightness_scale", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, brightness_scale));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "contrast_scale", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, contrast_scale));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "device_model", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, device_model));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "page_delay_3s_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, page_delay_3s_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "page_delay_5s_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, page_delay_5s_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "page_delay_7s_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, page_delay_7s_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "page_delay_10s_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, page_delay_10s_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "page_delay_15s_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, page_delay_15s_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "text_dpi_model", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, text_dpi_model));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "photo_dpi_model", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, photo_dpi_model));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "front_side_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, front_side_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "back_side_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, back_side_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "both_side_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, both_side_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "paper_size_model", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, paper_size_model));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "brightness_adjustment", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, brightness_adjustment));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "contrast_adjustment", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, contrast_adjustment));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "preferences_close_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, preferences_close_button));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "device_combo_changed_cb", G_CALLBACK(_preferences_dialog_device_combo_changed_cb_gtk_combo_box_changed));
}


static void
preferences_dialog_instance_init (PreferencesDialog * self)
{
	self->priv = PREFERENCES_DIALOG_GET_PRIVATE (self);
	gtk_widget_init_template (GTK_WIDGET (self));
}


static void
preferences_dialog_finalize (GObject * obj)
{
	PreferencesDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PREFERENCES_DIALOG, PreferencesDialog);
	_g_object_unref0 (self->priv->settings);
	_g_object_unref0 (self->priv->device_combo);
	_g_object_unref0 (self->priv->text_dpi_combo);
	_g_object_unref0 (self->priv->photo_dpi_combo);
	_g_object_unref0 (self->priv->paper_size_combo);
	_g_object_unref0 (self->priv->brightness_scale);
	_g_object_unref0 (self->priv->contrast_scale);
	_g_object_unref0 (self->priv->device_model);
	_g_object_unref0 (self->priv->page_delay_3s_button);
	_g_object_unref0 (self->priv->page_delay_5s_button);
	_g_object_unref0 (self->priv->page_delay_7s_button);
	_g_object_unref0 (self->priv->page_delay_10s_button);
	_g_object_unref0 (self->priv->page_delay_15s_button);
	_g_object_unref0 (self->priv->text_dpi_model);
	_g_object_unref0 (self->priv->photo_dpi_model);
	_g_object_unref0 (self->priv->front_side_button);
	_g_object_unref0 (self->priv->back_side_button);
	_g_object_unref0 (self->priv->both_side_button);
	_g_object_unref0 (self->priv->paper_size_model);
	_g_object_unref0 (self->priv->brightness_adjustment);
	_g_object_unref0 (self->priv->contrast_adjustment);
	_g_object_unref0 (self->priv->preferences_close_button);
	G_OBJECT_CLASS (preferences_dialog_parent_class)->finalize (obj);
}


GType
preferences_dialog_get_type (void)
{
	static volatile gsize preferences_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&preferences_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PreferencesDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) preferences_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PreferencesDialog), 0, (GInstanceInitFunc) preferences_dialog_instance_init, NULL };
		GType preferences_dialog_type_id;
		preferences_dialog_type_id = g_type_register_static (gtk_dialog_get_type (), "PreferencesDialog", &g_define_type_info, 0);
		g_once_init_leave (&preferences_dialog_type_id__volatile, preferences_dialog_type_id);
	}
	return preferences_dialog_type_id__volatile;
}


PageIcon*
page_icon_construct (GType object_type,
                     const gchar* text,
                     gdouble r,
                     gdouble g,
                     gdouble b)
{
	PageIcon * self = NULL;
	gchar* _tmp0_;
	g_return_val_if_fail (text != NULL, NULL);
	self = (PageIcon*) g_object_new (object_type, NULL);
	_tmp0_ = g_strdup (text);
	_g_free0 (self->priv->text);
	self->priv->text = _tmp0_;
	self->priv->r = r;
	self->priv->g = g;
	self->priv->b = b;
	return self;
}


PageIcon*
page_icon_new (const gchar* text,
               gdouble r,
               gdouble g,
               gdouble b)
{
	return page_icon_construct (TYPE_PAGE_ICON, text, r, g, b);
}


static void
page_icon_real_get_preferred_width (GtkWidget* base,
                                    gint* minimum_width,
                                    gint* natural_width)
{
	PageIcon * self;
	gint _vala_minimum_width = 0;
	gint _vala_natural_width = 0;
	self = (PageIcon*) base;
	_vala_natural_width = PAGE_ICON_MINIMUM_WIDTH;
	_vala_minimum_width = _vala_natural_width;
	if (minimum_width) {
		*minimum_width = _vala_minimum_width;
	}
	if (natural_width) {
		*natural_width = _vala_natural_width;
	}
}


static void
page_icon_real_get_preferred_height (GtkWidget* base,
                                     gint* minimum_height,
                                     gint* natural_height)
{
	PageIcon * self;
	gint _vala_minimum_height = 0;
	gint _vala_natural_height = 0;
	self = (PageIcon*) base;
	_vala_natural_height = (gint) round (PAGE_ICON_MINIMUM_WIDTH * G_SQRT2);
	_vala_minimum_height = _vala_natural_height;
	if (minimum_height) {
		*minimum_height = _vala_minimum_height;
	}
	if (natural_height) {
		*natural_height = _vala_natural_height;
	}
}


static void
page_icon_real_get_preferred_height_for_width (GtkWidget* base,
                                               gint width,
                                               gint* minimum_height,
                                               gint* natural_height)
{
	PageIcon * self;
	gint _vala_minimum_height = 0;
	gint _vala_natural_height = 0;
	self = (PageIcon*) base;
	_vala_natural_height = (gint) (width * G_SQRT2);
	_vala_minimum_height = _vala_natural_height;
	if (minimum_height) {
		*minimum_height = _vala_minimum_height;
	}
	if (natural_height) {
		*natural_height = _vala_natural_height;
	}
}


static void
page_icon_real_get_preferred_width_for_height (GtkWidget* base,
                                               gint height,
                                               gint* minimum_width,
                                               gint* natural_width)
{
	PageIcon * self;
	gint _vala_minimum_width = 0;
	gint _vala_natural_width = 0;
	self = (PageIcon*) base;
	_vala_natural_width = (gint) (height / G_SQRT2);
	_vala_minimum_width = _vala_natural_width;
	if (minimum_width) {
		*minimum_width = _vala_minimum_width;
	}
	if (natural_width) {
		*natural_width = _vala_natural_width;
	}
}


static gboolean
page_icon_real_draw (GtkWidget* base,
                     cairo_t* c)
{
	PageIcon * self;
	gboolean result = FALSE;
	gint w = 0;
	gint h = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	cairo_text_extents_t extents = {0};
	const gchar* _tmp11_;
	cairo_text_extents_t _tmp12_ = {0};
	gint _tmp13_;
	cairo_text_extents_t _tmp14_;
	gdouble _tmp15_;
	gint _tmp16_;
	cairo_text_extents_t _tmp17_;
	gdouble _tmp18_;
	const gchar* _tmp19_;
	self = (PageIcon*) base;
	g_return_val_if_fail (c != NULL, FALSE);
	w = gtk_widget_get_allocated_width ((GtkWidget*) self);
	h = gtk_widget_get_allocated_height ((GtkWidget*) self);
	_tmp0_ = w;
	_tmp1_ = h;
	if ((_tmp0_ * G_SQRT2) > ((gdouble) _tmp1_)) {
		gint _tmp2_;
		_tmp2_ = h;
		w = (gint) round (_tmp2_ / G_SQRT2);
	} else {
		gint _tmp3_;
		_tmp3_ = w;
		h = (gint) round (_tmp3_ * G_SQRT2);
	}
	_tmp4_ = w;
	_tmp5_ = h;
	cairo_translate (c, (gdouble) ((gtk_widget_get_allocated_width ((GtkWidget*) self) - _tmp4_) / 2), (gdouble) ((gtk_widget_get_allocated_height ((GtkWidget*) self) - _tmp5_) / 2));
	_tmp6_ = w;
	_tmp7_ = h;
	cairo_rectangle (c, 0.5, 0.5, (gdouble) (_tmp6_ - 1), (gdouble) (_tmp7_ - 1));
	_tmp8_ = self->priv->r;
	_tmp9_ = self->priv->g;
	_tmp10_ = self->priv->b;
	cairo_set_source_rgb (c, _tmp8_, _tmp9_, _tmp10_);
	cairo_fill_preserve (c);
	cairo_set_line_width (c, 1.0);
	cairo_set_source_rgb (c, 0.0, 0.0, 0.0);
	cairo_stroke (c);
	_tmp11_ = self->priv->text;
	cairo_text_extents (c, _tmp11_, &_tmp12_);
	extents = _tmp12_;
	_tmp13_ = w;
	_tmp14_ = extents;
	_tmp15_ = _tmp14_.width;
	_tmp16_ = h;
	_tmp17_ = extents;
	_tmp18_ = _tmp17_.height;
	cairo_translate (c, ((_tmp13_ - _tmp15_) * 0.5) - 0.5, ((_tmp16_ + _tmp18_) * 0.5) - 0.5);
	_tmp19_ = self->priv->text;
	cairo_show_text (c, _tmp19_);
	result = TRUE;
	return result;
}


static void
page_icon_class_init (PageIconClass * klass)
{
	page_icon_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PageIconPrivate));
	((GtkWidgetClass *) klass)->get_preferred_width = (void (*) (GtkWidget *, gint*, gint*)) page_icon_real_get_preferred_width;
	((GtkWidgetClass *) klass)->get_preferred_height = (void (*) (GtkWidget *, gint*, gint*)) page_icon_real_get_preferred_height;
	((GtkWidgetClass *) klass)->get_preferred_height_for_width = (void (*) (GtkWidget *, gint, gint*, gint*)) page_icon_real_get_preferred_height_for_width;
	((GtkWidgetClass *) klass)->get_preferred_width_for_height = (void (*) (GtkWidget *, gint, gint*, gint*)) page_icon_real_get_preferred_width_for_height;
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget *, cairo_t*)) page_icon_real_draw;
	G_OBJECT_CLASS (klass)->finalize = page_icon_finalize;
}


static void
page_icon_instance_init (PageIcon * self)
{
	self->priv = PAGE_ICON_GET_PRIVATE (self);
}


static void
page_icon_finalize (GObject * obj)
{
	PageIcon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PAGE_ICON, PageIcon);
	_g_free0 (self->priv->text);
	G_OBJECT_CLASS (page_icon_parent_class)->finalize (obj);
}


GType
page_icon_get_type (void)
{
	static volatile gsize page_icon_type_id__volatile = 0;
	if (g_once_init_enter (&page_icon_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PageIconClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) page_icon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PageIcon), 0, (GInstanceInitFunc) page_icon_instance_init, NULL };
		GType page_icon_type_id;
		page_icon_type_id = g_type_register_static (gtk_drawing_area_get_type (), "PageIcon", &g_define_type_info, 0);
		g_once_init_leave (&page_icon_type_id__volatile, page_icon_type_id);
	}
	return page_icon_type_id__volatile;
}



